# MutableArithmetics.jl

[![Stable][docs-stable-img]][docs-stable-url]
[![Dev][docs-dev-img]][docs-dev-url]
[![Build Status][build-img]][build-url]
[![Codecov][codecov-img]][codecov-url]
[![deps][deps-img]][deps-url]
[![version][version-img]][version-url]
[![pkgeval][pkgeval-img]][pkgeval-url]
[![DOI](https://proceedings.juliacon.org/papers/10.21105/jcon.00093/status.svg)](https://doi.org/10.21105/jcon.00093)


**MutableArithmetics** (MA for short) is a [Julia](http://julialang.org) package
which allows:
 * for mutable types to implement mutable arithmetics
 * for algorithms that could exploit mutable arithmetics to exploit them while
   still being completely generic.

While in some cases, similar features have been included in packages
idiosyncratically, the goal of MutableArithmetics is to provide a generic
interface to allow anyone to make use of mutability when desired.

The package allows a type to declare itself mutable through the `MA.mutability`
trait. Then the user can use the `MA.operate!!` function to write generic code
that works for arbitrary type while exploiting mutability of the type
if possible. More precisely:
 * The `MA.operate!!(op::Function, x, args...)` redirects to `op(x, args...)`
   if `x` is not mutable or if the result of the operation cannot be stored in
   `x`. Otherwise, it redirects to `MA.operate!(op, x, args...)`.
 * `MA.operate!(op::Function, x, args...)` stores the result of the operation in
   `x`. It is a `MethodError` if `x` is not mutable or if the result of the
   operation cannot be stored in `x`.

So from a generic code perspective, `MA.operate!!` can be used when the value of
`x` is not used anywhere else. This allows the code to both work for mutable and
for non-mutable type.

When the type is known to be mutable, `MA.operate!` can be used to make sure the
operation is done in-place. If it is not possible, the `MethodError` allows one
to easily fix the issue while `MA.operate!!` would have silently fallen back to
the non-mutating function.

In conclusion, the distinction between `MA.operate!!` and `MA.operate!` covers
all use case while having an universal convention accross all operations.

## Implementations

The following types and packages implement the MutableArithmetics API:

 * `Base.BigInt` in `src/interfaces/BigInt.jl`.
 * `Base.BigFloat` in `src/interfaces/BigFloat.jl`.
 * `Base.Array` in `src/interfaces/LinearAlgebra.jl`.
 * [Polynomials.jl](https://github.com/JuliaMath/Polynomials.jl) uses MA for its
   `Polynomial` type
 * [MultivariatePolynomials](https://github.com/JuliaAlgebra/MultivariatePolynomials.jl)
   uses MA for its multivariate polynomials, as well as its two implementations
   in [DynamicPolynomials](https://github.com/JuliaAlgebra/DynamicPolynomials.jl)
   and [TypedPolynomials](https://github.com/JuliaAlgebra/TypedPolynomials.jl)
 * [JuMP](https://github.com/jump-dev/JuMP.jl) and
   [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl) use
   MA for the scalar and quadratic functions used to define an optimization
   program

In addition, the implementation of the following `Base` functionalities are
reimplemented using the MA API:
 * Matrix-matrix, matrix-vector and array-scalar multiplication including
   `SparseArrays.AbstractSparseArray`, `LinearAlgebra.Adjoint`,
   `LinearAlgebra.Transpose`, `LinearAlgebra.Symmetric`.
 * `Base.sum`, `LinearAlgebra.dot` and `LinearAlgebra.diagm`.

These methods are reimplemented in this package for several reasons:
* The implementation in `Base` does not exploit the mutability of the type
  (except for `sum(::Vector{BigInt})` which has a specialized method) and
  are hence much slower.
* Some implementations in `Base` assume the following for the types `S`, `T` used satisfy:
  - `typeof(zero(T)) == T`, `typeof(one(T)) == T`, `typeof(S + T) == promote_type(S, T)`
    or `typeof(S * T) == promote_type(S, T)` which is not true for
    instance if `T` is a polynomial variable or the decision variable of an
    optimization model.
  - The multiplication between elements of type `S` and `T` is commutative which
    is not true for matrices or non-commutative polynomial variables.

The trait defined in this package cannot make the methods for the functions
defined in Base to be dispatched to the implementations of this package.
For these to be used for a given type, it needs to inherit from `MA.AbstractMutable`.
Not that subtypes of `MA.AbstractMutable` are not necessarily mutable,
for instance, polynomial variables and the decision variable of an optimization
model are subtypes of `MA.AbstractMutable` but are not mutable.
The only purpose of this abstract type is to have `Base` methods to be dispatched
to the implementations of this package. See `src/dispatch.jl` for more details.

## Quick Example & Benchmark

```julia
using BenchmarkTools
using MutableArithmetics
const MA = MutableArithmetics

n = 200
A = rand(-10:10, n, n)
b = rand(-10:10, n)
c = rand(-10:10, n)

# MA.mul works for arbitrary types
MA.mul(A, b)

A2 = big.(A)
b2 = big.(b)
c2 = big.(c)
```

The default implementation `LinearAlgebra.generic_matvecmul!` does not exploit
the mutability of `BigInt` is quite slow and allocates a lot:
```julia
using LinearAlgebra
trial = @benchmark LinearAlgebra.mul!($c2, $A2, $b2)
display(trial)

# output

BenchmarkTools.Trial: 407 samples with 1 evaluation.
 Range (min … max):   5.268 ms … 161.929 ms  ┊ GC (min … max):  0.00% … 73.90%
 Time  (median):      5.900 ms               ┊ GC (median):     0.00%
 Time  (mean ± σ):   12.286 ms ±  21.539 ms  ┊ GC (mean ± σ):  29.47% ± 14.50%

  █▃
  ██▄▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▅█▆▇▅▅ ▆
  5.27 ms       Histogram: log(frequency) by time      80.6 ms <

 Memory estimate: 3.66 MiB, allocs estimate: 197732.
```

In `MA.operate!(::typeof(MA.add_mul), ::Vector, ::Matrix, ::Vector)`, we
exploit the mutability of `BigInt` through the MutableArithmetics API.
This provides a significant speedup and a drastic reduction of memory usage:
```julia
trial2 = @benchmark MA.add_mul!!($c2, $A2, $b2)
display(trial2)

# output

BenchmarkTools.Trial: 4878 samples with 1 evaluation.
 Range (min … max):  908.860 μs …   1.758 ms  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):       1.001 ms               ┊ GC (median):    0.00%
 Time  (mean ± σ):     1.021 ms ± 102.381 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  █▅
  ██▂▂▂▇▅▇▇▅▅▅▇▅▆▄▄▅▄▄▃▄▄▃▃▂▃▃▂▃▂▂▂▂▂▂▂▂▂▂▂▁▂▂▂▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁ ▂
  909 μs           Histogram: frequency by time         1.36 ms <

 Memory estimate: 48 bytes, allocs estimate: 3.
```

There is still 48 bytes that are allocated, where does this come from ?
`MA.operate!(::typeof(MA.add_mul), ::BigInt, ::BigInt, ::BigInt)`
allocates a temporary `BigInt` to hold the result of the multiplication.
This buffer is allocated only once for the whole matrix-vector multiplication
through the system of buffers of MutableArithmetics.
If may Matrix-Vector products need to be computed, the buffer can even be allocated
outside of the matrix-vector product as follows:
```julia
buffer = MA.buffer_for(MA.add_mul, typeof(c2), typeof(A2), typeof(b2))
trial3 = @benchmark MA.buffered_operate!!($buffer, MA.add_mul, $c2, $A2, $b2)
display(trial3)

# output

BenchmarkTools.Trial: 4910 samples with 1 evaluation.
 Range (min … max):  908.414 μs …   1.774 ms  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     990.964 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):     1.014 ms ± 103.364 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  █▂
  ██▃▂▂▄▄▅▆▃▄▄▅▄▄▃▃▄▃▃▃▃▃▃▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁ ▂
  908 μs           Histogram: frequency by time         1.35 ms <

 Memory estimate: 0 bytes, allocs estimate: 0.
```
Note that there are now 0 allocations.

## Related projects

For related projects, see:

 * https://github.com/JuliaFolds/BangBang.jl
 * https://github.com/tkluck/InPlace.jl

## Citing MutableArithmetics

If you find MutableArithmetics useful in your work, we kindly request that you cite the
following [paper](https://doi.org/10.21105/jcon.00093):
```bibtex
@article{Legat2024,
  doi = {10.21105/jcon.00093},
  url = {https://doi.org/10.21105/jcon.00093},
  year = {2024},
  publisher = {The Open Journal},
  volume = {6},
  number = {58},
  pages = {93},
  author = {Benoît Legat},
  title = {MutableArithmetics: An API for mutable operations},
  journal = {Proceedings of the JuliaCon Conferences}
}
```

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-stable-url]: https://jump.dev/MutableArithmetics.jl/stable
[docs-dev-url]: https://jump.dev/MutableArithmetics.jl/dev

[build-img]: https://github.com/jump-dev/MutableArithmetics.jl/actions/workflows/ci.yml/badge.svg?branch=master
[build-url]: https://github.com/jump-dev/MutableArithmetics.jl/actions?query=workflow%3ACI
[codecov-img]: https://codecov.io/gh/jump-dev/MutableArithmetics.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/jump-dev/MutableArithmetics.jl

[deps-img]: https://juliahub.com/docs/MutableArithmetics/deps.svg
[deps-url]: https://juliahub.com/ui/Packages/MutableArithmetics/EoEec?t=2
[version-img]: https://juliahub.com/docs/MutableArithmetics/version.svg
[version-url]: https://juliahub.com/ui/Packages/MutableArithmetics/EoEec
[pkgeval-img]: https://juliahub.com/docs/MutableArithmetics/pkgeval.svg
[pkgeval-url]: https://juliahub.com/ui/Packages/MutableArithmetics/EoEec

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function iszero_test(x)
    x_copy = x

    @test iszero(x - x)
    @test iszero(MA.@rewrite(x - x))
    @test MA.iszero!!(x - x)
    @test MA.iszero!!(MA.@rewrite(x - x))

    @test iszero(0 * x)
    @test iszero(MA.@rewrite(0 * x))
    @test MA.iszero!!(0 * x)
    @test MA.iszero!!(MA.@rewrite(0 * x))

    @test iszero(x - 2x + x)
    @test iszero(MA.@rewrite(x - 2x + x))
    @test MA.iszero!!(x - 2x + x)
    @test MA.iszero!!(MA.@rewrite(x - 2x + x))

    @test MA.isequal_canonical(x_copy, x)
end

function empty_sum_test(x)
    @test MA.isequal_canonical(
        MA.@rewrite(x + sum(1 for i in 1:0) * sum(x for i in 1:0)),
        x,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(x + sum(x for i in 1:0) * sum(1 for i in 1:0)),
        x,
    )
    @test MA.isequal_canonical(MA.@rewrite(x + sum(1 for i in 1:0) * 1^2), x)
    @test MA.isequal_canonical(MA.@rewrite(x + 1^2 * sum(1 for i in 1:0)), x)
    # `1^2` is considered as a complex expression by `@rewrite`.
    @test MA.isequal_canonical(
        MA.@rewrite(x + 1^2 * sum(1 for i in 1:0) * sum(x for i in 1:0)),
        x,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(x + sum(1 for i in 1:0) * 1^2 * sum(x for i in 1:0)),
        x,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(x + 1^2 * sum(1 for i in 1:0) * sum(x for i in 1:0) * 1^2),
        x,
    )
    # Fails because the sum is not rewritten because `*` is not rewritten when `vectorized` is `true`.
    #@test MA.isequal_canonical(MA.@rewrite(x .+ sum(1 for i in 1:0) * sum(x for i in 1:0)), x)
    #@test MA.isequal_canonical(MA.@rewrite(x .+ 1^2 * sum(1 for i in 1:0) * sum(x for i in 1:0) * 1^2), x)
    @test MA.isequal_canonical(MA.@rewrite(x .+ sum(1 for i in 1:0)), x)
    @test_broken MA.isequal_canonical(
        MA.@rewrite(x .+ sum(1 for i in 1:0) * 1^2),
        x + 0,
    )
    @test MA.isequal_canonical(MA.@rewrite(sum(1 for i in 1:0) .+ x), x)
    @test MA.isequal_canonical(MA.@rewrite(sum(1 for i in 1:0) * 1^2 .+ x), x)
    @test MA.isequal_canonical(MA.@rewrite(x .- sum(1 for i in 1:0)), x)
    @test_broken MA.isequal_canonical(
        MA.@rewrite(x .- sum(1 for i in 1:0) * 1^2),
        x,
    )
    @test MA.isequal_canonical(MA.@rewrite(sum(1 for i in 1:0) .- x), -x)
    @test MA.isequal_canonical(MA.@rewrite(sum(1 for i in 1:0) * 1^2 .- x), -x)
end

function cube_test(x)
    @test_rewrite x^3
    @test_rewrite (x + 1)^3
    @test_rewrite x^2 * x
    @test_rewrite (x + 1)^2 * x
    @test_rewrite x^2 * (x + 1)
    @test_rewrite (x + 1)^2 * (x + 1)
    @test_rewrite x * x^2
    @test_rewrite (x + 1) * x^2
    @test_rewrite x * (x + 1)^2
    @test_rewrite (x + 1) * (x + 1)^2
    @test_rewrite x * x * x
    @test_rewrite (x + 1) * x * x
    @test_rewrite x * (x + 1) * x
    @test_rewrite x * x * (x + 1)
end

function mul_scalar_array_test(x)
    for A in [[1, 2, 3], [1 2; 3 4]]
        @test_rewrite x * A
        @test_rewrite A * x
    end
end

# See JuMP issue #656
function scalar_in_any_test(x)
    ints = [i for i in 1:2]
    anys = Array{Any}(undef, 2)
    anys[1] = 10
    anys[2] = 20 + x
    @test MA.isequal_canonical(dot(ints, anys), 10 + 40 + 2x)
end

function scalar_uniform_scaling_test(x)
    add_test(x, I)
    @test_rewrite (x + 1) + I
    @test_rewrite (x - 1) - I
    @test_rewrite I + (x + 1)
    @test_rewrite I - (x - 1)
    @test_rewrite I * x
    @test_rewrite I * (x + 1)
    @test_rewrite (x + 1) * I
end

function convert_test(x)
    y = MA.operate(convert, typeof(x), x)
    MA.operate!(+, y, 1)
    @test MA.isequal_canonical(y, x + 1)
end

const scalar_tests = Dict(
    "mul_scalar_array" => mul_scalar_array_test,
    "empty_sum" => empty_sum_test,
    "cube" => cube_test,
    "iszero" => iszero_test,
    "scalar_in_any" => scalar_in_any_test,
    "scalar_uniform_scaling" => scalar_uniform_scaling_test,
)

@test_suite scalar

struct Term{T}
    coef::T
    sym::SymbolicVariable
end
struct Sum{T}
    terms::Vector{Term{T}}
end
Base.:+(s::Sum, t::Term) = Sum(push!(copy(s.terms), t))
Base.zero(::Type{Term{T}}) where {T} = Sum(Term{T}[])

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

"""
    add_to!!(a, b, c)

Return the sum of `b` and `c`, possibly modifying `a`.
"""
function add_to!!(output, args::Vararg{Any,N}) where {N}
    return operate_to!!(output, +, args...)
end

"""
    add!!(a, b, ...)

Return the sum of `a`, `b`, ..., possibly modifying `a`.
"""
add!!(args::Vararg{Any,N}) where {N} = operate!!(+, args...)

"""
    sub_to!!(output, a, b)

Return the `a - b`, possibly modifying `output`.
"""
sub_to!!(output, a, b) = operate_to!!(output, -, a, b)

"""
    sub!!(a, b)

Return `a - b`, possibly modifying `a`.
"""
sub!!(a, b) = operate!!(-, a, b)

"""
    mul_to!!(a, b, c, ...)

Return the product of `b`, `c`, ..., possibly modifying `a`.
"""
function mul_to!!(output, args::Vararg{Any,N}) where {N}
    return operate_to!!(output, *, args...)
end

"""
    mul!!(a, b, ...)

Return the product of `a`, `b`, ..., possibly modifying `a`.
"""
mul!!(args::Vararg{Any,N}) where {N} = operate!!(*, args...)

"""
    mul(a, b, ...)

Shortcut for `operate(*, a, b, ...)`, see [`operate`](@ref).
"""
mul(args::Vararg{Any,N}) where {N} = operate(*, args...)

"""
    div_to!!(output, a, b)

Return `div(a, b)` possibly modifying `output`.
"""
function div_to!!(output, a, b)
    return operate_to!!(output, div, a, b)
end

"""
    div!!(a, b)

Return `div(a, b)` possibly modifying `a`.
"""
div!!(a, b) = operate!!(div, a, b)

"""
    gcd_to!!(a, b, c, ...)

Return the `gcd` of `b`, `c`, ..., possibly modifying `a`.
"""
function gcd_to!!(output, args::Vararg{Any,N}) where {N}
    return operate_to!!(output, gcd, args...)
end

"""
    gcd!!(a, b, ...)

Return the `gcd` of `a`, `b`, ..., possibly modifying `a`.
"""
gcd!!(args::Vararg{Any,N}) where {N} = operate!!(gcd, args...)

"""
    lcm_to!!(a, b, c, ...)

Return the `lcm` of `b`, `c`, ..., possibly modifying `a`.
"""
function lcm_to!!(output, args::Vararg{Any,N}) where {N}
    return operate_to!!(output, lcm, args...)
end

"""
    lcm!!(a, b, ...)

Return the `lcm` of `a`, `b`, ..., possibly modifying `a`.
"""
lcm!!(args::Vararg{Any,N}) where {N} = operate!!(lcm, args...)

"""
    add_mul_to!!(output, args...)

Return `add_mul(args...)`, possibly modifying `output`.
"""
function add_mul_to!!(output, args::Vararg{Any,N}) where {N}
    return operate_to!!(output, add_mul, args...)
end

"""
    add_mul!!(args...)

Return `add_mul(args...)`, possibly modifying `args[1]`.
"""
add_mul!!(args::Vararg{Any,N}) where {N} = operate!!(add_mul, args...)

"""
    add_mul_buf_to!!(buffer, output, args...)

Return `add_mul(args...)`, possibly modifying `output` and `buffer`.
"""
function add_mul_buf_to!!(buffer, output, args::Vararg{Any,N}) where {N}
    return buffered_operate_to!!(buffer, output, add_mul, args...)
end

"""
    add_mul_buf!!(buffer, args...)

Return `add_mul(args...)`, possibly modifying `args[1]` and `buffer`.
"""
function add_mul_buf!!(buffer, args::Vararg{Any,N}) where {N}
    return buffered_operate!!(buffer, add_mul, args...)
end

"""
    sub_mul_to!!(output, args...)

Return `sub_mul(args...)`, possibly modifying `output`.
"""
function sub_mul_to!!(output, args::Vararg{Any,N}) where {N}
    return operate_to!!(output, sub_mul, args...)
end

"""
    sub_mul!!(args...)

Return `sub_mul(args...)`, possibly modifying `args[1]`.
"""
sub_mul!!(args::Vararg{Any,N}) where {N} = operate!!(sub_mul, args...)

"""
    sub_mul_buf_to!!(buffer, output, args...)

Return `sub_mul(args...)`, possibly modifying `output` and `buffer`.
"""
function sub_mul_buf_to!!(buffer, output, args::Vararg{Any,N}) where {N}
    return buffered_operate_to!!(buffer, output, sub_mul, args...)
end

"""
    sub_mul_buf!!(buffer, args...)

Return `sub_mul(args...)`, possibly modifying `args[1]` and `buffer`.
"""
function sub_mul_buf!!(buffer, args::Vararg{Any,N}) where {N}
    return buffered_operate!!(buffer, sub_mul, args...)
end

"""
    zero!!(a)

Return `zero(a)`, possibly modifying `a`.
"""
zero!!(a) = operate!!(zero, a)

"""
    one!!(a)

Return `one(a)`, possibly modifying `a`.
"""
one!!(a) = operate!!(one, a)

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function test_fma_output_values(x::F, y::F, z::F) where {F<:BigFloat}
    two_roundings_reference = x * y + z
    one_rounding_reference = fma(x, y, z)
    @test one_rounding_reference != two_roundings_reference

    @testset "fma $op output values" for op in (MA.operate!, MA.operate!!)
        (a, b, c) = map(MA.copy_if_mutable, (x, y, z))
        @inferred op(fma, a, b, c)
        @test one_rounding_reference == a
        @test y == b
        @test z == c
    end

    @testset "fma $op output values" for op in (MA.operate_to!, MA.operate_to!!)
        (a, b, c) = map(MA.copy_if_mutable, (x, y, z))
        out = F()
        @inferred op(out, fma, a, b, c)
        @test one_rounding_reference == out
        @test x == a
        @test y == b
        @test z == c
    end

    return nothing
end

function test_fma_output_values(x::F, y::F, z::F) where {F<:Float64}
    return test_fma_output_values(map(BigFloat, (x, y, z))...)
end

function test_fma_output_values_func(x::F, y::F, z::F) where {F<:Float64}
    return let x = x, y = y, z = z
        () -> test_fma_output_values(x, y, z)
    end
end

@testset "fma output values: $exp_x $exp_y $sign_x $sign_y" for exp_x in (-3):3,
    exp_y in (-3):3,
    sign_x in (-1, 1),
    sign_y in (-1, 1)

    # Assuming a two-bit mantissa
    significand_length = 2

    sign_z = -sign_x * sign_y
    exp_z = exp_x + exp_y

    base = 2.0
    bit_0 = 2.0^0
    bit_1 = 2.0^-1

    x = sign_x * base^exp_x * (bit_0 + bit_1)
    y = sign_y * base^exp_y * (bit_0 + bit_1)
    z = sign_z * base^exp_z * (bit_0 + bit_1)

    setprecision(
        test_fma_output_values_func(x, y, z),
        BigFloat,
        significand_length,
    )
end

@testset "muladd operate_to!! type inferred" begin
    m1 = BigFloat(-1.0)
    out = BigFloat()
    @test iszero(@inferred MA.operate_to!!(out, Base.muladd, m1, m1, m1))
end

@testset "muladd operate!! type inferred" begin
    x = BigFloat(-1.0)
    y = BigFloat(-1.0)
    z = BigFloat(-1.0)
    @test iszero(@inferred MA.operate!!(Base.muladd, x, y, z))
end

@testset "fma $op doesn't allocate" for op in (MA.operate_to!, MA.operate_to!!)
    alloc_test(let op = op, o = big"1.3", x = big"1.3"
        () -> op(o, Base.fma, x, x, x)
    end, 0)
end

@testset "fma $op doesn't allocate" for op in (MA.operate!, MA.operate!!)
    alloc_test(let op = op, x = big"1.3", y = big"1.3", z = big"1.3"
        () -> op(Base.fma, x, y, z)
    end, 0)
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function matrix_vector_division_test(x)
    if size(x) == (3, 3)
        A = [
            2 1 0
            1 2 1
            0 1 2
        ]
        @test_rewrite A * x / 2
    end
end

function _xAx_test(x::AbstractVector, A::AbstractMatrix)
    for t in [transpose, adjoint]
        @test_rewrite(t(x) * A)
        # Complex expression
        @test_rewrite(t(x) * ones(Int, size(A)...))
        @test_rewrite(t(x) * A * x)
        # Complex expression
        @test_rewrite(t(x) * ones(Int, size(A)...) * x)
        @test_rewrite reshape(x, (1, length(x))) * A * x .- 1
        @test_rewrite t(x) * A * x .- 1
        @test_rewrite t(x) * A * x - 1
        @test_rewrite t(x) * x + t(x) * A * x
        @test_rewrite t(x) * x - t(x) * A * x
        @test MA.promote_operation(*, typeof(t(x)), typeof(A), typeof(x)) ==
              typeof(t(x) * A * x)
        @test MA.promote_operation(*, typeof(t(x)), typeof(x)) ==
              typeof(t(x) * x)
        @test_rewrite t(x) * x + 2 * t(x) * A * x
        @test_rewrite t(x) * x - 2 * t(x) * A * x
        @test_rewrite t(x) * A * x + 2 * t(x) * x
        @test_rewrite t(x) * A * x - 2 * t(x) * x
        @test MA.promote_operation(
            *,
            Int,
            typeof(t(x)),
            typeof(A),
            typeof(x),
        ) == typeof(2 * t(x) * A * x)
        @test MA.promote_operation(*, Int, typeof(t(x)), typeof(x)) ==
              typeof(2 * t(x) * x)
    end
end
function _xABx_test(x::AbstractVector, A::AbstractMatrix, B::AbstractMatrix)
    for t in [transpose, adjoint]
        @test_rewrite t(t(x) * A) + 2B * x
        @test_rewrite t(t(x) * A) + 2B * x .- 1
        @test_rewrite t(t(x) * A) + 2B * x .- [length(x):-1:1;]
        @test_rewrite t(t(x) * A) + 2B * x - [length(x):-1:1;]
    end
end

function _matrix_vector_test(x::AbstractVector, A::AbstractMatrix)
    _xAx_test(x, A)
    B = sparse(A)
    _xAx_test(x, B)

    @test MA.isequal_canonical(A * x, B * x)
    @test MA.isequal_canonical(A * x, MA.@rewrite(B * x))
    @test MA.isequal_canonical(MA.@rewrite(A * x), MA.@rewrite(B * x))
    @test MA.isequal_canonical(x' * A, x' * B)
    @test MA.isequal_canonical(x' * A, MA.@rewrite(x' * B))
    @test MA.isequal_canonical(MA.@rewrite(x' * A), MA.@rewrite(x' * B))
    @test MA.isequal_canonical(x'A * x, x' * B * x)
    @test MA.isequal_canonical(x' * A * x, MA.@rewrite(x' * B * x))
    @test MA.isequal_canonical(MA.@rewrite(x' * A * x), MA.@rewrite(x' * B * x))

    _xABx_test(x, A, A)
    _xABx_test(x, A, B)
    _xABx_test(x, B, A)
    return _xABx_test(x, B, B)
end

function matrix_vector_test(x)
    add_test(x, x)
    if size(x) != (3,)
        return
    end
    A = [
        2 1 0
        1 2 1
        0 1 2
    ]

    @test_rewrite x .+ A * x
    @test_rewrite A * x .+ A * x
    @test_rewrite x .- A * x
    @test_rewrite A * x .- A * x
    @test_rewrite A .+ (A + A)^2
    @test_rewrite A .- (A + A)^2
    @test_rewrite A * x .+ (A + A)^2 * x
    @test_rewrite A * x .- (A + A)^2 * x
    @test_rewrite A * x .- (A + A)^2 * x

    @test MA.isequal_canonical(-x, [-x[1], -x[2], -x[3]])
    xAx =
        2x[1] * x[1] + 2x[1] * x[2] + 2x[2] * x[2] + 2x[2] * x[3] + 2x[3] * x[3]
    @test MA.isequal_canonical(x' * A * x, xAx)
    y = A * x
    @test MA.isequal_canonical(x' * y, xAx)
    @test MA.isequal_canonical(
        y,
        [
            2x[1] + x[2]
            2x[2] + x[1] + x[3]
            x[2] + 2x[3]
        ],
    )
    @test MA.isequal_canonical(
        -y,
        [
            -2x[1] - x[2]
            -x[1] - 2x[2] - x[3]
            -x[2] - 2x[3]
        ],
    )
    @test MA.isequal_canonical(
        x' * A,
        [
            2x[1] + x[2]
            x[1] + 2x[2] + x[3]
            x[2] + 2x[3]
        ]',
    )

    @test MA.isequal_canonical(
        y .+ 1,
        [
            2x[1] + x[2] + 1
            x[1] + 2x[2] + x[3] + 1
            x[2] + 2x[3] + 1
        ],
    )
    @test MA.isequal_canonical(
        y .- 1,
        [
            2x[1] + x[2] - 1
            x[1] + 2x[2] + x[3] - 1
            x[2] + 2x[3] - 1
        ],
    )
    @test MA.isequal_canonical(
        y .+ 2ones(Int, 3),
        [
            2x[1] + x[2] + 2
            x[1] + 2x[2] + x[3] + 2
            x[2] + 2x[3] + 2
        ],
    )
    @test MA.isequal_canonical(
        y .- 2ones(Int, 3),
        [
            2x[1] + x[2] - 2
            x[1] + 2x[2] + x[3] - 2
            x[2] + 2x[3] - 2
        ],
    )
    @test MA.isequal_canonical(
        2ones(Int, 3) .+ y,
        [
            2x[1] + x[2] + 2
            x[1] + 2x[2] + x[3] + 2
            x[2] + 2x[3] + 2
        ],
    )
    @test MA.isequal_canonical(
        2ones(Int, 3) .- y,
        [
            -2x[1] - x[2] + 2
            -x[1] - 2x[2] - x[3] + 2
            -x[2] - 2x[3] + 2
        ],
    )
    @test MA.isequal_canonical(
        y .+ x,
        [
            3x[1] + x[2]
            x[1] + 3x[2] + x[3]
            x[2] + 3x[3]
        ],
    )
    @test MA.isequal_canonical(
        x .+ y,
        [
            3x[1] + x[2]
            x[1] + 3x[2] + x[3]
            x[2] + 3x[3]
        ],
    )
    @test MA.isequal_canonical(
        2y .+ 2x,
        [
            6x[1] + 2x[2]
            2x[1] + 6x[2] + 2x[3]
            2x[2] + 6x[3]
        ],
    )
    @test MA.isequal_canonical(
        y .- x,
        [
            x[1] + x[2]
            x[1] + x[2] + x[3]
            x[2] + x[3]
        ],
    )
    @test MA.isequal_canonical(
        x .- y,
        [
            -x[1] - x[2]
            -x[1] - x[2] - x[3]
            -x[2] - x[3]
        ],
    )
    @test MA.isequal_canonical(
        y .+ x[:],
        [
            3x[1] + x[2]
            x[1] + 3x[2] + x[3]
            x[2] + 3x[3]
        ],
    )
    @test MA.isequal_canonical(
        x[:] .+ y,
        [
            3x[1] + x[2]
            x[1] + 3x[2] + x[3]
            x[2] + 3x[3]
        ],
    )

    _matrix_vector_test(x, A)

    A = [
        1 2 3
        0 4 5
        6 0 7
    ]
    return _matrix_vector_test(x, A)
end

_constant(x) = reshape(collect(1:length(x)), size(x)...)

function non_array_test(x, x2)
    # This is needed to compare arrays that have nonstandard indexing
    function elements_equal(
        A::AbstractArray{T,N},
        B::AbstractArray{T,N},
    ) where {T,N}
        return all(MA.isequal_canonical(a, b) for (a, b) in zip(A, B))
    end

    @test elements_equal(+x, +x2)
    @test elements_equal(-x, -x2)
    @test elements_equal(x .+ first(x), x2 .+ first(x2))
    @test elements_equal(x .- first(x), x2 .- first(x2))
    @test elements_equal(first(x) .- x, first(x2) .- x2)
    @test elements_equal(first(x) .+ x, first(x2) .+ x2)
    @test elements_equal(2 .* x, 2 .* x2)
    @test elements_equal(first(x) .+ x2, first(x2) .+ x)
    @test MA.isequal_canonical(sum(x), sum(x2))
    if !MA._one_indexed(x2)
        @test_throws DimensionMismatch x + x2
    end
    if x isa AbstractVector
        # `diagm` only define with `Pair` in Julia v1.0 and v1.1
        @testset "diagm" begin
            if !MA._one_indexed(x2) && eltype(x2) <: MA.AbstractMutable
                @test_throws AssertionError diagm(x2)
            else
                @test MA.isequal_canonical(diagm(0 => x), diagm(0 => x2))
                @test MA.isequal_canonical(diagm(x), diagm(x2))
            end
        end
    end
end

function non_array_test(x)
    non_array_test(x, x)
    if x isa AbstractVector
        non_array_test(x, view(x, :))
    end
    if x isa AbstractVector || x isa AbstractMatrix
        non_array_test(x, sparse(x))
    end
end

function dot_test(x)
    @test_rewrite dot(first(x), first(x))
    @test_rewrite dot(2, first(x))
    @test_rewrite dot(first(x), 2)

    A = _constant(x)
    @test_rewrite dot(A, x)
    @test_rewrite dot(x, A)

    y = repeat(x, outer = (one.(size(x))..., size(x, 1)))
    @test_rewrite dot(x, _constant(x)) - dot(y, _constant(y))
end

function sum_test(matrix)
    @test_rewrite sum(matrix)
    if matrix isa AbstractMatrix
        @test_rewrite sum([
            2matrix[i, j] for i in axes(matrix, 1), j in axes(matrix, 2)
        ])
        @test_rewrite sum(
            2matrix[i, j] for i in axes(matrix, 1), j in axes(matrix, 2)
        )
    end
end

function sum_multiplication_test(matrix)
    if matrix isa AbstractMatrix
        @test_rewrite sum([
            2matrix[i, j]^2 for i in axes(matrix, 1), j in axes(matrix, 2)
        ])
        @test_rewrite sum(
            2matrix[i, j]^2 for i in axes(matrix, 1), j in axes(matrix, 2)
        )
    end
end

function _is_supported(op::Function, Ts::Type...)
    try
        op(zero.(Ts)...)
        true
    catch
        false
    end
end

function transpose_test(x)
    if x isa Vector
        y = reshape(x, 1, length(x))
        @test MA.isequal_canonical(x', y)
        @test MA.isequal_canonical(copy(transpose(x)), y)
    end
    # If the element type does not support multiplication, e.g.
    # JuMP or MOI quadratic functions, then we should skip these tests.
    if x isa AbstractMatrix && _is_supported(*, eltype(x), eltype(x))
        y = [x[i, j] for j in axes(x, 2), i in axes(x, 1)]
        @test MA.isequal_canonical(x', y)
        @test MA.isequal_canonical(copy(transpose(x)), y)
        if size(x, 1) == size(x, 2)
            yy = y * y
            @test MA.isequal_canonical(x' * x', yy)
            @test MA.isequal_canonical(transpose(x) * transpose(x), yy)
            z = _constant(x)
            zt = copy(z')
            @test MA.isequal_canonical(adjoint(x) * adjoint(z), y * zt)
            @test MA.isequal_canonical(transpose(x) * transpose(z), y * zt)
            @test MA.isequal_canonical(adjoint(z) * adjoint(x), zt * y)
            @test MA.isequal_canonical(transpose(z) * transpose(x), zt * y)
        end
    end
    if x isa AbstractVector || x isa AbstractMatrix
        @test_rewrite(x')
        @test_rewrite(transpose(x))
        @test (x')' == x
        @test transpose(transpose(x)) == x
    end
end

_matrix(x::Matrix) = x
_matrix(x::AbstractMatrix) = Matrix(x)
function _matrix_equal(x::AbstractMatrix, y::AbstractMatrix)
    return MA.isequal_canonical(_matrix(x), _matrix(y))
end

function _broadcast_test(x, A)
    B = sparse(A)
    y = SparseMatrixCSC(
        size(x)...,
        copy(B.colptr),
        copy(B.rowval),
        collect(vec(x)),
    )

    # `SparseMatrixCSC .+ Array` give `SparseMatrixCSC` so we cast it with `Matrix`
    # before comparing.
    @test _matrix_equal(A .+ x, B .+ x)
    @test _matrix_equal(A .+ x, A .+ y)
    @test _matrix_equal(A .+ y, B .+ y)
    @test _matrix_equal(x .+ A, x .+ B)
    @test _matrix_equal(x .+ A, y .+ A)
    @test _matrix_equal(y .+ A, y .+ B)

    @test _matrix_equal(A .- x, B .- x)
    @test _matrix_equal(A .- x, A .- y)
    @test _matrix_equal(A .- y, B .- y)
    @test _matrix_equal(x .- A, x .- B)
    @test _matrix_equal(x .- A, y .- A)
    @test _matrix_equal(y .- A, y .- B)
end
function broadcast_test(x)
    if !(x isa AbstractMatrix)
        return
    end
    A = reshape(1:length(x), size(x)...)
    if size(x) == (2, 2)
        @test MA.isequal_canonical(
            A .+ x,
            [
                1+x[1, 1] 3+x[1, 2]
                2+x[2, 1] 4+x[2, 2]
            ],
        )
        @test MA.isequal_canonical(
            x .+ A,
            [
                1+x[1, 1] 3+x[1, 2]
                2+x[2, 1] 4+x[2, 2]
            ],
        )
        @test MA.isequal_canonical(
            x .+ x,
            [2x[1, 1] 2x[1, 2]; 2x[2, 1] 2x[2, 2]],
        )

        @test MA.isequal_canonical(
            A .- x,
            [
                1-x[1, 1] 3-x[1, 2]
                2-x[2, 1] 4-x[2, 2]
            ],
        )
        @test MA.isequal_canonical(
            x .- x,
            [zero(typeof(x[1] - x[1])) for _1 in 1:2, _2 in 1:2],
        )
        @test MA.isequal_canonical(
            x .- A,
            [
                -1+x[1, 1] -3+x[1, 2]
                -2+x[2, 1] -4+x[2, 2]
            ],
        )
    end
    return _broadcast_test(x, A)
end

function _broadcast_multiplication_test(x, A)
    B = sparse(A)
    y = SparseMatrixCSC(
        size(x)...,
        copy(B.colptr),
        copy(B.rowval),
        collect(vec(x)),
    )

    @test _matrix_equal(A .* x, B .* x)
    @test _matrix_equal(A .* x, A .* y)
    @test _matrix_equal(A .* y, B .* y)
    @test _matrix_equal(x .* A, x .* B)
    @test _matrix_equal(x .* A, y .* A)
    @test _matrix_equal(y .* A, y .* B)
end

function broadcast_multiplication_test(x)
    if !(x isa AbstractMatrix)
        return
    end
    A = reshape(1:length(x), size(x)...)
    if size(x) == (2, 2)
        @test MA.isequal_canonical(
            A .* x,
            [
                1*x[1, 1] 3*x[1, 2]
                2*x[2, 1] 4*x[2, 2]
            ],
        )
        @test MA.isequal_canonical(
            x .* A,
            [
                1*x[1, 1] 3*x[1, 2]
                2*x[2, 1] 4*x[2, 2]
            ],
        )
        @test MA.isequal_canonical(
            x .* x,
            [x[1, 1]^2 x[1, 2]^2; x[2, 1]^2 x[2, 2]^2],
        )

        # TODO: Refactor to avoid calling the internal JuMP function
        # `_densify_with_jump_eltype`.
        #z = JuMP._densify_with_jump_eltype((2 .* y) ./ 3)
        #@test MA.isequal_canonical((2 .* x) ./ 3, z)
        #z = JuMP._densify_with_jump_eltype(2 * (y ./ 3))
        #@test MA.isequal_canonical(2 .* (x ./ 3), z)
        #z = JuMP._densify_with_jump_eltype((x[1,1],) .* B)
        #@test MA.isequal_canonical((x[1,1],) .* A, z)
    end
    return _broadcast_multiplication_test(x, A)
end

function _broadcast_division_test(x, A)
    B = sparse(A)
    y = SparseMatrixCSC(
        size(x)...,
        copy(B.colptr),
        copy(B.rowval),
        collect(vec(x)),
    )

    @test _matrix_equal(x ./ A, x ./ B)
    @test _matrix_equal(x ./ A, y ./ A)
end
function broadcast_division_test(x)
    if !(x isa AbstractMatrix)
        return
    end
    A = reshape(1:length(x), size(x)...)
    if size(x) == (2, 2)
        @test MA.isequal_canonical(
            x ./ A,
            [
                x[1, 1]/1 x[1, 2]/3
                x[2, 1]/2 x[2, 2]/4
            ],
        )
    end
    return _broadcast_division_test(x, A)
end

function symmetric_unary_test(x)
    if x isa AbstractMatrix && size(x, 1) == size(x, 2)
        unary_test(LinearAlgebra.Symmetric(x))
    end
end

function symmetric_add_test(x)
    if x isa AbstractMatrix && size(x, 1) == size(x, 2)
        y = LinearAlgebra.Symmetric(x)
        add_test(y, y)
        add_test(x, y)
    end
end

function matrix_uniform_scaling_test(x)
    if !(x isa AbstractMatrix && size(x, 1) == size(x, 2))
        return
    end
    add_test(x, I)
    @test_rewrite (x .+ 1) + I
    @test_rewrite (x .- 1) - I
    @test_rewrite I + (x .+ 1)
    @test_rewrite I - (x .- 1)
    @test_rewrite I * x
    @test_rewrite I * (x .+ 1)
    @test_rewrite (x .+ 1) * I
    @test_rewrite (x .+ 1) + I * I
    @test_rewrite (x .+ 1) + 2 * I
    @test_rewrite (x .+ 1) + I * 2
    @test_rewrite I + 2I * x
    @test_rewrite x + 2I * x
end

function symmetric_matrix_uniform_scaling_test(x)
    if x isa AbstractMatrix && size(x, 1) == size(x, 2)
        matrix_uniform_scaling_test(LinearAlgebra.Symmetric(x))
    end
end

function triangular_test(x)
    if !(x isa AbstractMatrix && size(x, 1) == size(x, 2))
        return
    end
    n = LinearAlgebra.checksquare(x)
    ut = LinearAlgebra.UpperTriangular(x)
    add_test(ut, ut)
    y = Matrix(ut)
    for i in 1:n
        for j in 1:(i-1)
            @test iszero(y[i, j])
            @test MA.iszero!!(y[i, j])
        end
    end
    lt = LinearAlgebra.LowerTriangular(x)
    add_test(lt, lt)
    z = Matrix(lt)
    for j in 1:n
        for i in 1:(j-1)
            @test iszero(z[i, j])
            @test MA.iszero!!(z[i, j])
        end
    end
    return
end

function diagonal_test(x)
    if !(x isa AbstractVector && MA._one_indexed(x))
        return
    end
    d = LinearAlgebra.Diagonal(x)
    add_test(d, d)
    y = Matrix(d)
    t = LinearAlgebra.Tridiagonal(x[2:end], x, x[2:end])
    add_test(t, t)
    z = Matrix(t)
    for i in eachindex(x)
        @test MA.isequal_canonical(y[i, i], convert(eltype(y), x[i]))
        @test MA.isequal_canonical(z[i, i], convert(eltype(z), x[i]))
    end
    n = length(x)
    for j in 1:n
        for i in 1:(j-1)
            @test iszero(y[i, j])
            @test MA.iszero!!(y[i, j])
            @test iszero(y[j, i])
            @test MA.iszero!!(y[j, i])
            if abs(i - j) > 1
                @test iszero(z[i, j])
                @test MA.iszero!!(z[i, j])
                @test iszero(z[j, i])
                @test MA.iszero!!(z[j, i])
            end
        end
    end
end

const array_tests = Dict(
    "matrix_vector_division" => matrix_vector_division_test,
    "non_array" => non_array_test,
    "matrix_vector" => matrix_vector_test,
    "dot" => dot_test,
    "sum" => sum_test,
    "sum_multiplication" => sum_multiplication_test,
    "transpose" => transpose_test,
    "broadcast" => broadcast_test,
    "broadcast_multiplication" => broadcast_multiplication_test,
    "broadcast_division" => broadcast_division_test,
    "unary" => unary_test,
    "symmetric_unary" => symmetric_unary_test,
    "symmetric_add" => symmetric_add_test,
    "matrix_uniform_scaling" => matrix_uniform_scaling_test,
    "symmetric_matrix_uniform_scaling" =>
        symmetric_matrix_uniform_scaling_test,
    "triangular" => triangular_test,
    "diagonal" => diagonal_test,
)

@test_suite array

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

include("dummy.jl")

# Allocating size for allocating a `BigInt`. Half size on 32-bit.
const BIGINT_ALLOC = @static if VERSION >= v"1.12-beta1"
    Sys.WORD_SIZE == 64 ? 72 : 36
elseif VERSION >= v"1.11"
    Sys.WORD_SIZE == 64 ? 56 : 28
else
    Sys.WORD_SIZE == 64 ? 48 : 24
end

function alloc_test(f, n)
    f() # compile
    @test n == @allocated f()
end

function alloc_test_le(f, n)
    f() # compile
    @test n >= @allocated f()
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module MutableArithmetics

import LinearAlgebra
import SparseArrays

using Base.Meta  # Used in rewrite.jl

# Performance note:
# We use `Vararg` instead of splatting `...` as using `where N` forces Julia to
# specialize in the number of arguments `N`. Otherwise, we get allocations and
# slowdown because it compiles something that works for any `N`. See
# https://github.com/JuliaLang/julia/issues/32761 for details.

"""
    add_mul(a, args...)

Return `a + *(args...)`. Note that `add_mul(a, b, c) = muladd(b, c, a)`.
"""
function add_mul end
add_mul(a, b) = a + b
add_mul(a, b, c) = muladd(b, c, a)
function add_mul(a, b, c, d, args::Vararg{Any,N}) where {N}
    return add_mul(a, b, *(c, d, args...))
end

"""
    sub_mul(a, args...)

Return `a - *(args...)`.
"""
function sub_mul end
sub_mul(a, b) = a - b
sub_mul(a, b, c, args::Vararg{Any,N}) where {N} = a - *(b, c, args...)

"""
    add_dot(a, args...)

Return `a + dot(args...)`.
"""
function add_dot(a, b, c, args::Vararg{Any,N}) where {N}
    return a + LinearAlgebra.dot(b, c, args...)
end

const AddSubMul = Union{typeof(add_mul),typeof(sub_mul)}
add_sub_op(::typeof(add_mul)) = +
add_sub_op(::typeof(sub_mul)) = -
add_sub_mul_op(::typeof(+)) = add_mul
add_sub_mul_op(::typeof(-)) = sub_mul

"""
    iszero!!(x)

Return a `Bool` indicating whether `x` is zero, possibly modifying `x`.

## Examples

In MathOptInterface, a `ScalarAffineFunction` may contain duplicate terms.
In `Base.iszero`, duplicate terms need to be merged but the function is left
with duplicates as it cannot be modified. If `iszero!!` is called instead,
the function will be canonicalized in addition for checking whether it is zero.
"""
iszero!!(x) = iszero(x)

include("interface.jl")
include("shortcuts.jl")
include("broadcast.jl")

# Implementation of the interface for Base types

const Scaling = Union{Number,LinearAlgebra.UniformScaling}

scaling_to_number(x::Number) = x
scaling_to_number(x::LinearAlgebra.UniformScaling) = x.λ
scaling(x::Scaling) = x
scaling_convert(T::Type, x) = convert(T, x)

# `convert(::Type{<:UniformScaling}, ::UniformScaling)` is not defined in
# LinearAlgebra.

function scaling_convert(
    ::Type{LinearAlgebra.UniformScaling{T}},
    x::LinearAlgebra.UniformScaling,
) where {T}
    return LinearAlgebra.UniformScaling(convert(T, x.λ))
end

function operate(
    ::typeof(convert),
    ::Type{LinearAlgebra.UniformScaling{T}},
    x::LinearAlgebra.UniformScaling,
) where {T}
    return LinearAlgebra.UniformScaling(operate(convert, T, x.λ))
end

scaling_convert(T::Type, x::LinearAlgebra.UniformScaling) = convert(T, x.λ)

function operate(::typeof(convert), T::Type, x::LinearAlgebra.UniformScaling)
    return operate(convert, T, x.λ)
end

include("implementations/BigInt.jl")
include("implementations/BigFloat.jl")
include("implementations/LinearAlgebra.jl")
include("implementations/MutatingStepRange.jl")
include("implementations/Rational.jl")
include("implementations/SparseArrays.jl")

include("evalpoly.jl")

include("reduce.jl")

"""
    isequal_canonical(a, b)

Return whether `a` and `b` represent a same object, even if their
representations differ.

## Examples

The terms in two MathOptInterface affine functions may not match but once
the duplicates are merged, the zero terms are removed and the terms are sorted
in ascending order of variable indices (i.e. their canonical representation),
the equality of the representation is equivalent to the equality of the objects
begin represented.
"""
isequal_canonical(a, b) = a == b

function isequal_canonical(
    a::AT,
    b::AT,
) where {
    AT<:Union{
        Array,
        LinearAlgebra.Symmetric,
        LinearAlgebra.UpperTriangular,
        LinearAlgebra.LowerTriangular,
    },
}
    return all(zip(a, b)) do elements
        return isequal_canonical(elements...)
    end
end

function isequal_canonical(x::LinearAlgebra.Adjoint, y::LinearAlgebra.Adjoint)
    return isequal_canonical(parent(x), parent(y))
end

function isequal_canonical(
    x::LinearAlgebra.Transpose,
    y::LinearAlgebra.Transpose,
)
    return isequal_canonical(parent(x), parent(y))
end

function isequal_canonical(x::LinearAlgebra.Diagonal, y::LinearAlgebra.Diagonal)
    return isequal_canonical(parent(x), parent(y))
end

function isequal_canonical(
    x::LinearAlgebra.Tridiagonal,
    y::LinearAlgebra.Tridiagonal,
)
    return isequal_canonical(x.dl, y.dl) &&
           isequal_canonical(x.d, y.d) &&
           isequal_canonical(x.du, y.du)
end

function isequal_canonical(x::_SparseMat, y::_SparseMat)
    return x.m == y.m &&
           x.n == y.n &&
           isequal_canonical(x.colptr, y.colptr) &&
           isequal_canonical(x.rowval, y.rowval) &&
           isequal_canonical(x.nzval, y.nzval)
end

include("rewrite.jl")
include("rewrite_generic.jl")
include("dispatch.jl")

# Test that can be used to test an implementation of the interface
include("Test/Test.jl")

# This export code below was taken from JuMP:
const _EXCLUDE_SYMBOLS = [Symbol(@__MODULE__), :eval, :include]
for sym in names(@__MODULE__, all = true)
    sym_string = string(sym)
    if sym in _EXCLUDE_SYMBOLS ||
       startswith(sym_string, "_") ||
       startswith(sym_string, "@_")
        continue
    end
    if !(
        Base.isidentifier(sym) ||
        (startswith(sym_string, "@") && Base.isidentifier(sym_string[2:end]))
    )
        continue
    end
    @eval export $sym
end

end # module

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# This file contains methods to implement the MutableArithmetics API for types
# in the SparseArrays stdlib.

const _SparseMat = SparseArrays.SparseMatrixCSC

function undef_array(
    ::Type{_SparseMat{Tv,Ti}},
    rows::Base.OneTo,
    cols::Base.OneTo,
) where {Tv,Ti}
    return SparseArrays.spzeros(Tv, Ti, length(rows), length(cols))
end

function operate!(::typeof(zero), v::SparseArrays.SparseVector)
    empty!(v.nzind)
    empty!(v.nzval)
    return v
end

function operate!(::typeof(zero), A::_SparseMat)
    for i in eachindex(A.colptr)
        A.colptr[i] = one(A.colptr[i])
    end
    empty!(A.rowval)
    empty!(A.nzval)
    return A
end

function promote_operation(
    op::Union{typeof(+),typeof(-)},
    ::Type{<:SparseArrays.AbstractSparseArray{Tv,Ti,N}},
    ::Type{Array{T,N}},
) where {Tv,Ti,T,N}
    return Array{promote_operation(op, Tv, T),N}
end

function promote_operation(
    op::Union{typeof(+),typeof(-)},
    ::Type{Array{T,N}},
    ::Type{<:SparseArrays.AbstractSparseArray{Tv,Ti,N}},
) where {Tv,Ti,T,N}
    return Array{promote_operation(op, Tv, T),N}
end

function similar_array_type(
    ::Type{SparseArrays.SparseVector{Tv,Ti}},
    ::Type{T},
) where {T,Tv,Ti}
    return SparseArrays.SparseVector{T,Ti}
end

function similar_array_type(
    ::Type{_SparseMat{Tv,Ti}},
    ::Type{T},
) where {T,Tv,Ti}
    return _SparseMat{T,Ti}
end

# `SparseArrays/src/linalg.jl` sometimes create a sparse matrix to contain the
# result. For example, with `Matrix * Adjoint{SparseMatrixCSC}` and then uses
# `generic_matmatmul!` which looks quite inefficient as it does not exploit the
# sparsity of the result matrix and the rhs. The approach used here should be
# more efficient as we redirect to a method that exploits the sparsity of the
# rhs and `copyto!` should be faster to write the result matrix.
function operate!(
    ::typeof(add_mul),
    output::_SparseMat{T},
    A::AbstractMatrix,
    B::AbstractMatrix,
) where {T}
    C = Matrix{T}(undef, size(output)...)
    operate_to!(C, *, A, B)
    output .+= C
    return output
end

function operate!(
    ::typeof(add_mul),
    ret::VecOrMat{T},
    adjA::_TransposeOrAdjoint{<:Any,<:_SparseMat},
    B::AbstractVecOrMat,
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    _dim_check(ret, adjA, B)
    A = parent(adjA)
    A_nonzeros = SparseArrays.nonzeros(A)
    A_rowvals = SparseArrays.rowvals(A)
    for k in axes(ret, 2)
        for col in 1:A.n
            cur = ret[col, k]
            for j in SparseArrays.nzrange(A, col)
                A_val = _mirror_transpose_or_adjoint(A_nonzeros[j], adjA)
                cur = operate!!(add_mul, cur, A_val, B[A_rowvals[j], k], α...)
            end
            ret[col, k] = cur
        end
    end
    return ret
end

function operate!(
    ::typeof(add_mul),
    ret::VecOrMat{T},
    A::_SparseMat,
    B::AbstractVecOrMat,
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    _dim_check(ret, A, B)
    A_nonzeros = SparseArrays.nonzeros(A)
    A_rowvals = SparseArrays.rowvals(A)
    for col in axes(A, 2)
        for k in axes(ret, 2)
            αxj = *(B[col, k], α...)
            for j in SparseArrays.nzrange(A, col)
                ret[A_rowvals[j], k] =
                    operate!!(add_mul, ret[A_rowvals[j], k], A_nonzeros[j], αxj)
            end
        end
    end
    return ret
end

function operate!(
    ::typeof(add_mul),
    ret::Matrix{T},
    A::AbstractMatrix,
    B::_SparseMat,
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    _dim_check(ret, A, B)
    rowval = SparseArrays.rowvals(B)
    B_nonzeros = SparseArrays.nonzeros(B)
    for multivec_row in axes(A, 1)
        for col in axes(B, 2)
            cur = ret[multivec_row, col]
            for k in SparseArrays.nzrange(B, col)
                cur = operate!!(
                    add_mul,
                    cur,
                    A[multivec_row, rowval[k]],
                    B_nonzeros[k],
                    α...,
                )
            end
            ret[multivec_row, col] = cur
        end
    end
    return ret
end

function operate!(
    ::typeof(add_mul),
    ret::Matrix{T},
    A::AbstractMatrix,
    adjB::_TransposeOrAdjoint{<:Any,<:_SparseMat},
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    _dim_check(ret, A, adjB)
    B = parent(adjB)
    B_rowvals = SparseArrays.rowvals(B)
    B_nonzeros = SparseArrays.nonzeros(B)
    for B_col in axes(B, 2), k in SparseArrays.nzrange(B, B_col)
        B_row = B_rowvals[k]
        B_val = _mirror_transpose_or_adjoint(B_nonzeros[k], adjB)
        αB_val = *(B_val, α...)
        for A_row in axes(A, 1)
            ret[A_row, B_row] =
                operate!!(add_mul, ret[A_row, B_row], A[A_row, B_col], αB_val)
        end
    end
    return ret
end

# `_SparseMat`-`_SparseMat` matrix multiplication.
# Inspired from `SparseArrays.spmatmul` which is Gustavsen's matrix
# multiplication algorithm revisited so that row indices are sorted.

function promote_array_mul(
    ::Type{<:Union{_SparseMat{S,Ti},_TransposeOrAdjoint{S,_SparseMat{S,Ti}}}},
    ::Type{<:Union{_SparseMat{T,Ti},_TransposeOrAdjoint{T,_SparseMat{T,Ti}}}},
) where {S,T,Ti}
    return _SparseMat{promote_sum_mul(S, T),Ti}
end

function operate!(
    ::typeof(add_mul),
    ret::_SparseMat{T},
    A::_SparseMat,
    B::_SparseMat,
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    rhs_constants = prod(α)
    _dim_check(ret, A, B)
    rowvalA = SparseArrays.rowvals(A)
    nzvalA = SparseArrays.nonzeros(A)
    rowvalB = SparseArrays.rowvals(B)
    nzvalB = SparseArrays.nonzeros(B)
    mA, _ = size(A)
    nB = size(B, 2)
    nnz_ret = length(ret.rowval)
    @assert length(ret.nzval) == nnz_ret
    @inbounds begin
        ip = 1
        xb = fill(false, mA)
        for i in 1:nB
            if ip + mA - 1 > nnz_ret
                nnz_ret += max(mA, nnz_ret >> 2)
                resize!(ret.rowval, nnz_ret)
                resize!(ret.nzval, nnz_ret)
            end
            ret.colptr[i] = ip0 = ip
            k0 = ip - 1
            for jp in SparseArrays.nzrange(B, i)
                nzB = nzvalB[jp] * rhs_constants
                j = rowvalB[jp]
                for kp in SparseArrays.nzrange(A, j)
                    k = rowvalA[kp]
                    if xb[k]
                        ret.nzval[k+k0] =
                            operate!!(add_mul, ret.nzval[k+k0], nzvalA[kp], nzB)
                    else
                        ret.nzval[k+k0] = operate(*, nzvalA[kp], nzB)
                        xb[k] = true
                        ret.rowval[ip] = k
                        ip += 1
                    end
                end
            end
            if ip > ip0
                if _prefer_sort(ip - k0, mA)
                    # in-place sort of indices. Effort: O(nnz*ln(nnz)).
                    sort!(
                        ret.rowval,
                        ip0,
                        ip - 1,
                        QuickSort,
                        Base.Order.Forward,
                    )
                    for vp in ip0:(ip-1)
                        k = ret.rowval[vp]
                        xb[k] = false
                        ret.nzval[vp] = ret.nzval[k+k0]
                    end
                else
                    # scan result vector (effort O(mA))
                    for k in 1:mA
                        if xb[k]
                            xb[k] = false
                            ret.rowval[ip0] = k
                            ret.nzval[ip0] = ret.nzval[k+k0]
                            ip0 += 1
                        end
                    end
                end
            end
        end
        ret.colptr[nB+1] = ip
    end
    # This modification of Gustavson algorithm has sorted row indices
    resize!(ret.rowval, ip - 1)
    resize!(ret.nzval, ip - 1)
    return ret
end

# Taken from the internal function `Base.top_set_bit`, added in
# https://github.com/JuliaLang/julia/pull/47523
_top_set_bit(x::Integer) = 8 * sizeof(x) - leading_zeros(x)

# Taken from `SparseArrays.prefer_sort` added in Julia v1.1.
function _prefer_sort(nz::Integer, m::Integer)
    return m > 6 && 3 * _top_set_bit(nz) * nz < m
end

function operate!(
    ::typeof(add_mul),
    ret::_SparseMat{T},
    A::_SparseMat,
    B::_TransposeOrAdjoint{<:Any,<:_SparseMat},
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    return operate!(add_mul, ret, A, copy(B), α...)
end

function operate!(
    ::typeof(add_mul),
    ret::_SparseMat{T},
    A::_TransposeOrAdjoint{<:Any,<:_SparseMat},
    B::_SparseMat,
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    return operate!(add_mul, ret, copy(A), B, α...)
end

function operate!(
    ::typeof(add_mul),
    ret::_SparseMat{T},
    A::_TransposeOrAdjoint{<:Any,<:_SparseMat},
    B::_TransposeOrAdjoint{<:Any,<:_SparseMat},
    α::Vararg{Union{T,Scaling},N},
) where {T,N}
    return operate!(add_mul, ret, copy(A), B, α...)
end

# This `BroadcastStyle` is used when there is a mix of sparse arrays and dense
# arrays. The result is a sparse array.
function _broadcasted_type(
    ::SparseArrays.HigherOrderFns.PromoteToSparse,
    ::Base.HasShape{1},
    ::Type{Eltype},
) where {Eltype}
    return SparseArrays.SparseVector{Eltype,Int}
end

function _broadcasted_type(
    ::SparseArrays.HigherOrderFns.PromoteToSparse,
    ::Base.HasShape{2},
    ::Type{Eltype},
) where {Eltype}
    return _SparseMat{Eltype,Int}
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

using Documenter, MutableArithmetics

makedocs(;
    modules = [MutableArithmetics],
    # See https://github.com/JuliaDocs/Documenter.jl/issues/868
    format = Documenter.HTML(
        prettyurls = get(ENV, "CI", nothing) == "true",
        assets = String[],
    ),
    # See https://github.com/jump-dev/JuMP.jl/issues/1576
    strict = true,
    pages = ["Home" => "index.md"],
    repo = "https://github.com/jump-dev/MutableArithmetics.jl/blob/{commit}{path}#L{line}",
    sitename = "MutableArithmetics",
    authors = "Gilles Peiffer, Benoît Legat, and Sascha Timme",
)

deploydocs(; repo = "github.com/jump-dev/MutableArithmetics.jl.git")

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

using Test
import MutableArithmetics as MA

function mutating_step_range_test(::Type{T}) where {T}
    r = MA.MutatingStepRange(T(2), T(3), T(9))
    expected = MA.mutability(T) isa MA.IsMutable ? 8 * ones(T, 3) : T[2, 5, 8]
    @test collect(r) == expected
    @test reduce(MA.add!!, r) == T(15)
end

@testset "MutatingStepRange" begin
    mutating_step_range_test(Int)
    mutating_step_range_test(BigInt)
end

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestBasics

using Test

import MutableArithmetics as MA

include("dummy.jl")

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

function alloc_test(f::F, expected_upper_bound::Integer) where {F<:Function}
    f() # compile
    measured_allocations = @allocated f()
    @test measured_allocations <= expected_upper_bound
    return
end

function _test_copy(::Type{T}) where {T}
    @test MA.operate!!(copy, T(2)) == 2
    @test MA.operate_to!!(T(3), copy, T(2)) == 2
    if MA.mutability(T, copy, T) != MA.IsMutable()
        return
    end
    @testset "correctness" begin
        x = T(2)
        y = T(3)
        @test MA.operate!(copy, x) === x == 2
        @test MA.operate_to!(y, copy, x) === y == 2
    end
    @testset "alloc" begin
        f = let x = T(2)
            () -> MA.operate!(copy, x)
        end
        g = let x = T(2), y = T(3)
            () -> MA.operate_to!(y, copy, x)
        end
        alloc_test(f, 0)
        alloc_test(g, 0)
    end
    return
end

test_copy_Float64() = _test_copy(Float64)

test_copy_BigFloat() = _test_copy(BigFloat)

test_copy_Int() = _test_copy(Int)

test_copy_BigInt() = _test_copy(BigInt)

test_copy_Rational_Int() = _test_copy(Rational{Int})

test_copy_Rational_BigInt() = _test_copy(Rational{BigInt})

function test_copy_BigInt_smallint()
    function example_ints(t::Type{<:Integer})
        if t <: Signed
            [
                typemin(t),
                typemin(t) + t(1),
                t(-2),
                t(-1),
                t(0),
                t(1),
                t(2),
                typemax(t) - t(1),
                typemax(t),
            ]
        elseif t <: Unsigned
            [t(0), t(1), t(2), typemax(t) - t(1), typemax(t)]
        elseif t == Bool
            [false, true]
        else
            throw(ArgumentError("unknown type"))
        end
    end
    @testset "`copy` small integer to `BigInt`" begin
        for f! in (MA.operate_to!, MA.operate_to!!)
            for typ in [Bool, Int8, Int16, Int32, UInt8, UInt16, UInt32]
                for x in example_ints(typ)
                    @test let y = BigInt(3)
                        x == @inferred f!(y, copy, x)
                    end
                    @test let y = BigInt(3)
                        y === @inferred f!(y, copy, x)
                    end
                    let y = BigInt(3), x = typ(0), f! = f!
                        alloc_test(0) do
                            return f!(y, copy, x)
                        end
                    end
                end
            end
        end
    end
end

function _test_mutating_step_range(::Type{T}) where {T}
    r = MA.MutatingStepRange(T(2), T(3), T(9))
    expected = MA.mutability(T) isa MA.IsMutable ? 8 * ones(T, 3) : T[2, 5, 8]
    @test collect(r) == expected
    @test reduce(MA.add!!, r) == T(15)
    return
end

test_mutating_step_range_Int() = _test_mutating_step_range(Int)

test_mutating_step_range_BigInt() = _test_mutating_step_range(BigInt)

function test_Zero()
    z = MA.Zero()
    @test zero(MA.Zero) isa MA.Zero
    @test z + z isa MA.Zero
    @test z + 1 == 1
    @test 1 + z == 1
    @test z * z isa MA.Zero
    @test z * 1 isa MA.Zero
    @test 1 * z isa MA.Zero
    @test -z isa MA.Zero
    @test +z isa MA.Zero
    @test *(z) isa MA.Zero
    @test iszero(z)
    @test !isone(z)
    return
end

# *(::Complex, ::Hermitian)
function test_mult_Complex_Hermitian()
    A = BigInt[1 2; 2 3]
    B = LinearAlgebra.Hermitian(DummyBigInt.(A))
    C = 2im * A
    @test 2im * B == C
    @test C isa Matrix{Complex{BigInt}}
    return
end

function test_operate_to!_Array_AbstractMutable_Array()
    for A in ([1 2; 5 3], DummyBigInt[1 2; 5 3])
        for x in (2, DummyBigInt(2))
            # operate_to!(::Array, *, ::AbstractMutable, ::Array)
            B = x * A
            C = zero(B)
            D = MA.operate_to!(C, *, x, A)
            @test C === D
            @test typeof(B) == typeof(C)
            @test MA.isequal_canonical(B, C)
            # operate_to!(::Array, *, ::Array, ::AbstractMutable)
            B = A * x
            C = zero(B)
            D = MA.operate_to!(C, *, A, x)
            @test C === D
            @test typeof(B) == typeof(C)
            @test MA.isequal_canonical(B, C)
        end
    end
    return
end

function non_mutable_sum_pr306(x)
    y = zero(eltype(x))
    for xi in x
        y += xi
    end
    return y
end

function test_sum_with_init()
    x = convert(Vector{DummyBigInt}, 1:100)
    # compilation
    @allocated sum(x)
    @allocated sum(x; init = DummyBigInt(0))
    @allocated non_mutable_sum_pr306(x)
    # now test actual allocations
    no_init = @allocated sum(x)
    with_init = @allocated sum(x; init = DummyBigInt(0))
    no_ma = @allocated non_mutable_sum_pr306(x)
    # There's an additional 16 bytes for kwarg version. Upper bound by 40 to be
    # safe between Julia versions
    @test with_init <= no_init + 40
    # MA is at least 10-times better than no MA for this example
    @test 10 * with_init < no_ma
end

function test_sum_with_init_and_dims()
    x = reshape(convert(Vector{DummyBigInt}, 1:12), 3, 4)
    X = reshape(1:12, 3, 4)
    for dims in (1, 2, :, 1:2, (1, 2))
        # Without (; init)
        @test MA.isequal_canonical(sum(x; dims), DummyBigInt.(sum(X; dims)))
        # With (; init)
        y = sum(x; init = DummyBigInt(0), dims)
        @test MA.isequal_canonical(y, DummyBigInt.(sum(X; dims)))
    end
    return
end

function test_issue_336()
    A = DummyBigInt[1 2; 3 4]
    B = Any[A[1], A[2]]
    @test MA.isequal_canonical(A * B, A * A[1:2])
    @test_throws DimensionMismatch A * Any[A[1]]
    @test_throws DimensionMismatch MA.operate(*, A, Any[A[1]])
    return
end

function test_dispatch_dot()
    # Symmetric
    x = DummyBigInt[1 2; 2 3]
    y = LinearAlgebra.Symmetric(x)
    @test MA.isequal_canonical(
        LinearAlgebra.dot(x, y),
        MA.operate(LinearAlgebra.dot, x, y),
    )
    a = @allocated LinearAlgebra.dot(x, y)
    b = @allocated MA.operate(LinearAlgebra.dot, x, y)
    @test a == b
    # Symmetric
    x = DummyBigInt[1 2; 2 3]
    y = LinearAlgebra.Hermitian(x)
    @test MA.isequal_canonical(
        LinearAlgebra.dot(x, y),
        MA.operate(LinearAlgebra.dot, x, y),
    )
    a = @allocated LinearAlgebra.dot(x, y)
    b = @allocated MA.operate(LinearAlgebra.dot, x, y)
    @test a == b
    # AbstractArray
    x = DummyBigInt[1 2; 2 3]
    y = x
    @test MA.isequal_canonical(
        LinearAlgebra.dot(x, y),
        MA.operate(LinearAlgebra.dot, x, y),
    )
    a = @allocated LinearAlgebra.dot(x, y)
    b = @allocated MA.operate(LinearAlgebra.dot, x, y)
    @test a == b
    return
end

# Tests that the calls are correctly redirected to the mutable calls
# by checking allocations
function _test_dispatch(::Type{T}) where {T}
    buffer = zero(T)
    a = one(T)
    b = one(T)
    c = one(T)
    x = convert.(T, [1, 2, 3])
    # Need to allocate 1 BigInt for the result and one for the buffer
    nalloc = 3 * @allocated(BigInt(1))
    alloc_test(() -> MA.fused_map_reduce(MA.add_mul, x, x), nalloc)
    alloc_test(() -> MA.fused_map_reduce(MA.add_dot, x, x), nalloc)
    if T <: MA.AbstractMutable
        alloc_test(() -> x'x, nalloc)
        alloc_test(() -> transpose(x) * x, nalloc)
        alloc_test(() -> LinearAlgebra.dot(x, x), nalloc)
    end
    return
end

test_dispatch_BigInt() = _test_dispatch(BigInt)

test_dispatch_DummyBigInt() = _test_dispatch(DummyBigInt)

function test_dot_non_concrete_vector()
    x = [5.0, 6.0]
    y = Vector{Union{Float64,String}}(x)
    @test MA.operate(LinearAlgebra.dot, x, y) == LinearAlgebra.dot(x, y)
    @test MA.operate(*, x', y) == x' * y
    return
end

function test_dot_vector_of_vectors()
    x = [5.0, 6.0]
    z = [x, x]
    @test MA.operate(LinearAlgebra.dot, z, z) == LinearAlgebra.dot(z, z)
    return
end

# *(::Real, ::Hermitian)
function test_mult_Real_Hermitian()
    A = DummyBigInt[1 2; 2 3]
    B = DummyBigInt[2 4; 4 6]
    D = LinearAlgebra.Hermitian(B)
    for s in (:L, :U)
        Ah = LinearAlgebra.Hermitian(A, s)
        @test all(MA.isequal_canonical.(2 * Ah, D))
        @test all(MA.isequal_canonical.(Ah * 2, D))
    end
    return
end

# *(::AbstractMutable, ::Symmetric)
function test_mult_AbstractMutable_Symmetric()
    for A in ([1 2; 5 3], DummyBigInt[1 2; 5 3])
        for x in (2, DummyBigInt(2))
            for s in (:L, :U)
                # *(::AbstractMutable, ::Symmetric)
                B = LinearAlgebra.Symmetric(A, s)
                C = LinearAlgebra.Symmetric(x * A, s)
                D = x * B
                @test D isa LinearAlgebra.Symmetric
                @test MA.isequal_canonical(D, C)
                @test MA.isequal_canonical(D + D, 2 * D)
                # *(::Symmetric, ::AbstractMutable)
                B = LinearAlgebra.Symmetric(A, s)
                C = LinearAlgebra.Symmetric(A * x, s)
                D = B * x
                @test D isa LinearAlgebra.Symmetric
                @test MA.isequal_canonical(D, C)
                @test MA.isequal_canonical(D + D, 2 * D)
            end
        end
    end
end

function test_issue_271_mutability()
    a = 1
    x = [1; 2;;]
    y = [1 2; 3 4]
    z = [1 2; 3 4; 5 6]
    @test MA.mutability(x, *, x, x') == MA.IsNotMutable()
    @test MA.mutability(x, *, x', x) == MA.IsNotMutable()
    @test MA.mutability(x, *, x, a, x') == MA.IsNotMutable()
    @test MA.mutability(x, *, x', a, x) == MA.IsNotMutable()
    @test MA.mutability(y, *, y, y) == MA.IsMutable()
    @test MA.mutability(y, *, y, y, y) == MA.IsMutable()
    @test MA.mutability(y, *, y, a, y') == MA.IsMutable()
    @test MA.mutability(y, *, y', a, y) == MA.IsMutable()
    @test MA.mutability(y, *, a, a, y) == MA.IsMutable()
    @test MA.mutability(y, *, y, z', z) == MA.IsMutable()
    @test MA.mutability(z, *, z, z) == MA.IsNotMutable()
    @test MA.mutability(z, *, z, z, y) == MA.IsNotMutable()
    return
end

function test_issue_316_SubArray()
    y = reshape([1.0], 1, 1, 1)
    Y = view(y,:,:,1)
    ret = reshape([1.0], 1, 1)
    ret = MA.operate!!(MA.add_mul, ret, 2.0, Y)
    @test ret == reshape([3.0], 1, 1)
    @test y == reshape([1.0], 1, 1, 1)
    return
end

function test_issue_318_neutral_element()
    a = rand(3)
    A = [rand(2, 2) for _ in 1:3]
    @test_throws DimensionMismatch MA.operate(LinearAlgebra.dot, a, A)
    y = a' * A
    @test isapprox(MA.fused_map_reduce(MA.add_mul, a', A), y)
    z = MA.operate(LinearAlgebra.dot, Int[], Int[])
    @test iszero(z) && z isa Int
    z = MA.operate(LinearAlgebra.dot, BigInt[], Int[])
    @test iszero(z) && z isa BigInt
    z = MA.operate(LinearAlgebra.dot, Int[], Float64[])
    @test iszero(z) && z isa Float64
    z = MA.operate(LinearAlgebra.dot, Matrix{Int}[], Matrix{Float64}[])
    @test iszero(z) && z isa Float64
    @test MA.fused_map_reduce(MA.add_mul, Matrix{Int}[], Float64[]) isa MA.Zero
    @test MA.fused_map_reduce(MA.add_mul, Float64[], Matrix{Int}[]) isa MA.Zero
    return
end

function test_add_mul_for_BitArray()
    x = BigInt[0, 0]
    MA.operate!!(MA.add_mul, x, big(2), trues(2))
    @test x == BigInt[2, 2]
    MA.operate!!(MA.add_mul, x, big(3), BitVector([true, false]))
    @test x == BigInt[5, 2]
    x = BigInt[0 0; 0 0]
    MA.operate!!(MA.add_mul, x, big(2), trues(2, 2))
    @test x == BigInt[2 2; 2 2]
    MA.operate!!(MA.add_mul, x, big(3), BitArray([true false; true true]))
    @test x == BigInt[5 2; 5 5]
    return
end

function test_similar_array_type()
    @test MA.similar_array_type(BitArray{2}, Int) == Array{Int,2}
    @test MA.similar_array_type(BitArray{2}, Bool) == BitArray{2}
    return
end

function test_similar_array_type_Diagonal()
    z = zeros(2, 2)
    y = MA.operate!!(MA.add_mul, z, big(1), LinearAlgebra.I(2))
    @test y == BigFloat[1 0; 0 1]
    y = MA.operate!!(MA.add_mul, z, 2.4, LinearAlgebra.I(2))
    @test y === z
    @test y == Float64[2.4 0; 0 2.4]
    z = zeros(2, 2)
    y = MA.operate!!(MA.add_mul, z, 2.4, LinearAlgebra.Diagonal(1:2))
    @test y == LinearAlgebra.Diagonal(2.4 * (1:2))
    return
end

function test_Errors()
    err = ArgumentError(
        "Cannot call `operate_to!(::$Int, +, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `operate_to!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.operate_to!(0, +, 0, 0)
    err = ArgumentError(
        "Cannot call `operate!(+, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `operate!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.operate!(+, 0, 0)
    err = ArgumentError(
        "Cannot call `buffered_operate_to!(::$Int, ::$Int, +, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `buffered_operate_to!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.buffered_operate_to!(0, 0, +, 0, 0)
    err = ArgumentError(
        "Cannot call `buffered_operate!(::$Int, +, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `buffered_operate!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.buffered_operate!(0, +, 0, 0)
    x = DummyMutable()
    err = ErrorException(
        "`operate_to!(::$DummyMutable, +, ::$DummyMutable, ::$DummyMutable)` is not implemented yet.",
    )
    @test_throws err MA.operate_to!(x, +, x, x)
    err = ErrorException(
        "`operate!(+, ::$DummyMutable, ::$DummyMutable)` is not implemented yet.",
    )
    @test_throws err MA.operate!(+, x, x)
    err = ErrorException(
        "`buffered_operate_to!(::$DummyMutable, ::$DummyMutable, +, ::$DummyMutable, ::$DummyMutable)` is not implemented.",
    )
    @test_throws err MA.buffered_operate_to!(x, x, +, x, x)
    err = ErrorException(
        "`buffered_operate!(::$DummyMutable, +, ::$DummyMutable, ::$DummyMutable)` is not implemented.",
    )
    @test_throws err MA.buffered_operate!(x, +, x, x)
    return
end

function test_issue_240_error_free_mutability()
    for op in (+, -, *, /, div)
        for T in
            (Float64, BigFloat, Int, BigInt, Rational{Int}, Rational{BigInt})
            @test_nowarn MA.mutability(T, op, T, T) # should run without error
        end
    end
    return
end

function test_unary_op()
    @testset "unary op(::$T)" for T in (
        Float64,
        BigFloat,
        Int,
        BigInt,
        Rational{Int},
        Rational{BigInt},
    )
        @test MA.operate!!(+, T(7)) == 7
        @test MA.operate!!(*, T(7)) == 7
        @test MA.operate!!(-, T(7)) == -7
        @test MA.operate_to!!(T(6), +, T(7)) == 7
        @test MA.operate_to!!(T(6), *, T(7)) == 7
        @test MA.operate_to!!(T(6), -, T(7)) == -7
        @test MA.operate!!(abs, T(7)) == 7
        @test MA.operate!!(abs, T(-7)) == 7
        @test MA.operate_to!!(T(6), abs, T(7)) == 7
        @test MA.operate_to!!(T(6), abs, T(-7)) == 7
    end
    return
end

# Theodorus' constant √3 (deined in global scope due to const)
Base.@irrational theodorus 1.73205080756887729353 sqrt(big(3))

function test_issue_164()
    iπ() = MA.promote_operation(+, Int, typeof(π))
    @test iπ() == Float64
    alloc_test(iπ, 0)
    ℯbf() = MA.promote_operation(+, typeof(ℯ), BigFloat)
    @test ℯbf() == BigFloat
    # TODO this allocates as it creates the `BigFloat`
    #alloc_test(ℯbf, 0)
    bγ() = MA.promote_operation(/, Bool, typeof(Base.MathConstants.γ))
    @test bγ() == Float64
    alloc_test(bγ, 0)
    φf32() = MA.promote_operation(*, typeof(Base.MathConstants.φ), Float32)
    @test φf32() == Float32
    alloc_test(φf32, 0)
    # test user-defined Irrational
    i_theodorus() = MA.promote_operation(+, Int, typeof(theodorus))
    @test i_theodorus() == Float64
    alloc_test(i_theodorus, 0)
    # test _instantiate(::Type{S}) where {S<:Irrational} return value
    @test MA._instantiate(typeof(π)) == π
    @test MA._instantiate(typeof(MathConstants.catalan)) ==
          MathConstants.catalan
    @test MA._instantiate(typeof(theodorus)) == theodorus
    return
end

function test_promote_operation_complex()
    for op in [real, imag]
        @test MA.promote_operation(op, ComplexF64) == Float64
        @test MA.promote_operation(op, Complex{Real}) == Real
    end
    return
end

function test_promote_operation()
    @test MA.promote_operation(/, Rational{Int}, Rational{Int}) == Rational{Int}
    @test MA.promote_operation(-, DummyMutable, DummyMutable) == DummyMutable
    @test MA.promote_operation(/, DummyMutable, DummyMutable) == DummyMutable
    return
end

function _test_unary_op(::Type{T}, op) where {T}
    x = T(7)
    a = op(x)
    b = MA.operate(op, x)
    @test a == b
    if MA.mutability(T, op, T) == MA.IsMutable()
        @test a !== b
    end
    return
end

function _test_binary_op(::Type{T}, op) where {T}
    x = T(7)
    a = op(x, x)
    b = MA.operate(op, x, x)
    @test a == b
    if MA.mutability(T, op, T, T) == MA.IsMutable()
        @test a !== b
    end
    return
end

function _test_quaternary_op(::Type{T}, op) where {T}
    x = T(7)
    a = op(x, x, x, x)
    b = MA.operate(op, x, x, x, x)
    @test a == b
    if MA.mutability(T, op, T, T, T, T) == MA.IsMutable()
        @test a !== b
    end
    return
end

function _test_operate_dot(::Type{T}, ::Type{U}) where {T,U}
    x = T(7)
    y = U(5)
    a = LinearAlgebra.dot(x, y)
    b = MA.operate(LinearAlgebra.dot, [x], [y])
    @test a == b
    if MA.mutability(
        promote_type(T, U),
        LinearAlgebra.dot,
        Vector{T},
        Vector{U},
    ) == MA.IsMutable()
        @test a !== b
    end
end

function test_operate()
    @testset "$T" for T in (Int, BigInt, Rational{Int})
        @testset "1-ary $op" for op in [+, *, gcd, lcm, copy, abs]
            _test_unary_op(T, op)
        end
        ops = [+, *, MA.add_mul, MA.sub_mul, MA.add_dot, gcd, lcm]
        @testset "4-ary $op" for op in ops
            _test_quaternary_op(T, op)
        end
        @testset "2-ary $op" for op in [-, /, div]
            _test_binary_op(T, op)
        end
        @testset "dot" for U in (Int, BigInt, Rational{Int}, Rational{BigInt})
            _test_operate_dot(T, U)
        end
    end
    return
end

function test_op_divide()
    @test MA.Zero() / DummyBigInt(1) == MA.Zero()
    @test_throws DivideError MA.Zero() / DummyBigInt(0)
    return
end

end  # TestBasics

TestBasics.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestRewriteGeneric

using Test

import MutableArithmetics as MA

include(joinpath(@__DIR__, "dummy.jl"))

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

macro test_rewrite(expr)
    return quote
        esc(
            @test MA.isequal_canonical(
                MA.@rewrite($expr, move_factors_into_sums = false),
                $expr,
            )
        )
    end
end

function test_rewrite()
    x, expr = MA.rewrite(1 + 1, move_factors_into_sums = false)
    @test x isa Symbol
    @test Meta.isexpr(expr, :(=), 2)
    return
end

function test_rewrite_basic_ops()
    @test_rewrite 1 + 2
    @test_rewrite 1 - 2
    @test_rewrite 1 * 2
    @test_rewrite 1 / 2
    @test_rewrite 1 + 2 - 3
    @test_rewrite 1 - 2 + 4
    @test_rewrite 1 * 2 / 3
    @test_rewrite 1 / 2 * 3
    return
end

function test_rewrite_not_call()
    x = [1, 2, 3]
    for i in 1:3
        @test MA.@rewrite(x[i], move_factors_into_sums = false) == i
    end
    return
end

function test_rewrite_zero_argument()
    @test_rewrite Dict()
    return
end

function test_rewrite_sum_to_add_mul()
    @test_rewrite +1
    @test_rewrite +(-2)
    x = [1.2]
    @test MA.@rewrite(+x, move_factors_into_sums = false) == x
    @test MA.@rewrite(x + x, move_factors_into_sums = false) == 2 * x
    @test MA.@rewrite(+(x, x, x), move_factors_into_sums = false) == 3 * x
    @test MA.@rewrite(+(x, x, x, x), move_factors_into_sums = false) == 4 * x
    return
end

function test_rewrite_prod_to_add_mul()
    @test_rewrite 1 * 1
    @test_rewrite 2 * -2
    A = [1.0 2.0; 3.0 4.0]
    x = [5.0, 6.0]
    @test MA.@rewrite(A * x, move_factors_into_sums = false) == A * x
    return
end

function test_rewrite_nonconcrete_vector()
    x = [5.0, 6.0]
    y = Vector{Union{Float64,String}}(x)
    @test MA.@rewrite(x' * y, move_factors_into_sums = false) == x' * y
    @test MA.@rewrite(x .+ y, move_factors_into_sums = false) == x .+ y
    @test MA.@rewrite(x + y, move_factors_into_sums = false) == x + x
    return
end

function test_rewrite_minus_to_add_mul()
    @test_rewrite -1
    @test_rewrite -(+2)
    @test_rewrite -(-2)
    x = [1.2]
    @test MA.@rewrite(-x, move_factors_into_sums = false) == -x
    @test MA.@rewrite(x - x, move_factors_into_sums = false) == [0.0]
    @test MA.@rewrite(-(x, x, x), move_factors_into_sums = false) == -1 * x
    @test MA.@rewrite(-(x, x, x, x), move_factors_into_sums = false) == -2 * x
    return
end

function test_rewrite_sum()
    @test MA.@rewrite(sum(i for i in 1:0), move_factors_into_sums = false) ==
          MA.Zero()
    @test_rewrite sum(i for i in 1:10)
    @test_rewrite sum(i + i^2 for i in 1:10)
    @test_rewrite sum(i * i for i in 1:10)
    return
end

function test_rewrite_unknown_generators()
    @test_rewrite prod(i for i in 1:10)
    @test_rewrite minimum(i for i in 1:10)
    @test_rewrite maximum(i for i in 1:10)
    return
end

function test_rewrite_generator()
    # Unfiltered generators
    # Univariate
    @test_rewrite sum(i for i in 1:2)
    @test_rewrite sum(j^2 for j in 2:3)
    # Binary
    @test_rewrite sum(i + j^2 for i in 1:2, j in 2:3)
    @test_rewrite sum(i + j^2 for i in 1:2 for j in 2:3)
    # Tertiary
    @test_rewrite sum(i + j^2 for i in 1:2, j in 2:3, k in 3:4)
    @test_rewrite sum(i + j^2 for i in 1:2, j in 2:3 for k in i:j)
    @test_rewrite sum(i + j^2 for i in 1:2 for j in 2:3, k in 3:4)
    @test_rewrite sum(i + j^2 for i in 1:2 for j in 2:3 for k in 3:4)
    # Generators with dependent variables
    # This syntax is unsupported by Julia!
    @test MA.@rewrite(
        sum(i + j^2 for i in 1:2, j in i:3),
        move_factors_into_sums = false,
    ) == 34
    @test MA.@rewrite(
        sum(i + j^2 for i in 1:2, j in 2:3, k in i:j),
        move_factors_into_sums = false,
    ) == 68
    # Unnivariate generators with an if statement
    @test_rewrite sum(i for i in 1:2 if i >= 1)
    @test_rewrite sum(j^2 for j in 2:3 if j <= 3)
    @test_rewrite sum(i for i in 1:2 if isodd(i))
    @test_rewrite sum(j^2 for j in 2:3 if isodd(j))
    # Binary generators with an if statement
    @test_rewrite sum(i + j^2 for i in 1:2, j in 2:3 if i + j >= 0)
    @test_rewrite sum(i + j^2 for i in 1:2, j in 2:3 if i <= 1)
    @test_rewrite sum(i + j^2 for i in 1:2, j in 2:3 if j <= 2)
    # Flatten with generator on first key
    @test_rewrite sum(i for i in 1:2 if isodd(i) for j in 1:3)
    @test_rewrite sum(i for i in 1:3 if i <= 2 for j in 1:2)
    # Flatten with generator on second key
    @test_rewrite sum(i for i in 1:2 for j in 1:i if isodd(j))
    @test_rewrite sum(i for i in 1:2 for j in 1:i if i != j)
    # Generator with two filters
    @test_rewrite sum(i for i in 1:3 if i <= 2 for j in 1:2 if j >= 1)
    return
end

function test_rewrite_linear_algebra()
    @test_rewrite [1 2; 3 4] * [5.0, 6.0]
    @test_rewrite [1 2; 3 4] * [5, 6]
    @test_rewrite [1 2; 3 4] * [1 2; 3 4]
    @test_rewrite [1 2; 3 4] * Float64[1 2; 3 4]
    @test_rewrite [5, 6]' * [1 2; 3 4] * [5, 6]
    @test_rewrite 2 * [1 2; 3 4]
    @test_rewrite [1 2; 3 4] * 2
    @test_rewrite [1, 2] * 2.0
    @test_rewrite 2.0 * [1, 2]
    x = [1, 2]
    A = [1 2; 3 4]
    y = reshape(x, (1, length(x))) * A * x .- 1
    @test MA.@rewrite(
        reshape(x, (1, length(x))) * A * x .- 1,
        move_factors_into_sums = false,
    ) == y
    return
end

function test_rewrite_broadcast_add_mul()
    @test_rewrite 1 .+ 2
    @test_rewrite [1, 2] .+ [2, 3]
    @test_rewrite [5.0, 6.0] .+ [1 2; 3 4] * [5.0, 6.0]
    @test_rewrite .+(BigInt(1))

    return
end

function test_rewrite_broadcast_sub_mul()
    @test_rewrite 1 .* 2
    @test_rewrite [1, 2] .* [2, 3]
    @test_rewrite [5.0, 6.0] .- [1 2; 3 4] * [5.0, 6.0]
    @test_rewrite .-(BigInt(1))
    return
end

function test_rewrite_repeated_sums()
    n = 10
    x = BigInt[2 for _ in 1:n]
    @test MA.@rewrite(sum(x[i] for i in 1:n) + sum(x[i] for i in 1:n)) == 4 * n
    @test MA.@rewrite(sum(x[i] for i in 1:n) - sum(x[i] for i in 1:n)) == 0
    @test MA.@rewrite(sum(x[i]^2 for i in 1:n) - sum(x[i] for i in 1:n)) ==
          sum(x .^ 2) - sum(x)
    @test MA.@rewrite(sum(x[i]^2 for i in 1:n) + sum(x[i] for i in 1:n)) ==
          sum(x .^ 2) + sum(x)
    @test MA.@rewrite(sum(x[i] for i in 1:n) - sum(x[i]^2 for i in 1:n)) ==
          sum(x) - sum(x .^ 2)
    @test MA.@rewrite(sum(x[i] for i in 1:n) + sum(x[i]^2 for i in 1:n)) ==
          sum(x) + sum(x .^ 2)
    return
end

function test_multi_prod()
    @test_rewrite *(sum([BigInt(5)] for _ in 1:2), 2)
    @test_rewrite *(sum([BigInt(5)] for _ in 1:2), BigInt(2))
    @test_rewrite *(sum([BigInt(5)] for _ in 1:2)', [2])
    @test_rewrite *(sum(BigInt(5) for _ in 1:2), BigInt(2), 3, BigInt(4))
    return
end

function test_rewrite_sums_init()
    @test_rewrite sum(i for i in 1:2; init = 2)
    @test_rewrite sum(i for i in 1:2; init = -1)
    @test_rewrite sum(i * j for i in 1:2 for j in 1:3; init = -1)
    @test_rewrite sum(i * j for i in 1:2 for j in 1:3; init = 2 * 3)
    @test_rewrite sum(i * j for i in 1:2 for j in i:3; init = 2 * 3)
    return
end

function test_rewrite_sums_init_positional()
    # Needed so we don't replace `, init` with `; init`.
    #! format:off
    @test MA.@rewrite(
        sum(i for i in 1:2, init = 2),
        move_factors_into_sums = false,
    ) == 5
    @test MA.@rewrite(
        sum(i for i in 1:2, init = -1),
        move_factors_into_sums = false,
    ) == 2
    @test MA.@rewrite(
        sum(i * j for i in 1:2 for j in 1:3, init = -1),
        move_factors_into_sums = false,
    ) == 17
    @test MA.@rewrite(
        sum(i * j for i in 1:2 for j in 1:3, init = 2 * 3),
        move_factors_into_sums = false,
    ) == 24
    @test MA.@rewrite(
        sum(i * j for i in 1:2 for j in i:3, init = 2 * 3),
        move_factors_into_sums = false,
    ) == 22
    #! format:on
    return
end

function test_rewrite_kwarg()
    f(; x) = x^2
    @test MA.@rewrite(f(; x = 2), move_factors_into_sums = false) == 4
    g(x; y) = x + y^2
    @test MA.@rewrite(g(2; y = 2), move_factors_into_sums = false) == 6
    return
end

function test_rewrite_sum_function()
    @test_rewrite sum(i -> i^2, 1:2)
    @test_rewrite sum(i -> i^2, 1:2; init = 3)
    f(x) = x^2
    y = 1:2
    @test MA.@rewrite(sum(f, y), move_factors_into_sums = false) == sum(f, y)
    return
end

struct NoProduct <: MA.AbstractMutable
    x::Int
end

MA.operate(::typeof(*), x::NoProduct, y::NoProduct) = NoProduct(x.x * y.x)

function test_no_product()
    x, y = NoProduct(2), NoProduct(3)
    @test MA.@rewrite(x * y, move_factors_into_sums = false) == NoProduct(6)
    return
end

function test_splatting()
    x = [1, 2, 3]
    @test MA.@rewrite(+(x...), move_factors_into_sums = false) == 6
    @test MA.@rewrite(+(4, x...), move_factors_into_sums = false) == 10
    @test MA.@rewrite(+(x..., 4), move_factors_into_sums = false) == 10
    @test MA.@rewrite(+(4, x..., 5), move_factors_into_sums = false) == 15
    @test MA.@rewrite(*(x...), move_factors_into_sums = false) == 6
    @test MA.@rewrite(*(4, x...), move_factors_into_sums = false) == 24
    @test MA.@rewrite(*(x..., 4), move_factors_into_sums = false) == 24
    @test MA.@rewrite(*(4, x..., 5), move_factors_into_sums = false) == 120
    @test MA.@rewrite(
        +(4, x..., *(4, x..., 5)),
        move_factors_into_sums = false,
    ) == 130
    @test MA.@rewrite(vcat(x...), move_factors_into_sums = false) == x
    return
end

struct _KwargRef{K,V}
    data::Dict{K,V}
end

Base.getindex(x::_KwargRef; i) = x.data[i]

function test_rewrite_kw_in_ref()
    x = _KwargRef(Dict(i => i + 1 for i in 2:4))
    @test MA.@rewrite(
        sum(x[i=j] for j in 2:4),
        move_factors_into_sums = false,
    ) == 12
    return
end

function test_rewrite_expression()
    x = [1.2]
    @test MA.@rewrite(x + 2 * x, move_factors_into_sums = false) == 3x
    @test MA.@rewrite(x + *(2, x, 3), move_factors_into_sums = false) ==
          x + *(2, x, 3)
    y = 1.2
    @test MA.@rewrite(
        sum(y for i in 1:2) + 2y,
        move_factors_into_sums = false
    ) == 4y
    @test MA.@rewrite(
        sum(y for i in 1:2) + y * y,
        move_factors_into_sums = false
    ) == 2y + y^2
    @test MA.@rewrite(y + 2 * y, move_factors_into_sums = false) == 3y
    @test MA.@rewrite(y + *(2, y, 3), move_factors_into_sums = false) ==
          y + *(2, y, 3)
    return
end

function test_rewrite_generic_sum_dims()
    @test_rewrite sum([1 2; 3 4]; dims = 1)
    @test_rewrite sum([1 2; 3 4]; dims = 2)
    @test_rewrite sum([1 2; 3 4]; dims = 1, init = 0)
    @test_rewrite sum([1 2; 3 4]; dims = 2, init = 0)
    @test_rewrite sum([1 2; 3 4]; init = 0, dims = 1)
    @test_rewrite sum([1 2; 3 4]; init = 0, dims = 2)
    @test_rewrite sum([1 2; 3 4], dims = 1)
    @test_rewrite sum([1 2; 3 4], dims = 2)
    @test_rewrite sum([1 2; 3 4], dims = 1, init = 0)
    @test_rewrite sum([1 2; 3 4], dims = 2, init = 0)
    @test_rewrite sum([1 2; 3 4], init = 0, dims = 1)
    @test_rewrite sum([1 2; 3 4], init = 0, dims = 2)
    return
end

function test_rewrite_block()
    @test_rewrite begin
        x = 1
        y = x + 2
        z = 3 * y
    end
    @test_rewrite begin
        x = [1]
        y = x + [2]
        z = 3 * y
    end
    return
end

function test_rewrite_ifelse()
    @test_rewrite begin
        x = -1
        y = [3.0]
        if x < 1
            y .+ x
        else
            2 * x
        end
    end
    @test_rewrite begin
        x = 2
        y = [3.0]
        if x < 1
            y .+ x
        else
            2 * x
        end
    end
    @test_rewrite begin
        x = 2
        y = [3.0, 4.0]
        if x < 1
            y .+ x
        elseif length(y) == 2
            0.0
        else
            2 * x
        end
    end
    @test_rewrite begin
        x = 2
        y = Float64[]
        if x < 1
            y .+ x
        elseif length(y) == 2
            0.0
        elseif isempty(y)
            -1.0
        else
            2 * x
        end
    end
    @test_rewrite begin
        x = 2
        y = Float64[1.0]
        if x < 1
            1.0
        elseif length(y) == 2
            2.0
        elseif isempty(y)
            3.0
        else
            4.0
        end
    end
    return
end

function test_return_is_mutable()
    function _rewrite(expr)
        return MA.rewrite(
            expr;
            move_factors_into_sums = false,
            return_is_mutable = true,
        )
    end
    x, expr, is_mutable = _rewrite(1)
    @test x isa Symbol
    @test Meta.isexpr(expr, :(=), 2)
    @test is_mutable
    y = 1
    x, expr, is_mutable = _rewrite(:(y))
    @test x isa Symbol
    @test Meta.isexpr(expr, :(=), 2)
    @test !is_mutable
    x, expr, is_mutable = _rewrite(:(1 + 1))
    @test x isa Symbol
    @test Meta.isexpr(expr, :(=), 2)
    @test is_mutable
    @test_throws(
        AssertionError,
        MA.rewrite(
            :(1 + 1);
            move_factors_into_sums = true,
            return_is_mutable = true,
        ),
    )
    return
end

function test_rewrite_sum_unary_minus()
    x = big.(1:3)
    y = MA.@rewrite(sum(-x[i] for i in 1:3), move_factors_into_sums = false)
    @test y == big(-6)
    return
end

function test_allocations_rewrite_unary_minus()
    N = 100
    x = big.(1:N)
    a = big(-1)
    # precompilaton
    MA.@rewrite(sum(-x[i] for i in 1:N), move_factors_into_sums = false)
    MA.@rewrite(-sum(x[i] for i in 1:N), move_factors_into_sums = false)
    MA.@rewrite(sum(a * x[i] for i in 1:N), move_factors_into_sums = false)
    sum(-x[i] for i in 1:N)
    value = @allocated(
        MA.@rewrite(sum(-x[i] for i in 1:N), move_factors_into_sums = false),
    )
    @test value < @allocated sum(-x[i] for i in 1:N)
    value = @allocated(
        MA.@rewrite(-sum(x[i] for i in 1:N), move_factors_into_sums = false),
    )
    @test value < @allocated -sum(x[i] for i in 1:N)
    value = @allocated(
        MA.@rewrite(sum(a * x[i] for i in 1:N), move_factors_into_sums = false),
    )
    @test value < @allocated sum(a * x[i] for i in 1:N)
    return
end

function test_allocations_rewrite_mult()
    x = BigFloat[1, 2, 3]
    y = MA.@rewrite(x[1] * x[2] * x[3], move_factors_into_sums = false)
    @test y == BigFloat(6)
    @test x == BigFloat[1, 2, 3]
    total = @allocated (x[1] * x[2]) * x[3]
    @test @allocated(
        MA.@rewrite(x[1] * x[2] * x[3], move_factors_into_sums = false),
    ) < total
    return
end

function test_rewrite_init_symbol()
    x = Int[]
    y = MA.@rewrite(sum(x; init = 0), move_factors_into_sums = false)
    @test y == 0
    y = MA.@rewrite(sum(x, init = 0), move_factors_into_sums = false)
    @test y == 0
    return
end

function test_issue_343()
    x = [1, 3, 5, 7, 8, 2]
    y = sum(x)
    @test MA.@rewrite(sum(x[:]), move_factors_into_sums = false) == y
    @test MA.@rewrite(sum(x[i] for i in 1:6), move_factors_into_sums = false) ==
          y
    @test MA.@rewrite(
        sum(x[i+j] for i in 1:2:6 for j in 0:1),
        move_factors_into_sums = false
    ) == y
    @test MA.@rewrite(
        sum(x[i+j] for i in 1:2:6, j in 0:1),
        move_factors_into_sums = false
    ) == y
    # Turn formatting off here so we preserve `init = 0`
    #!format:off
    @test MA.@rewrite(sum(x[:], init = 0), move_factors_into_sums = false) == y
    @test MA.@rewrite(
        sum(x[i] for i in 1:6, init = 0),
        move_factors_into_sums = false
    ) == y
    @test MA.@rewrite(
        sum(x[i+j] for i in 1:2:6 for j in 0:1, init = 0),
        move_factors_into_sums = false
    ) == y
    @test MA.@rewrite(
        sum(x[i+j] for i in 1:2:6, j in 0:1, init = 0),
        move_factors_into_sums = false
    ) == y
    #!format:on
    @test MA.@rewrite(sum(x[:]; init = 0), move_factors_into_sums = false) == y
    @test MA.@rewrite(
        sum(x[i] for i in 1:6; init = 0),
        move_factors_into_sums = false
    ) == y
    @test MA.@rewrite(
        sum(x[i+j] for i in 1:2:6 for j in 0:1; init = 0),
        move_factors_into_sums = false
    ) == y
    @test MA.@rewrite(
        sum(x[i+j] for i in 1:2:6, j in 0:1; init = 0),
        move_factors_into_sums = false
    ) == y
    return
end

function test_multiply_expr_MA_Zero()
    x = DummyBigInt(1)
    f = DummyBigInt(2)
    @test MA.@rewrite(
        f * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * f,
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        -f * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * -f,
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        (f + f) * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * (f + f),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        -[f] * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * -[f],
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.isequal_canonical(
        MA.@rewrite(f + sum(x for i in 1:0), move_factors_into_sums = false),
        f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(sum(x for i in 1:0) + f, move_factors_into_sums = false),
        f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(-f + sum(x for i in 1:0), move_factors_into_sums = false),
        -f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(sum(x for i in 1:0) + -f, move_factors_into_sums = false),
        -f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(
            (f + f) + sum(x for i in 1:0),
            move_factors_into_sums = false
        ),
        f + f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(
            sum(x for i in 1:0) + (f + f),
            move_factors_into_sums = false
        ),
        f + f,
    )
    return
end

function test_generator_with_not_sum()
    @test MA.@rewrite(minimum(j^2 for j in 2:3)) == 4
    @test MA.@rewrite(maximum(j^2 for j in 2:3)) == 9
    return
end

function test_issue_76_trailing_dimensions()
    @testset "(4,) + (4,1)" begin
        X = [1, 2, 3, 4]
        Y = reshape([1, 2, 3, 4], (4, 1))
        @test MA.@rewrite(X + Y) == X + Y
        @test MA.@rewrite(Y + X) == Y + X
    end
    @testset "(4,) + (4,1,1)" begin
        X = [1, 2, 3, 4]
        Y = reshape([1, 2, 3, 4], (4, 1, 1))
        @test MA.@rewrite(X + Y) == X + Y
        @test MA.@rewrite(Y + X) == Y + X
    end
    @testset "(2,2) + (2,2,1)" begin
        X = [1 2; 3 4]
        Y = reshape([1, 2, 3, 4], (2, 2, 1))
        @test MA.@rewrite(X + Y) == X + Y
        @test MA.@rewrite(Y + X) == Y + X
    end
    @testset "(4,) - (4,1)" begin
        X = [1, 3, 5, 7]
        Y = reshape([1, 2, 3, 4], (4, 1))
        @test MA.@rewrite(X - Y) == X - Y
        @test MA.@rewrite(Y - X) == Y - X
    end
    @testset "(4,) - (4,1,1)" begin
        X = [1, 3, 5, 7]
        Y = reshape([1, 2, 3, 4], (4, 1, 1))
        @test MA.@rewrite(X - Y) == X - Y
        @test MA.@rewrite(Y - X) == Y - X
    end
    @testset "(2,2) - (2,2,1)" begin
        X = [1 3; 5 7]
        Y = reshape([1, 2, 3, 4], (2, 2, 1))
        @test MA.@rewrite(X - Y) == X - Y
        @test MA.@rewrite(Y - X) == Y - X
    end
    return
end

function test_issue_359()
    for (expr, has_zero) in Pair{Expr,Bool}[
        :(sum(i for i in I))=>true,
        :(sum(i for i in I; init = 0))=>false,
        :(sum(i for i in I, init in 0))=>false,
    ]
        stack = quote end
        root, is_mutable = MA._rewrite_generic(stack, expr)
        @test root isa Symbol
        @test is_mutable
        @test length(stack.args) == 3
        @test occursin(".Zero()", string(stack.args[2])) == has_zero
    end
    return
end

end  # module

TestRewriteGeneric.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

using Test

is_test(f) = startswith(f, "test_") && endswith(f, ".jl")

@testset "$file" for file in filter(is_test, readdir(@__DIR__))
    include(joinpath(@__DIR__, file))
end

function operate!!(op, args...)
    T = typeof.(args)
    if mutability(T[1], op, T...) isa IsMutable
        return operate!(op, args...)
    else
        return op(args...)
    end
end
function operate_to!!(output, op, args...)
    O = typeof(output)
    T = typeof.(args)
    if mutability(O, op, T...) isa IsMutable
        return operate_to!(output, op, args...)
    else
        return op(args...)
    end
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

using LinearAlgebra

# Tests that the calls are correctly redirected to the mutable calls
# by checking allocations
function dispatch_tests(::Type{T}) where {T}
    buffer = zero(T)
    a = one(T)
    b = one(T)
    c = one(T)
    x = convert.(T, [1, 2, 3])
    # Need to allocate 1 BigInt for the result and one for the buffer
    alloc_test(() -> MA.fused_map_reduce(MA.add_mul, x, x), 2BIGINT_ALLOC)
    alloc_test(() -> MA.fused_map_reduce(MA.add_dot, x, x), 2BIGINT_ALLOC)
    if T <: MA.AbstractMutable
        alloc_test(() -> x'x, 2BIGINT_ALLOC)
        alloc_test(() -> transpose(x) * x, 2BIGINT_ALLOC)
        alloc_test(() -> LinearAlgebra.dot(x, x), 2BIGINT_ALLOC)
    end
end

@testset "Dispatch tests" begin
    dispatch_tests(BigInt)
    # On `DummyBigInt` allocates more on previous releases of Julia
    # as it's dynamically allocated
    dispatch_tests(DummyBigInt)

    @testset "dot non-concrete vector" begin
        x = [5.0, 6.0]
        y = Vector{Union{Float64,String}}(x)
        @test MA.operate(LinearAlgebra.dot, x, y) == LinearAlgebra.dot(x, y)
        @test MA.operate(*, x', y) == x' * y
    end

    @testset "dot vector of vectors" begin
        x = [5.0, 6.0]
        z = [x, x]
        @test MA.operate(LinearAlgebra.dot, z, z) == LinearAlgebra.dot(z, z)
    end
end

@testset "*(::Real, ::Hermitian)" begin
    A = DummyBigInt[1 2; 2 3]
    B = DummyBigInt[2 4; 4 6]
    D = LinearAlgebra.Hermitian(B)
    for s in (:L, :U)
        Ah = LinearAlgebra.Hermitian(A, s)
        @test all(MA.isequal_canonical.(2 * Ah, D))
        @test all(MA.isequal_canonical.(Ah * 2, D))
    end
end

@testset "*(::AbstractMutable, ::Symmetric)" begin
    for A in ([1 2; 5 3], DummyBigInt[1 2; 5 3])
        for x in (2, DummyBigInt(2))
            for s in (:L, :U)
                # *(::AbstractMutable, ::Symmetric)
                B = LinearAlgebra.Symmetric(A, s)
                C = LinearAlgebra.Symmetric(x * A, s)
                D = x * B
                @test D isa LinearAlgebra.Symmetric
                @test MA.isequal_canonical(D, C)
                @test MA.isequal_canonical(D + D, 2 * D)
                # *(::Symmetric, ::AbstractMutable)
                B = LinearAlgebra.Symmetric(A, s)
                C = LinearAlgebra.Symmetric(A * x, s)
                D = B * x
                @test D isa LinearAlgebra.Symmetric
                @test MA.isequal_canonical(D, C)
                @test MA.isequal_canonical(D + D, 2 * D)
            end
        end
    end
end

@testset "*(::Complex, ::Hermitian)" begin
    A = BigInt[1 2; 2 3]
    B = LinearAlgebra.Hermitian(DummyBigInt.(A))
    C = 2im * A
    @test 2im * B == C
    @test C isa Matrix{Complex{BigInt}}
end

@testset "operate_to!(::Array, ::typeof(*), ::AbstractMutable, ::Array)" begin
    for A in ([1 2; 5 3], DummyBigInt[1 2; 5 3])
        for x in (2, DummyBigInt(2))
            # operate_to!(::Array, *, ::AbstractMutable, ::Array)
            B = x * A
            C = zero(B)
            D = MA.operate_to!(C, *, x, A)
            @test C === D
            @test typeof(B) == typeof(C)
            @test MA.isequal_canonical(B, C)
            # operate_to!(::Array, *, ::Array, ::AbstractMutable)
            B = A * x
            C = zero(B)
            D = MA.operate_to!(C, *, A, x)
            @test C === D
            @test typeof(B) == typeof(C)
            @test MA.isequal_canonical(B, C)
        end
    end
end

function non_mutable_sum_pr306(x)
    y = zero(eltype(x))
    for xi in x
        y += xi
    end
    return y
end

@testset "sum_with_init" begin
    x = convert(Vector{DummyBigInt}, 1:100)
    # compilation
    @allocated sum(x)
    @allocated sum(x; init = DummyBigInt(0))
    @allocated non_mutable_sum_pr306(x)
    # now test actual allocations
    no_init = @allocated sum(x)
    with_init = @allocated sum(x; init = DummyBigInt(0))
    no_ma = @allocated non_mutable_sum_pr306(x)
    # There's an additional 16 bytes for kwarg version. Upper bound by 40 to be
    # safe between Julia versions
    @test with_init <= no_init + 40
    # MA is at least 10-times better than no MA for this example
    @test 10 * with_init < no_ma
end

@testset "sum_with_init_and_dims" begin
    x = reshape(convert(Vector{DummyBigInt}, 1:12), 3, 4)
    X = reshape(1:12, 3, 4)
    for dims in (1, 2, :, 1:2, (1, 2))
        # Without (; init)
        @test MA.isequal_canonical(sum(x; dims), DummyBigInt.(sum(X; dims)))
        # With (; init)
        y = sum(x; init = DummyBigInt(0), dims)
        @test MA.isequal_canonical(y, DummyBigInt.(sum(X; dims)))
    end
end

@testset "issue_336" begin
    A = DummyBigInt[1 2; 3 4]
    B = Any[A[1], A[2]]
    @test MA.isequal_canonical(A * B, A * A[1:2])
    @test_throws DimensionMismatch A * Any[A[1]]
    @test_throws DimensionMismatch MA.operate(*, A, Any[A[1]])
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestBig

using Test

import LinearAlgebra
import MutableArithmetics as MA

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

function alloc_test(f::F, expected_upper_bound::Integer) where {F<:Function}
    f() # compile
    measured_allocations = @allocated f()
    @test measured_allocations <= expected_upper_bound
    return
end

function _test_allocation(
    op,
    T,
    short,
    short_to,
    n;
    a = T(2),
    b = T(3),
    c = T(4),
)
    @test MA.promote_operation(op, T, T) == T
    alloc_test(() -> MA.promote_operation(op, T, T), 0)
    if op != div && op != -
        @test MA.promote_operation(op, T, T, T) == T
        alloc_test(() -> MA.promote_operation(op, T, T, T), 0)
    end
    g = op(a, b)
    @test c === short_to(c, a, b)
    @test g == c
    A = MA.copy_if_mutable(a)
    @test A === short(A, b)
    @test g == A
    alloc_test(() -> short(A, b), n)
    alloc_test(() -> short_to(c, a, b), n)
    @test g == MA.buffered_operate!(nothing, op, MA.copy_if_mutable(a), b)
    @test g == MA.buffered_operate_to!(nothing, c, op, a, b)
    buffer = MA.buffer_for(op, typeof(a), typeof(b))
    @test g == MA.buffered_operate_to!(buffer, c, op, a, b)
    alloc_test(() -> MA.buffered_operate_to!(buffer, c, op, a, b), 0)
    return
end

function add_sub_mul_test(op, T; a = T(2), b = T(3), c = T(4))
    g = op(a, b, c)
    @test g == MA.buffered_operate!(nothing, op, MA.copy_if_mutable(a), b, c)
    buffer = MA.buffer_for(op, typeof(a), typeof(b), typeof(c))
    return alloc_test(() -> MA.buffered_operate!(buffer, op, a, b, c), 0)
end

test_int_test_BigInt() = MA.Test.int_test(BigInt)

test_int_test_BigFloat() = MA.Test.int_test(BigFloat)

test_int_test_Rational_BigInt() = MA.Test.int_test(Rational{BigInt})

test_allocation_BigInt() = _test_allocation(BigInt)

test_allocation_BigFloat() = _test_allocation(BigFloat)

test_allocation_Rational_BigInt() = _test_allocation(Rational{BigInt})

function _test_allocation(::Type{T}) where {T}
    MAX_ALLOC = T <: Rational ? 280 : 0
    _test_allocation(+, T, MA.add!!, MA.add_to!!, MAX_ALLOC)
    _test_allocation(-, T, MA.sub!!, MA.sub_to!!, MAX_ALLOC)
    _test_allocation(*, T, MA.mul!!, MA.mul_to!!, MAX_ALLOC)
    add_sub_mul_test(MA.add_mul, T)
    add_sub_mul_test(MA.sub_mul, T)
    if T <: Rational # https://github.com/jump-dev/MutableArithmetics.jl/issues/167
        _test_allocation(
            +,
            T,
            MA.add!!,
            MA.add_to!!,
            MAX_ALLOC,
            a = T(1 // 2),
            b = T(3 // 2),
            c = T(5 // 2),
        )
        _test_allocation(
            -,
            T,
            MA.sub!!,
            MA.sub_to!!,
            MAX_ALLOC,
            a = T(1 // 2),
            b = T(3 // 2),
            c = T(5 // 2),
        )
    end
    # Requires https://github.com/JuliaLang/julia/commit/3f92832df042198b2daefc1f7ca609db38cb8173
    # for `gcd` to be defined on `Rational`.
    if T == BigInt
        _test_allocation(div, T, MA.div!!, MA.div_to!!, 0)
    end
    if T == BigInt || T == Rational{BigInt}
        _test_allocation(gcd, T, MA.gcd!!, MA.gcd_to!!, 0)
        _test_allocation(lcm, T, MA.lcm!!, MA.lcm_to!!, 0)
    end
    return
end

function test_unary_neg()
    for x in BigFloat[-1.3, -1.0, -0.7, -0.0, 0.0, 0.3, 1.0, 1.7]
        backup = MA.copy_if_mutable(x)
        @test -(backup) == MA.operate!(-, x) == x
    end
    return
end

function test_unary_abs()
    for x in BigFloat[-1.3, -1.0, -0.7, -0.0, 0.0, 0.3, 1.0, 1.7]
        backup = MA.copy_if_mutable(x)
        @test abs(backup) == MA.operate!(abs, x) == x
    end
    return
end

function _test_fma_output_values(x::F, y::F, z::F) where {F<:BigFloat}
    two_roundings_reference = x * y + z
    one_rounding_reference = fma(x, y, z)
    @test one_rounding_reference != two_roundings_reference
    @testset "fma $op output values" for op in (MA.operate!, MA.operate!!)
        (a, b, c) = map(MA.copy_if_mutable, (x, y, z))
        @inferred op(fma, a, b, c)
        @test one_rounding_reference == a
        @test y == b
        @test z == c
    end
    @testset "fma $op output values" for op in (MA.operate_to!, MA.operate_to!!)
        (a, b, c) = map(MA.copy_if_mutable, (x, y, z))
        out = F()
        @inferred op(out, fma, a, b, c)
        @test one_rounding_reference == out
        @test x == a
        @test y == b
        @test z == c
    end
    return
end

function _test_fma_output_values(x::F, y::F, z::F) where {F<:Float64}
    return _test_fma_output_values(map(BigFloat, (x, y, z))...)
end

function _test_fma_output_values_func(x::F, y::F, z::F) where {F<:Float64}
    return let x = x, y = y, z = z
        () -> _test_fma_output_values(x, y, z)
    end
end

function test_fma_output_values()
    for exp_x in (-3):3, exp_y in (-3):3, sign_x in (-1, 1), sign_y in (-1, 1)
        _test_set_precision(exp_x, exp_y, sign_x, sign_y)
    end
    return
end

function _test_set_precision(exp_x, exp_y, sign_x, sign_y)
    # Assuming a two-bit mantissa
    significand_length = 2
    sign_z = -sign_x * sign_y
    exp_z = exp_x + exp_y
    base = 2.0
    bit_0 = 2.0^0
    bit_1 = 2.0^-1
    x = sign_x * base^exp_x * (bit_0 + bit_1)
    y = sign_y * base^exp_y * (bit_0 + bit_1)
    z = sign_z * base^exp_z * (bit_0 + bit_1)
    setprecision(
        _test_fma_output_values_func(x, y, z),
        BigFloat,
        significand_length,
    )
    return
end

function test_muladd_operate_to!!_type_inferred()
    m1 = BigFloat(-1.0)
    out = BigFloat()
    @test iszero(@inferred MA.operate_to!!(out, Base.muladd, m1, m1, m1))
    return
end

function test_muladd_operate!!_type_inferred()
    x = BigFloat(-1.0)
    y = BigFloat(-1.0)
    z = BigFloat(-1.0)
    @test iszero(@inferred MA.operate!!(Base.muladd, x, y, z))
    return
end

function test_fma_operate_to!_doesnt_allocate()
    alloc_test(let o = big"1.3", x = big"1.3"
        () -> MA.operate_to!(o, Base.fma, x, x, x)
    end, 0)
    return
end

function test_fma_operate_to!!_doesnt_allocate()
    alloc_test(let o = big"1.3", x = big"1.3"
        () -> MA.operate_to!!(o, Base.fma, x, x, x)
    end, 0)
    return
end

function test_fma_operate!_doesnt_allocate()
    alloc_test(let x = big"1.3", y = big"1.3", z = big"1.3"
        () -> MA.operate!(Base.fma, x, y, z)
    end, 0)
    return
end

function test_fma_operate!!_doesnt_allocate()
    alloc_test(let x = big"1.3", y = big"1.3", z = big"1.3"
        () -> MA.operate!!(Base.fma, x, y, z)
    end, 0)
    return
end

function test_precision()
    iters = Iterators.product(
        # These precisions (in bits) are most probably smaller than what
        # users would set in their code, but they are relevant anyway
        # because the compensated summation algorithm used for computing
        # the dot product is accurate independently of the machine
        # precision (except when vector lengths are really huge with
        # respect to the precision).
        (32, 64),
        # Compensated summation should be accurate even for very large
        # input vectors, so test that.
        (10000,),
        # The zero "bias" signifies that the input will be entirely
        # nonnegative (drawn from the interval [0, 1]), while a positive
        # bias shifts that interval towards negative infinity. We want to
        # test a few different values here, but we do not want to set the
        # bias to 0.5, because the expected value is then zero and there's
        # no guarantee on the relative error in that case.
        (0.0, 2^-2, 2^-2 + 2^-3 + 2^-4),
    )
    @testset "prec:$prec size:$size bias:$bias" for (prec, size, bias) in iters
        _test_precision(prec, size, bias)
    end
    return
end

function _test_precision(prec, size, bias)
    err = setprecision(BigFloat, prec) do
        maximum_relative_error = mapreduce(max, 1:10) do _
            # Generate some random vectors for dot(x, y) input.
            x = rand(BigFloat, size) .- bias
            y = rand(BigFloat, size) .- bias
            # Copy x and y so that we can check we haven't mutated them after
            # the fact.
            old_x, old_y = MA.copy_if_mutable(x), MA.copy_if_mutable(y)
            # Compute output = dot(x, y)
            buf = MA.buffer_for(
                LinearAlgebra.dot,
                Vector{BigFloat},
                Vector{BigFloat},
            )
            output = BigFloat()
            MA.buffered_operate_to!!(buf, output, LinearAlgebra.dot, x, y)
            # Check that we haven't mutated x or y
            @test old_x == x
            @test old_y == y
            # Compute dot(x, y) in larger precision. This will be used to
            # compare with our `dot`.
            accurate = setprecision(BigFloat, 8 * precision(BigFloat)) do
                    return LinearAlgebra.dot(x, y)
                end
            # Compute the relative error
            return abs(accurate - output) / abs(accurate)
        end
        # Return estimate for ULP
        return maximum_relative_error / eps(BigFloat)
    end
    @test 0 <= err < 1
    return
end

function _alloc_test_helper(
    buf::B,
    output::BigFloat,
    x::Vector{BigFloat},
    y::Vector{BigFloat},
) where {B<:Any}
    let b = buf, o = output, x = x, y = y
        () -> MA.buffered_operate_to!!(b, o, LinearAlgebra.dot, x, y)
    end
end

function test_alloc()
    x = rand(BigFloat, 1000)
    y = rand(BigFloat, 1000)
    V = Vector{BigFloat}
    buffer = MA.buffer_for(LinearAlgebra.dot, V, V)
    alloc_test(_alloc_test_helper(buffer, BigFloat(), x, y), 0)
    return
end

end  # TestBig

TestBig.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestRewrite

using Test

import MutableArithmetics as MA
import OffsetArrays

include(joinpath(@__DIR__, "dummy.jl"))

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        @testset "$T" for T in (
            Int,
            Float64,
            BigInt,
            BigFloat,
            Rational{Int},
            Rational{BigInt},
            DummyBigInt,
        )
            getfield(@__MODULE__, name)(T)
        end
    end
    return
end

# Test that the macro call `m` throws an error exception during pre-compilation
macro test_macro_throws(error, m)
    # See https://discourse.julialang.org/t/test-throws-with-macros-after-pr-23533/5878
    return quote
        @test_throws $(esc(error)) try
            @eval $m
        catch catched_error
            throw(catched_error.error)
        end
    end
end

function test_is_supported_test(::Type{T}) where {T}
    @test MA.Test._is_supported(*, T, T)
    @test MA.Test._is_supported(+, T, T)
    return
end

function test_Error(::Type{T}) where {T}
    x, y, z = T(1), T(2), T(3)
    err = ErrorException(
        "The curly syntax (sum{},prod{},norm2{}) is no longer supported. Expression: `sum{(i for i = 1:2)}`.",
    )
    @test_macro_throws err MA.@rewrite sum{i for i in 1:2}
    err = ErrorException("Unexpected comparison in expression `z >= y`.")
    @test_macro_throws err MA.@rewrite z >= y
    err = ErrorException("Unexpected comparison in expression `y <= z`.")
    @test_macro_throws err MA.@rewrite y <= z
    err = ErrorException("Unexpected comparison in expression `x <= y <= z`.")
    @test_macro_throws err MA.@rewrite x <= y <= z
    return
end

function test_Scalar(::Type{T}) where {T}
    MA.Test.scalar_test(T(2))
    MA.Test.scalar_test(T(3))
    return
end

function test_Quadratic(::Type{T}) where {T}
    exclude = T == DummyBigInt ? ["quadratic_division"] : String[]
    MA.Test.quadratic_test(T(1), T(2), T(3), T(4); exclude)
    return
end

function test_Sparse(::Type{T}) where {T}
    return MA.Test.sparse_test(T(4), T(5), T[8 1 9; 4 3 1; 2 0 8])
end

_exclude(::Type{DummyBigInt}) = ["broadcast_division", "matrix_vector_division"]

_exclude(::Type{<:Rational}) = ["broadcast_division"]

_exclude(::Type) = String[]

function test_Vector(::Type{T}) where {T}
    exclude = _exclude(T)
    MA.Test.array_test(T[-7, 1, 4]; exclude)
    MA.Test.array_test(T[3, 2, 6]; exclude)
    return
end

function test_Square_Matrix(::Type{T}) where {T}
    exclude = _exclude(T)
    MA.Test.array_test(T[1 2; 2 4]; exclude)
    MA.Test.array_test(T[2 4; -1 3]; exclude)
    MA.Test.array_test(T[0 -4; 6 -5]; exclude)
    MA.Test.array_test(T[5 1 9; -7 2 4; -2 -7 5]; exclude)
    return
end

function test_non_square_matrix(::Type{T}) where {T}
    exclude = _exclude(T)
    MA.Test.array_test(T[5 1 9; -7 2 4]; exclude)
    return
end

function test_tensor(::Type{T}) where {T}
    exclude = _exclude(T)
    S = zeros(T, 2, 2, 2)
    S[1, :, :] = T[5 -8; 3 -7]
    S[2, :, :] = T[-2 8; 8 -1]
    MA.Test.array_test(S; exclude)
    return
end

function test_offset_array(::Type{T}) where {T}
    x = T[2, 4, 3]
    MA.Test.non_array_test(x, OffsetArrays.OffsetArray(x, -length(x)))
    return
end

end  # TestRewrite

TestRewrite.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function quadratic_division_test(w, x, y, z)
    @test_rewrite w / 2
    a = 7
    b = 2
    aff = @inferred a * x + b
    @test_rewrite aff / 2
    q = @inferred b * y * z + aff
    @test_rewrite q / 2
end

function quadratic_iszero_test(w, x, y, z)
    @test !iszero(x)
    a = 7
    b = 2
    aff = @inferred a * x + b
    @test !iszero(aff)
    @test iszero(zero(typeof(aff)))
    q = @inferred b * y * z + aff
    @test !iszero(q)
    @test iszero(zero(typeof(q)))
end

function quadratic_isequal_canonical_test(w, x, y, z)
    a = 7
    b = 2
    c = 1
    @test MA.isequal_canonical((@inferred 3w + 2y), @inferred 2y + 3w)
    @test !MA.isequal_canonical((@inferred 3w + 2y + 1), @inferred 3w + 2y)
    if !MA.isequal_canonical(w, y)
        @test !MA.isequal_canonical((@inferred 3w + 2y), @inferred 3y + 2w)
    end
    if !MA.isequal_canonical(w, y)
        @test !MA.isequal_canonical((@inferred 3w + 2y), @inferred 3w + y)
    end

    aff = @inferred a * x + b
    aff2 = @inferred c * y + c
    @test !MA.isequal_canonical(aff, aff2)
    @test !MA.isequal_canonical(aff2, aff)

    @test MA.isequal_canonical(
        MA.sub_mul(MA.add_mul(aff, c, y), a, x) + c - b,
        aff2,
    )
    @test MA.isequal_canonical(
        MA.sub_mul(MA.add_mul(aff2, a, x), c, y) + b - c,
        aff,
    )

    q = @inferred b * y * z + aff
    if MA.isequal_canonical(y * z, z * y)
        @test MA.isequal_canonical(q, @inferred b * z * y + aff)
    end
    @test !MA.isequal_canonical(q, @inferred b * y * z + aff2)
    if !MA.isequal_canonical(x, y)
        @test !MA.isequal_canonical(q, @inferred b * x * z + aff)
    end
    if !MA.isequal_canonical(x, z)
        @test !MA.isequal_canonical(q, @inferred b * y * x + aff)
    end
    @test !MA.isequal_canonical(q, @inferred (b - 1) * y * z + aff)

    q2 = @inferred 8 * x * z + aff2
    if MA.isequal_canonical(x * z, z * x)
        @test MA.isequal_canonical(q2, @inferred 8z * x + aff2)
    end
    @test !MA.isequal_canonical(q2, @inferred 8x * z + aff)
    @test !MA.isequal_canonical(q2, @inferred 7x * z + aff2)
    if !MA.isequal_canonical(y, z)
        @test !MA.isequal_canonical(q2, @inferred 8x * y + aff2)
    end
    if !MA.isequal_canonical(x, y)
        @test !MA.isequal_canonical(q2, @inferred 8y * z + aff2)
    end
end

function quadratic_add_test(w, x, y, z)
    w_copy = MA.copy_if_mutable(w)
    x_copy = MA.copy_if_mutable(x)
    y_copy = MA.copy_if_mutable(y)
    z_copy = MA.copy_if_mutable(z)
    a = 7
    b = 2
    c = 1

    @testset "Variable--???" begin
        # 2-0 Variable unary
        @test (+x) === x
        @test w == w
        unary_test(x)
        add_test(x, x)
        add_test(x, w)
        add_test(w, 4)
        add_test(w, 3)
        @test_rewrite w * 4
        @test_rewrite x * y - 1
        @test_rewrite x^2
        @test_rewrite x^1
        @test_rewrite x^0
        @test_rewrite w * x
        @test_rewrite y * z - x
    end

    @test MA.isequal_canonical(w, w_copy)
    @test MA.isequal_canonical(x, x_copy)
    @test MA.isequal_canonical(y, y_copy)
    @test MA.isequal_canonical(z, z_copy)

    aff = @inferred a * x + b
    @test_rewrite a * x + b
    @test aff == aff
    aff2 = @inferred c * y + c
    @test_rewrite c * y + c

    @test MA.isequal_canonical(w, w_copy)
    @test MA.isequal_canonical(x, x_copy)
    @test MA.isequal_canonical(y, y_copy)
    @test MA.isequal_canonical(z, z_copy)

    @testset "Affine" begin
        unary_test(aff)
        add_test(aff, aff)
        add_test(aff, 1)
        add_test(aff, z)
        add_test(aff, aff2)
        @test_rewrite 7 * x - aff
        @test_rewrite aff^2
        @test_rewrite (a * x + b)^2
        @test_rewrite aff^1
        @test_rewrite (a * x + b)^1
        @test_rewrite aff^0
        @test_rewrite (a * x + b)^0
        # 3-2 AffExpr--Variable
        @test_rewrite aff * z
        @test_rewrite aff - a * x
        # 3-3 AffExpr--AffExpr
        @test_rewrite aff * aff2
    end

    @test MA.isequal_canonical(w, w_copy)
    @test MA.isequal_canonical(x, x_copy)
    @test MA.isequal_canonical(y, y_copy)
    @test MA.isequal_canonical(z, z_copy)

    @testset "Quadratic" begin
        @test_rewrite 2 * x * x + 1 * y * y + z + 3

        @test_rewrite b * y * z + aff
        q = @inferred b * y * z + aff
        @test q == q
        unary_test(q)
        add_test(q, q)
        add_test(q, 1)
        add_test(q, w)
        add_test(q, aff2)

        @test_rewrite 8 * x * z + aff2
        q2 = @inferred 8 * x * z + aff2
        add_test(q, q2)

        vx = [x]
        vy = [z]
        v1 = [1]
        @test_rewrite (1 + vx'vy) * 1
        @test_rewrite (1 + vx'v1) * x
        @test_rewrite (1 + v1'vy) * y
    end

    @test MA.isequal_canonical(w, w_copy)
    @test MA.isequal_canonical(x, x_copy)
    @test MA.isequal_canonical(y, y_copy)
    @test MA.isequal_canonical(z, z_copy)
end

const quadratic_tests = Dict(
    "quadratic_division" => quadratic_division_test,
    "quadratic_iszero" => quadratic_iszero_test,
    "quadratic_isequal_canonical" => quadratic_isequal_canonical_test,
    "quadratic_add_canonical" => quadratic_add_test,
)

@test_suite quadratic

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# This file contains methods to implement the MutableArithmetics API for types
# in the LinearAlgebra stdlib.

mutability(::Type{<:Array}) = IsMutable()

mutable_copy(A::Array) = copy_if_mutable.(A)

# Sum

# By default, we assume the return value is an `Array` because having a
# different method for all combinations of cases would be cumbersome. A more
# specific method could be implemented for specific cases.
function promote_operation(
    op::Union{typeof(+),typeof(-)},
    ::Type{<:AbstractArray{S,N}},
    ::Type{<:AbstractArray{T,M}},
) where {S,T,N,M}
    # If `N != M`, we need the axes between `min(N,M)+1` and `max(N,M)` to be
    # `Base.OneTo(1)`. In any cases, the axes from `1` to `min(N,M)` must also
    # match.
    return Array{promote_operation(op, S, T),max(N, M)}
end

function promote_operation(
    op::Union{typeof(+),typeof(-)},
    ::Type{LinearAlgebra.UniformScaling{S}},
    ::Type{Matrix{T}},
) where {S,T}
    return Matrix{promote_operation(op, S, T)}
end

function promote_operation(
    op::Union{typeof(+),typeof(-)},
    ::Type{Matrix{T}},
    ::Type{LinearAlgebra.UniformScaling{S}},
) where {S,T}
    return Matrix{promote_operation(op, S, T)}
end

# Only `Scaling`
function operate!(
    op::Union{typeof(+),typeof(-)},
    A::Matrix,
    B::LinearAlgebra.UniformScaling,
)
    n = LinearAlgebra.checksquare(A)
    for i in 1:n
        A[i, i] = operate!!(op, A[i, i], B)
    end
    return A
end

function operate!(
    op::AddSubMul,
    A::Matrix,
    B::Scaling,
    C::Scaling,
    D::Vararg{Scaling,N},
) where {N}
    return operate!(add_sub_op(op), A, *(B, C, D...))
end

# TODO(odow): these are the only cases that appear in all of JuliaHub. They
# should become private.
mul_rhs(::typeof(+)) = add_mul
mul_rhs(::typeof(-)) = sub_mul

# We redirect the mutable `A + B` into `A .+ B`.
# To be consistent with Julia Base, we first call `promote_shape`
# which throws an error if the broadcasted dimension are not singleton
# and we check that the axes of `A` are indeed the axes of the array
# that would be returned in Julia Base (maybe we could relax this ?).
function _check_dims(A, B)
    if axes(A) != promote_shape(A, B)
        throw(
            DimensionMismatch(
                "Cannot sum or substract a matrix of axes `$(axes(B))` into" *
                " matrix of axes `$(axes(A))`, expected axes" *
                " `$(promote_shape(A, B))`.",
            ),
        )
    end
    return
end

function operate!(
    op::Union{typeof(+),typeof(-)},
    A::AbstractArray,
    B::AbstractArray,
)
    _check_dims(A, B)
    return broadcast!(op, A, B)
end

function operate_to!(
    output::AbstractArray,
    op::Union{typeof(+),typeof(-)},
    A::AbstractArray,
)
    if axes(output) != axes(A)
        throw(
            DimensionMismatch(
                "Cannot sum or substract a matrix of axes `$(axes(A))`" *
                " into a matrix of axes `$(axes(output))`, expected" *
                " axes `$(axes(A))`.",
            ),
        )
    end
    # We don't have `MA.broadcast_to!` as it would be exactly `Base.broadcast!`.
    return Base.broadcast!(op, output, A)
end

function operate_to!(
    output::AbstractArray,
    op::Union{typeof(+),typeof(-)},
    A::AbstractArray,
    B::AbstractArray,
)
    if axes(output) != promote_shape(A, B)
        throw(
            DimensionMismatch(
                "Cannot sum or substract matrices of axes `$(axes(A))` and" *
                " `$(axes(B))` into a matrix of axes `$(axes(output))`," *
                " expected axes `$(promote_shape(A, B))`.",
            ),
        )
    end
    # We don't have `MA.broadcast_to!` as it would be exactly `Base.broadcast!`.
    return Base.broadcast!(op, output, A, B)
end

# We call `scaling_to_number` as `UniformScaling` do not support broadcasting
function operate!(
    op::AddSubMul,
    A::AbstractArray,
    B::AbstractArray,
    α::Vararg{Scaling,M},
) where {M}
    _check_dims(A, B)
    return broadcast!(op, A, B, scaling_to_number.(α)...)
end

function operate!(
    op::AddSubMul,
    A::AbstractArray,
    α::Scaling,
    B::AbstractArray,
    β::Vararg{Scaling,M},
) where {M}
    _check_dims(A, B)
    return broadcast!(op, A, scaling_to_number(α), B, scaling_to_number.(β)...)
end

function operate!(
    op::AddSubMul,
    A::AbstractArray,
    α1::Scaling,
    α2::Scaling,
    B::AbstractArray,
    β::Vararg{Scaling,M},
) where {M}
    _check_dims(A, B)
    return broadcast!(
        op,
        A,
        scaling_to_number(α1),
        scaling_to_number(α2),
        B,
        scaling_to_number.(β)...,
    )
end

# Fallback, we may be able to be more efficient in more cases by adding more
# specialized methods.
function operate!(op::AddSubMul, A::AbstractArray, x, y)
    return operate!(op, A, x * y)
end

function operate!(
    op::AddSubMul,
    A::AbstractArray,
    x,
    y,
    args::Vararg{Any,N},
) where {N}
    @assert N > 0
    return operate!(op, A, x, *(y, args...))
end

# Product

function similar_array_type(
    ::Type{LinearAlgebra.Symmetric{T,MT}},
    ::Type{S},
) where {S,T,MT}
    return LinearAlgebra.Symmetric{S,similar_array_type(MT, S)}
end

function similar_array_type(
    ::Type{LinearAlgebra.Diagonal{T,VT}},
    ::Type{S},
) where {S,T,VT<:AbstractVector{T}}
    return LinearAlgebra.Diagonal{S,similar_array_type(VT, S)}
end

similar_array_type(::Type{<:AbstractVector}, ::Type{T}) where {T} = Vector{T}
similar_array_type(::Type{Array{T,N}}, ::Type{S}) where {S,T,N} = Array{S,N}

similar_array_type(::Type{BitArray{N}}, ::Type{S}) where {S,N} = Array{S,N}
similar_array_type(::Type{BitArray{N}}, ::Type{Bool}) where {N} = BitArray{N}

function similar_array_type(
    ::Type{<:SubArray{T,N,<:Array{T}}},
    ::Type{S},
) where {S,T,N}
    return Array{S,N}
end

function promote_operation(
    op::typeof(*),
    A::Type{<:AbstractArray{T}},
    ::Type{S},
) where {S,T}
    return similar_array_type(A, promote_operation(op, T, S))
end

function promote_operation(
    op::typeof(*),
    ::Type{S},
    A::Type{<:AbstractArray{T}},
) where {S,T}
    return similar_array_type(A, promote_operation(op, S, T))
end

# `{S}` and `{T}` are used to avoid ambiguity with above methods.
function promote_operation(
    ::typeof(*),
    A::Type{<:AbstractArray{S}},
    B::Type{<:AbstractArray{T}},
) where {S,T}
    return promote_array_mul(A, B)
end

function promote_sum_mul(T::Type, S::Type)
    U = promote_operation(*, T, S)
    return promote_operation(+, U, U)
end

function promote_array_mul(::Type{Matrix{S}}, ::Type{Vector{T}}) where {S,T}
    return Vector{promote_sum_mul(S, T)}
end

function promote_array_mul(
    ::Type{<:AbstractMatrix{S}},
    ::Type{<:AbstractMatrix{T}},
) where {S,T}
    return Matrix{promote_sum_mul(S, T)}
end

function promote_array_mul(
    ::Type{<:AbstractVector{S}},
    ::Type{<:LinearAlgebra.Adjoint{T,<:AbstractVector{T}}},
) where {S,T}
    return Matrix{promote_operation(*, S, T)}
end

function promote_array_mul(
    ::Type{<:AbstractVector{S}},
    ::Type{<:LinearAlgebra.Transpose{T,<:AbstractVector{T}}},
) where {S,T}
    return Matrix{promote_operation(*, S, T)}
end

function promote_array_mul(
    ::Type{<:AbstractMatrix{S}},
    ::Type{<:AbstractVector{T}},
) where {S,T}
    return Vector{promote_sum_mul(S, T)}
end

function _dim_check(C::AbstractVector, A::AbstractMatrix, B::AbstractVector)
    mB = length(B)
    mA, nA = size(A)
    if mB != nA
        throw(
            DimensionMismatch(
                "matrix A has dimensions ($mA,$nA), vector B has length $mB",
            ),
        )
    end
    if mA != length(C)
        throw(
            DimensionMismatch(
                "result C has length $(length(C)), needs length $mA",
            ),
        )
    end
    return
end

function _dim_check(C::AbstractMatrix, A::AbstractMatrix, B::AbstractMatrix)
    mB, nB = size(B)
    mA, nA = size(A)
    if mB != nA
        throw(
            DimensionMismatch(
                "matrix A has dimensions ($mA,$nA), matrix B has dimensions ($mB,$nB)",
            ),
        )
    end
    if size(C, 1) != mA || size(C, 2) != nB
        throw(
            DimensionMismatch(
                "result C has dimensions $(size(C)), needs ($mA,$nB)",
            ),
        )
    end
    return
end

function buffered_operate!(
    buffer,
    ::typeof(add_mul),
    C::Vector,
    A::AbstractMatrix,
    B::AbstractVector,
)
    _dim_check(C, A, B)
    for (ci, ai) in zip(axes(C, 1), axes(A, 1))
        for (aj, bj) in zip(axes(A, 2), axes(B, 1))
            C[ci] = buffered_operate!!(buffer, add_mul, C[ci], A[ai, aj], B[bj])
        end
    end
    return C
end

function buffered_operate!(
    buffer,
    ::typeof(add_mul),
    C::Matrix,
    A::AbstractMatrix,
    B::AbstractMatrix,
)
    _dim_check(C, A, B)
    for (ci, ai) in zip(axes(C, 1), axes(A, 1))
        for (cj, bj) in zip(axes(C, 2), axes(B, 2))
            for (aj, bi) in zip(axes(A, 2), axes(B, 1))
                C[ci, cj] = buffered_operate!!(
                    buffer,
                    add_mul,
                    C[ci, cj],
                    A[ai, aj],
                    B[bi, bj],
                )
            end
        end
    end
    return C
end

function buffer_for(
    ::typeof(add_mul),
    ::Type{<:VecOrMat{S}},
    ::Type{<:AbstractMatrix{T}},
    ::Type{<:AbstractVecOrMat{U}},
) where {S,T,U}
    return buffer_for(add_mul, S, T, U)
end

function operate!(
    ::typeof(add_mul),
    C::VecOrMat,
    A::AbstractMatrix,
    B::AbstractVecOrMat,
)
    buffer = buffer_for(add_mul, typeof(C), typeof(A), typeof(B))
    return buffered_operate!(buffer, add_mul, C, A, B)
end

function operate!(::typeof(zero), C::Union{Vector,Matrix})
    # C may contain undefined values so we cannot call `zero!`
    for i in eachindex(C)
        @inbounds C[i] = zero(eltype(C))
    end
    return
end

function operate_to!(
    C::AbstractArray,
    ::typeof(*),
    A::AbstractArray,
    B::AbstractArray,
)
    operate!(zero, C)
    return operate!(add_mul, C, A, B)
end

function undef_array(::Type{Array{T,N}}, axes::Vararg{Base.OneTo,N}) where {T,N}
    return Array{T,N}(undef, length.(axes))
end

# This method is for things like StaticArrays which return something other than
# Base.OneTo for their axes. It isn't typed because there can be a mix of axes
# in the call.
function undef_array(::Type{T}, axes...) where {T}
    return undef_array(T, convert.(Base.OneTo, axes)...)
end

# Does what `LinearAlgebra/src/matmul.jl` does for abstract matrices and
# vectors: estimate the resulting element type, allocate the resulting array but
# it redirects to `mul_to!` instead of `LinearAlgebra.mul!`.
function operate(
    ::typeof(*),
    A::AbstractMatrix{S},
    B::AbstractVector{T},
) where {T,S}
    # Only use the efficient in-place operate_to! if both arrays are
    # concrete. Bad things can happen if S or T is abstract and we pick the
    # wrong type for C.
    if !(isconcretetype(S) && isconcretetype(T))
        if S <: AbstractMutable || T <: AbstractMutable
            # We can't use A * B here, because this will StackOverflow via:
            #   *(A, B) -> mul(A, B) -> operate(*, A, B) -> *(A, B)
            # See MutableArithmetics.jl#336
            if axes(A, 2) != axes(B, 1)
                throw(DimensionMismatch())
            end
            return [sum(A[i, j] * B[j] for j in axes(B, 1)) for i in axes(A, 1)]
        end
        return A * B
    end
    C = undef_array(promote_array_mul(typeof(A), typeof(B)), axes(A, 1))
    return operate_to!(C, *, A, B)
end

function operate(
    ::typeof(*),
    A::AbstractMatrix{S},
    B::AbstractMatrix{T},
) where {T,S}
    # Only use the efficient in-place operate_to! if both arrays are
    # concrete. Bad things can happen if S or T is abstract and we pick the
    # wrong type for C.
    if !(isconcretetype(S) && isconcretetype(T))
        # It's safe to use A * B here, because there is no fallback for
        #   *(A, B) -> mul(A, B) -> operate(*, A, B)
        # See MutableArithmetics.jl#336
        return A * B
    end
    C = undef_array(
        promote_array_mul(typeof(A), typeof(B)),
        axes(A, 1),
        axes(B, 2),
    )
    return operate_to!(C, *, A, B)
end

const _TransposeOrAdjoint{T,MT} =
    Union{LinearAlgebra.Transpose{T,MT},LinearAlgebra.Adjoint{T,MT}}

function _mirror_transpose_or_adjoint(x, ::LinearAlgebra.Transpose)
    return LinearAlgebra.transpose(x)
end

function _mirror_transpose_or_adjoint(x, ::LinearAlgebra.Adjoint)
    return LinearAlgebra.adjoint(x)
end

function _mirror_transpose_or_adjoint(
    A::Type{<:AbstractArray{T}},
    ::Type{<:LinearAlgebra.Transpose},
) where {T}
    return LinearAlgebra.Transpose{T,A}
end

function _mirror_transpose_or_adjoint(
    A::Type{<:AbstractArray{T}},
    ::Type{<:LinearAlgebra.Adjoint},
) where {T}
    return LinearAlgebra.Adjoint{T,A}
end

function similar_array_type(
    TA::Type{<:_TransposeOrAdjoint{T,A}},
    ::Type{S},
) where {S,T,A}
    return _mirror_transpose_or_adjoint(similar_array_type(A, S), TA)
end

# dot product

function promote_array_mul(
    ::Type{<:_TransposeOrAdjoint{S,<:AbstractVector}},
    ::Type{<:AbstractVector{T}},
) where {S,T}
    return promote_sum_mul(S, T)
end

function promote_array_mul(
    A::Type{<:_TransposeOrAdjoint{S,V}},
    M::Type{<:AbstractMatrix{T}},
) where {S,T,V<:AbstractVector}
    B = promote_array_mul(_mirror_transpose_or_adjoint(M, A), V)
    return _mirror_transpose_or_adjoint(B, A)
end

function operate(
    ::typeof(*),
    x::LinearAlgebra.Adjoint{<:Any,<:AbstractVector},
    y::AbstractVector,
)
    return operate(LinearAlgebra.dot, parent(x), y)
end

function operate(
    ::typeof(*),
    x::_TransposeOrAdjoint{<:Any,<:AbstractVector},
    y::AbstractMatrix,
)
    return _mirror_transpose_or_adjoint(
        operate(*, _mirror_transpose_or_adjoint(y, x), parent(x)),
        x,
    )
end

function operate(
    ::typeof(*),
    x::_TransposeOrAdjoint{<:Any,<:AbstractVector},
    y::AbstractVector,
)
    return fused_map_reduce(add_mul, x, y)
end

function operate(
    ::typeof(LinearAlgebra.dot),
    x::AbstractArray,
    y::AbstractArray,
)
    return fused_map_reduce(add_dot, x, y)
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# This file contains methods to implement the MutableArithmetics API for
# Base.BigInt.

mutability(::Type{BigInt}) = IsMutable()
mutability(::Type{BigInt}, ::typeof(copy), ::Vararg{Type}) = IsMutable()

# Copied from `deepcopy_internal` implementation in Julia:
# https://github.com/JuliaLang/julia/blob/7d41d1eb610cad490cbaece8887f9bbd2a775021/base/gmp.jl#L772
mutable_copy(x::BigInt) = Base.GMP.MPZ.set(x)

# copy

promote_operation(::typeof(copy), ::Type{BigInt}) = BigInt

function operate_to!(
    out::BigInt,
    ::typeof(copy),
    in::Union{Bool,Int8,Int16,Int32,Clong,UInt8,UInt16,UInt32,Culong,BigInt},
)
    let f!
        if in isa BigInt
            f! = Base.GMP.MPZ.set!
        elseif in isa Union{Bool,Unsigned}
            f! = Base.GMP.MPZ.set_ui!
        elseif in isa Signed
            f! = Base.GMP.MPZ.set_si!
        end
        f!(out, in)
    end
    return out
end

operate!(::typeof(copy), x::BigInt) = x

# zero

promote_operation(::typeof(zero), ::Type{BigInt}) = BigInt

operate!(::typeof(zero), x::BigInt) = operate_to!(x, copy, false)

# one

promote_operation(::typeof(one), ::Type{BigInt}) = BigInt

operate!(::typeof(one), x::BigInt) = operate_to!(x, copy, true)

# +

promote_operation(::typeof(+), ::Type{BigInt}, ::Type{BigInt}) = BigInt

function operate_to!(output::BigInt, ::typeof(+), a::BigInt, b::BigInt)
    return Base.GMP.MPZ.add!(output, a, b)
end

operate_to!(out::BigInt, ::typeof(+), a::BigInt) = operate_to!(out, copy, a)

operate!(::typeof(+), a::BigInt) = a

# -

promote_operation(::typeof(-), ::Vararg{Type{BigInt},N}) where {N} = BigInt

function operate_to!(output::BigInt, ::typeof(-), a::BigInt, b::BigInt)
    return Base.GMP.MPZ.sub!(output, a, b)
end

operate_to!(out::BigInt, ::typeof(-), a::BigInt) = Base.GMP.MPZ.neg!(out, a)

operate!(::typeof(-), a::BigInt) = operate_to!(a, -, a)

# abs

promote_operation(::typeof(abs), ::Type{BigInt}) = BigInt

function operate!(::typeof(abs), n::BigInt)
    n.size = abs(n.size)
    return n
end

function operate_to!(o::BigInt, ::typeof(abs), n::BigInt)
    operate_to!(o, copy, n)
    return operate!(abs, o)
end

# *

promote_operation(::typeof(*), ::Type{BigInt}, ::Type{BigInt}) = BigInt

function operate_to!(output::BigInt, ::typeof(*), a::BigInt, b::BigInt)
    return Base.GMP.MPZ.mul!(output, a, b)
end

operate_to!(out::BigInt, ::typeof(*), a::BigInt) = operate_to!(out, copy, a)

operate!(::typeof(*), a::BigInt) = a

promote_operation(::typeof(div), ::Type{BigInt}, ::Type{BigInt}) = BigInt

function operate_to!(output::BigInt, ::typeof(div), a::BigInt, b::BigInt)
    return Base.GMP.MPZ.tdiv_q!(output, a, b)
end

# gcd

function promote_operation(
    ::Union{typeof(gcd),typeof(lcm)},
    ::Type{BigInt},
    ::Type{BigInt},
)
    return BigInt
end

function operate_to!(output::BigInt, ::typeof(gcd), a::BigInt, b::BigInt)
    return Base.GMP.MPZ.gcd!(output, a, b)
end

function operate_to!(output::BigInt, ::typeof(lcm), a::BigInt, b::BigInt)
    return Base.GMP.MPZ.lcm!(output, a, b)
end

function operate_to!(
    output::BigInt,
    op::Union{typeof(gcd),typeof(lcm)},
    a::BigInt,
    b::BigInt,
    c::Vararg{BigInt,N},
) where {N}
    operate_to!(output, op, a, b)
    return operate!(op, output, c...)
end

function operate_to!(
    output::BigInt,
    op::Union{typeof(+),typeof(-),typeof(*)},
    a::BigInt,
    b::BigInt,
    c::Vararg{BigInt,N},
) where {N}
    operate_to!(output, op, a, b)
    return operate!(op, output, c...)
end

function operate!(op::Function, x::BigInt, args::Vararg{Any,N}) where {N}
    return operate_to!(x, op, x, args...)
end

# add_mul and sub_mul

# Buffer to hold the product
buffer_for(::AddSubMul, args::Vararg{Type{BigInt},N}) where {N} = BigInt()

function operate_to!(
    output::BigInt,
    op::AddSubMul,
    x::BigInt,
    y::BigInt,
    z::BigInt,
    args::Vararg{BigInt,N},
) where {N}
    return buffered_operate_to!(BigInt(), output, op, x, y, z, args...)
end

function buffered_operate_to!(
    buffer::BigInt,
    output::BigInt,
    op::AddSubMul,
    a::BigInt,
    x::BigInt,
    y::BigInt,
    args::Vararg{BigInt,N},
) where {N}
    operate_to!(buffer, *, x, y, args...)
    return operate_to!(output, add_sub_op(op), a, buffer)
end

function buffered_operate!(
    buffer::BigInt,
    op::AddSubMul,
    x::BigInt,
    args::Vararg{Any,N},
) where {N}
    return buffered_operate_to!(buffer, x, op, x, args...)
end

function _scaling_to(::Type{T}, x) where {T}
    return convert(T, scaling_to_number(x))
end

_scaling_to_bigint(x) = _scaling_to(BigInt, x)

function operate_to!(
    output::BigInt,
    op::Union{
        typeof(+),
        typeof(-),
        typeof(*),
        typeof(div),
        typeof(gcd),
        typeof(lcm),
    },
    args::Vararg{Scaling,N},
) where {N}
    return operate_to!(output, op, _scaling_to_bigint.(args)...)
end

function operate_to!(
    output::BigInt,
    op::AddSubMul,
    x::Scaling,
    y::Scaling,
    z::Scaling,
    args::Vararg{Scaling,N},
) where {N}
    return operate_to!(
        output,
        op,
        _scaling_to_bigint(x),
        _scaling_to_bigint(y),
        _scaling_to_bigint(z),
        _scaling_to_bigint.(args)...,
    )
end

# Called for instance if `args` is `(v', v)` for a vector `v`.
function operate_to!(
    output::BigInt,
    op::AddSubMul,
    x,
    y,
    z,
    args::Vararg{Any,N},
) where {N}
    return operate_to!(output, add_sub_op(op), x, *(y, z, args...))
end

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

@testset "prec:$prec size:$size bias:$bias" for (prec, size, bias) in
                                                Iterators.product(
    # These precisions (in bits) are most probably smaller than what
    # users would set in their code, but they are relevant anyway
    # because the compensated summation algorithm used for computing
    # the dot product is accurate independently of the machine
    # precision (except when vector lengths are really huge with
    # respect to the precision).
    (32, 64),
    # Compensated summation should be accurate even for very large
    # input vectors, so test that.
    (10000,),
    # The zero "bias" signifies that the input will be entirely
    # nonnegative (drawn from the interval [0, 1]), while a positive
    # bias shifts that interval towards negative infinity. We want to
    # test a few different values here, but we do not want to set the
    # bias to 0.5, because the expected value is then zero and there's
    # no guarantee on the relative error in that case.
    (0.0, 2^-2, 2^-2 + 2^-3 + 2^-4),
)
    err = setprecision(BigFloat, prec) do
        maximum_relative_error = mapreduce(max, 1:10) do _
            # Generate some random vectors for dot(x, y) input.
            x = rand(BigFloat, size) .- bias
            y = rand(BigFloat, size) .- bias
            # Copy x and y so that we can check we haven't mutated them after
            # the fact.
            old_x, old_y = MA.copy_if_mutable(x), MA.copy_if_mutable(y)
            # Compute output = dot(x, y)
            buf = MA.buffer_for(
                LinearAlgebra.dot,
                Vector{BigFloat},
                Vector{BigFloat},
            )
            output = BigFloat()
            MA.buffered_operate_to!!(buf, output, LinearAlgebra.dot, x, y)
            # Check that we haven't mutated x or y
            @test old_x == x
            @test old_y == y
            # Compute dot(x, y) in larger precision. This will be used to
            # compare with our `dot`.
            accurate = setprecision(BigFloat, 8 * precision(BigFloat)) do
                    return LinearAlgebra.dot(x, y)
                end
            # Compute the relative error
            return abs(accurate - output) / abs(accurate)
        end
        # Return estimate for ULP
        return maximum_relative_error / eps(BigFloat)
    end
    @test 0 <= err < 1
end

function alloc_test_helper(
    buf::B,
    output::BigFloat,
    x::Vector{BigFloat},
    y::Vector{BigFloat},
) where {B<:Any}
    let b = buf, o = output, x = x, y = y
        () -> MA.buffered_operate_to!!(b, o, LinearAlgebra.dot, x, y)
    end
end

@testset "alloc" begin
    x = rand(BigFloat, 1000)
    y = rand(BigFloat, 1000)
    V = Vector{BigFloat}
    alloc_test(
        alloc_test_helper(
            MA.buffer_for(LinearAlgebra.dot, V, V),
            BigFloat(),
            x,
            y,
        ),
        0,
    )
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# This file contains methods to implement the MutableArithmetics API for a new
# MutatingStepRange type. This feature was originally designed because of a
# discussion in the julialang/julia issue #39008:
# https://github.com/JuliaLang/julia/issues/39008

struct MutatingStepRange{T,S} <: OrdinalRange{T,S}
    start::T
    step::S
    stop::T
    function MutatingStepRange{T,S}(start::T, step::S, stop::T) where {T,S}
        return new(start, step, Base.steprange_last(start, step, stop))
    end
end

function MutatingStepRange(start::T, step::S, stop::T) where {T,S}
    return MutatingStepRange{T,S}(start, step, stop)
end

Base.step(r::MutatingStepRange) = r.step

function Base.unsafe_length(r::MutatingStepRange)
    n = Integer(div((r.stop - r.start) + r.step, r.step))
    return isempty(r) ? zero(n) : n
end

Base.length(r::MutatingStepRange) = Base.unsafe_length(r)

function Base.isempty(r::MutatingStepRange)
    return (r.start != r.stop) & ((r.step > zero(r.step)) != (r.stop > r.start))
end

function Base.iterate(r::MutatingStepRange)
    if isempty(r)
        return
    end
    state = copy_if_mutable(first(r))
    return (state, state)
end

function Base.iterate(r::MutatingStepRange{T}, i) where {T}
    if i == last(r)
        return
    end
    next = convert(T, operate!!(+, i, step(r)))
    return (next, next)
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestMatMul

using Test

import LinearAlgebra
import MutableArithmetics as MA
import SparseArrays

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

struct CustomArray{T,N} <: AbstractArray{T,N} end

function alloc_test(f::F, expected_upper_bound::Integer) where {F<:Function}
    f() # compile
    measured_allocations = @allocated f()
    @test measured_allocations <= expected_upper_bound
    return
end

function _test_dot(x, y)
    @test MA.operate(LinearAlgebra.dot, x, y) == LinearAlgebra.dot(x, y)
    @test MA.operate(LinearAlgebra.dot, y, x) == LinearAlgebra.dot(y, x)
    @test MA.operate(*, x', y) == x' * y
    @test MA.operate(*, y', x) == y' * x
    @test MA.operate(*, LinearAlgebra.transpose(x), y) ==
          LinearAlgebra.transpose(x) * y
    @test MA.operate(*, LinearAlgebra.transpose(y), x) ==
          LinearAlgebra.transpose(y) * x
end

function test_dot()
    x = [1im]
    y = [1]
    A = reshape(x, 1, 1)
    B = reshape(y, 1, 1)
    _test_dot(x, x)
    _test_dot(y, y)
    _test_dot(A, A)
    _test_dot(B, B)
    _test_dot(x, y)
    _test_dot(x, A)
    _test_dot(x, B)
    _test_dot(y, A)
    _test_dot(y, B)
    _test_dot(A, B)
    return
end

function test_promote_operation()
    x = [1]
    @test MA.promote_operation(*, typeof(x'), typeof(x)) == Int
    @test MA.promote_operation(*, typeof(transpose(x)), typeof(x)) == Int
    return
end

function test_convert()
    @test MA.scaling_convert(
        LinearAlgebra.UniformScaling{Int},
        LinearAlgebra.I,
    ) isa LinearAlgebra.UniformScaling
    @test MA.scaling_convert(Int, LinearAlgebra.I) === 1
    @test MA.scaling_convert(Int, 1) === 1
    @test MA.operate(
        convert,
        LinearAlgebra.UniformScaling{Int},
        LinearAlgebra.I,
    ) isa LinearAlgebra.UniformScaling
    @test MA.operate(convert, Int, LinearAlgebra.I) === 1
    @test MA.operate(convert, Int, 1) === 1
    return
end

struct NoProdMutable <: MA.AbstractMutable end

function MA.promote_operation(
    ::typeof(*),
    ::Type{NoProdMutable},
    ::Type{NoProdMutable},
)
    return Int # Dummy result just to test error message
end

function test_unsupported_product()
    A = [NoProdMutable() for i in 1:2, j in 1:2]
    err = ErrorException(
        "Cannot multiply a `Matrix{$NoProdMutable}` with a " *
        "`Matrix{$NoProdMutable}` because the sum of the product of a " *
        "`$NoProdMutable` and a `$NoProdMutable` could not be inferred so a " *
        "`Matrix{Union{}}` allocated to store the output of the " *
        "multiplication instead of a `Matrix{$(Int)}`.",
    )
    @test_throws err A * A
    return
end

function test_promote_op_error()
    AT = CustomArray{Int,3}
    f(x, y) = nothing
    err = ErrorException(
        "`promote_operation($(f), $(CustomArray{Int,3}), $(CustomArray{Int,3}))` not implemented yet, please report this.",
    )
    @test_throws err MA.promote_operation(f, AT, AT)
    return
end

function test_DimensionMismatch()
    A = zeros(1, 1)
    B = zeros(2, 2)
    @test_throws DimensionMismatch MA.@rewrite A + B
    x = ones(1)
    y = ones(2)
    err = DimensionMismatch(
        "one array has length 1 which does not match the length of the next one, 2.",
    )
    @test_throws err MA.operate(*, x', y)
    @test_throws err MA.operate(*, LinearAlgebra.transpose(x), y)
    err = DimensionMismatch(
        "matrix A has dimensions (2,2), vector B has length 1",
    )
    @test_throws err MA.operate(*, x', B)
    a = zeros(0)
    @test iszero(@inferred MA.operate(LinearAlgebra.dot, a, a))
    @test iszero(@inferred MA.operate(*, a', a))
    @test iszero(@inferred MA.operate(*, LinearAlgebra.transpose(a), a))
    A = zeros(2)
    B = zeros(2, 1)
    err = DimensionMismatch(
        "Cannot sum or substract a matrix of axes `$(axes(B))` into matrix of axes `$(axes(A))`, expected axes `$(axes(B))`.",
    )
    @test_throws err MA.operate!(+, A, B)
    A = SparseArrays.spzeros(2)
    B = SparseArrays.spzeros(2, 1)
    err = DimensionMismatch(
        "Cannot sum or substract a matrix of axes `$(axes(B))` into matrix of axes `$(axes(A))`, expected axes `$(axes(B))`.",
    )
    @test_throws err MA.operate!(+, A, B)
    output = zeros(2)
    A = zeros(2, 1)
    B = zeros(2, 1)
    err = DimensionMismatch(
        "Cannot sum or substract matrices of axes `$(axes(A))` and `$(axes(B))` into a matrix of axes `$(axes(output))`, expected axes `$(axes(B))`.",
    )
    @test_throws err MA.operate_to!(output, +, A, B)
    output = SparseArrays.spzeros(2)
    A = SparseArrays.spzeros(2, 1)
    B = SparseArrays.spzeros(2, 1)
    err = DimensionMismatch(
        "Cannot sum or substract matrices of axes `$(axes(A))` and `$(axes(B))` into a matrix of axes `$(axes(output))`, expected axes `$(axes(B))`.",
    )
    @test_throws err MA.operate_to!(output, +, A, B)
    err = DimensionMismatch(
        "Cannot sum or substract a matrix of axes `$(axes(A))` into a matrix of axes `$(axes(output))`, expected axes `$(axes(A))`.",
    )
    @test_throws err MA.operate_to!(output, +, A)
    @test_throws err MA.operate_to!(output, -, A)
    return
end

function test_matrix_vector_product()
    A = [1 1 1; 1 1 1; 1 1 1]
    x = [1; 1; 1]
    y = [0; 0; 0]
    @test MA.mul(A, x) == [3; 3; 3]
    @test MA.mul_to!!(y, A, x) == [3; 3; 3] && y == [3; 3; 3]
    A = BigInt[1 1 1; 1 1 1; 1 1 1]
    x = BigInt[1; 1; 1]
    y = BigInt[0; 0; 0]
    @test MA.mutability(y, *, A, x) isa MA.IsMutable
    @test MA.mul(A, x) == BigInt[3; 3; 3]
    @test MA.mul_to!!(y, A, x) == BigInt[3; 3; 3] && y == BigInt[3; 3; 3]
    @test_throws DimensionMismatch MA.mul(BigInt[1 1; 1 1], BigInt[])
    @test MA.mul_to!!(BigInt[], BigInt[1 1; 1 1], BigInt[1; 1]) == BigInt[2, 2]
    z = BigInt[0, 0]
    @test MA.mul_to!!(z, BigInt[1 1; 1 1], BigInt[1; 1]) === z
    @test z == BigInt[2, 2]
    alloc_test(() -> MA.promote_operation(*, typeof(A), typeof(x)), 0)
    alloc_test(0) do
        return MA.promote_operation(
            +,
            typeof(y),
            MA.promote_operation(*, typeof(A), typeof(x)),
        )
    end
    alloc_test(0) do
        return MA.promote_operation(MA.add_mul, typeof(y), typeof(A), typeof(x))
    end
    alloc_test(0) do
        return MA.mutability(
            typeof(y),
            MA.add_mul,
            typeof(y),
            typeof(A),
            typeof(x),
        )
    end
    alloc_test(() -> MA.mutability(y, MA.add_mul, y, A, x), 0)
    BIGINT_ALLOC = 2 * sizeof(Int) + @allocated(BigInt(1))
    alloc_test(() -> MA.add_mul!!(y, A, x), BIGINT_ALLOC)
    alloc_test(
        () -> MA.operate_fallback!!(MA.IsMutable(), MA.add_mul, y, A, x),
        BIGINT_ALLOC,
    )
    alloc_test(() -> MA.operate!!(MA.add_mul, y, A, x), BIGINT_ALLOC)
    alloc_test(() -> MA.operate!(MA.add_mul, y, A, x), BIGINT_ALLOC)
    # Apparently, all allocations were on creating the buffer since this is allocation free:
    buffer = MA.buffer_for(MA.add_mul, typeof(y), typeof(A), typeof(x))
    alloc_test(() -> MA.buffered_operate!(buffer, MA.add_mul, y, A, x), 0)
    return
end

function test_matrix_matrix_product()
    A = [1 2 3; 4 5 6; 6 8 9]
    B = [1 -1 2; -2 3 1; 2 -3 1]
    C = [one(Int) for i in 1:3, j in 1:3]
    D = [3 -4 7; 6 -7 19; 8 -9 29]
    @test MA.mul(A, B) == D
    @test MA.mul_to!!(C, A, B) == D
    @test C == D
    A = BigInt[1 2 3; 4 5 6; 6 8 9]
    B = BigInt[1 -1 2; -2 3 1; 2 -3 1]
    C = [one(BigInt) for i in 1:3, j in 1:3]
    D = BigInt[3 -4 7; 6 -7 19; 8 -9 29]
    @test MA.mul(A, B) == D
    @test MA.mul_to!!(C, A, B) == D
    @test C == D
    @test MA.mutability(C, *, A, B) isa MA.IsMutable
    @test_throws DimensionMismatch MA.mul(BigInt[1 1; 1 1], zeros(BigInt, 1, 1))
    @test MA.mul_to!!(
        zeros(BigInt, 1, 1),
        BigInt[1 1; 1 1],
        zeros(BigInt, 2, 1),
    ) == zeros(BigInt, 2, 1)
    alloc_test(() -> MA.promote_operation(*, typeof(A), typeof(B)), 0)
    alloc_test(
        () -> MA.promote_operation(
            +,
            typeof(C),
            MA.promote_operation(*, typeof(A), typeof(B)),
        ),
        0,
    )
    alloc_test(
        () -> MA.promote_operation(MA.add_mul, typeof(C), typeof(A), typeof(B)),
        0,
    )
    alloc_test(
        () -> MA.mutability(
            typeof(C),
            MA.add_mul,
            typeof(C),
            typeof(A),
            typeof(B),
        ),
        0,
    )
    alloc_test(() -> MA.mutability(C, MA.add_mul, C, A, B), 0)
    BIGINT_ALLOC = 2 * sizeof(Int) + @allocated(BigInt(1))
    alloc_test(() -> MA.add_mul!!(C, A, B), BIGINT_ALLOC)
    alloc_test(() -> MA.operate!!(MA.add_mul, C, A, B), BIGINT_ALLOC)
    alloc_test(() -> MA.operate!(MA.add_mul, C, A, B), BIGINT_ALLOC)
    return
end

function test_matrix_multiplication()
    X = ones(BigInt, 1, 1)
    M = ones(1, 1)
    C = X * M
    D = MA.operate!!(MA.add_mul, C, X, M)
    @test D == X * M + X * M
    return
end

function test_sub_mul()
    x = BigFloat[1, 1]
    A = BigFloat[2 2; 2 2]
    y = BigFloat[3, 3]
    MA.operate!!(MA.sub_mul, x, A, y)
    @test x == [-11, -11]
    return
end

function test_add_mul()
    x = BigFloat[1, 1]
    A = BigFloat[2 2; 2 2]
    y = BigFloat[3, 3]
    MA.operate!!(MA.add_mul, x, A, y)
    @test x == [13, 13]
    return
end

struct Issue65Matrix <: AbstractMatrix{Float64}
    x::Matrix{Float64}
end

struct Issue65OneTo
    N::Int
end

Base.size(x::Issue65Matrix) = size(x.x)

Base.getindex(x::Issue65Matrix, args...) = getindex(x.x, args...)

Base.axes(x::Issue65Matrix, n) = Issue65OneTo(size(x.x, n))

Base.convert(::Type{Base.OneTo}, x::Issue65OneTo) = Base.OneTo(x.N)

Base.iterate(x::Issue65OneTo) = iterate(Base.OneTo(x.N))

Base.iterate(x::Issue65OneTo, arg) = iterate(Base.OneTo(x.N), arg)

function test_issue_65()
    x = [1.0 2.0; 3.0 4.0]
    A = Issue65Matrix(x)
    @test MA.operate(*, A, x[:, 1]) == x * x[:, 1]
    @test MA.operate(*, A, x) == x * x
    return
end

function test_issue_154()
    X = big.([1 2; 3 4])
    c = big.([5, 6])
    MA.operate!!(MA.add_mul, X, c, c')
    @test X == [26 32; 33 40]
    return
end

function test_issue_153_vector()
    A = big.([1 2; 3 4])
    b = big.([5, 6])
    ret = big.([0, 0])
    LinearAlgebra.mul!(ret, A, b)
    @test ret == A * b
    return
end

function test_issue_153_matrix()
    A = big.([1 2; 3 4])
    B = big.([5 6; 7 8])
    ret = big.([0 0; 0 0])
    LinearAlgebra.mul!(ret, A, B)
    @test ret == A * B
    return
end

function test_Abstract_eltype_in_matmul()
    # Test that we don't initialize the output with zero(T), which might not
    # exist.
    for M in (Matrix, LinearAlgebra.Diagonal)
        for T in (Any, Union{String,Int})
            x, x12, x22 = T[1, 2], T[1 2], M([1 2; 3 4])
            @test MA.operate(*, x, x') ≈ x * x'
            @test MA.operate(*, x', x) ≈ x' * x
            @test MA.operate(*, x12, x) ≈ x12 * x
            @test MA.operate(*, x22, x) ≈ x22 * x
            @test MA.operate(*, x', x22) ≈ x' * x22
            @test MA.operate(*, x12, x22) ≈ x12 * x22
            @test MA.operate(*, x22, x22) ≈ x22 * x22
            y = M([1.1 1.2; 1.3 1.4])
            @test MA.operate(*, y, x) ≈ y * x
            @test MA.operate(*, x', y) ≈ x' * y
            @test MA.operate(*, y, x12') ≈ y * x12'
            @test MA.operate(*, x12, y) ≈ x12 * y
            @test MA.operate(*, x22, y) ≈ x22 * y
            @test MA.operate(*, y, x22) ≈ y * x22
        end
    end
    for T in (Any, Union{String,Int})
        x, x12, x22 = T[1, 2], T[1 2], LinearAlgebra.LowerTriangular([1 2; 3 4])
        @test MA.operate(*, x, x') ≈ x * x'
        @test MA.operate(*, x', x) ≈ x' * x
        @test MA.operate(*, x12, x) ≈ x12 * x
        @test MA.operate(*, x22, x22) ≈ x22 * x22
        y = LinearAlgebra.LowerTriangular([1.1 1.2; 1.3 1.4])
        @test MA.operate(*, x22, y) ≈ x22 * y
        @test MA.operate(*, y, x22) ≈ y * x22
        # TODO(odow): These tests are broken because `Base` is also broken.
        # Although it fixed y * x12' in Julia v1.9.0.
        # @test_broken MA.operate(*, x22, x) ≈ x22 * x
        # @test_broken MA.operate(*, x', x22) ≈ x' * x22
        # @test_broken MA.operate(*, x12, x22) ≈ x12 * x22
        # @test_broken MA.operate(*, y, x) ≈ y * x
        # @test_broken MA.operate(*, x', y) ≈ x' * y
        # @test_broken MA.operate(*, y, x12') ≈ y * x12'
        # @test_broken MA.operate(*, x12, y) ≈ x12 * y
    end
    return
end

function test_Union_Int_Float64_eltype_in_matmul()
    # Test that we don't initialize the output with zero(Int), either by taking
    # the first available type in the union, or by looking at the first element
    # in the array.
    T = Union{Int,Float64}
    x, x12, x22 = T[1, 2.5], T[1 2.5], T[1 2.5; 3.5 4]
    @test MA.operate(*, x, x') == x * x'
    @test MA.operate(*, x', x) == x' * x
    @test MA.operate(*, x12, x) == x12 * x
    @test MA.operate(*, x22, x) == x22 * x
    @test MA.operate(*, x', x22) == x' * x22
    @test MA.operate(*, x12, x22) == x12 * x22
    @test MA.operate(*, x22, x22) == x22 * x22
    y = [1.1 1.2; 1.3 1.4]
    @test MA.operate(*, y, x) == y * x
    @test MA.operate(*, x', y) == x' * y
    @test MA.operate(*, y, x12') == y * x12'
    @test MA.operate(*, x12, y) == x12 * y
    @test MA.operate(*, x22, y) == x22 * y
    @test MA.operate(*, y, x22) == y * x22
    return
end

function test_issue_256_Vector_Transpose_Vector()
    x = BigInt[1 2; 3 4]
    A = [1 2; 3 4]
    y = MA.@rewrite sum(A[i, :] * LinearAlgebra.transpose(x[i, :]) for i in 1:2)
    @test y == BigInt[10 14; 14 20]
    return
end

struct Monomial end

LinearAlgebra.transpose(m::Monomial) = m

LinearAlgebra.adjoint(m::Monomial) = m

MA.promote_operation(::typeof(*), ::Type{Monomial}, ::Type{Monomial}) = Monomial

Base.:*(m::Monomial, ::Monomial) = m

# `Monomial` does not implement `+`, we should check that it does not prevent
# to do outer products of vectors
function test_issue_256_Vector_Transpose_Vector_Monomial()
    m = Monomial()
    a = [m, m]
    for f in [LinearAlgebra.transpose, LinearAlgebra.adjoint]
        b = f(a)
        T = MA.promote_operation(*, typeof(a), typeof(b))
        @test T == typeof(a * b)
        @test T == typeof(MA.operate(*, a, b))
    end
    return
end

function test_issue_271()
    A = reshape([1, 2], (2, 1))
    B = [1 2]
    C = MA.operate!!(*, A, B)
    @test A == reshape([1, 2], (2, 1))
    @test B == [1 2]
    @test C == A * B
    D = MA.operate!!(*, B, A)
    @test A == reshape([1, 2], (2, 1))
    @test B == [1 2]
    @test D == B * A
    return
end

function test_array_sum()
    x = zeros(Int, 2)
    y = copy(x)
    z = copy(y)
    alloc_test(() -> MA.operate!(+, y, z), 0)
    alloc_test(() -> MA.add!!(y, z), 0)
    alloc_test(() -> MA.operate_to!(x, +, y, z), 0)
    alloc_test(() -> MA.add_to!!(x, y, z), 0)
    return
end

function test_sparse_vector_sum()
    x = SparseArrays.sparsevec([1, 3], [5, 7])
    y = copy(x)
    z = copy(y)
    # FIXME not sure what is allocating
    alloc_test(() -> MA.operate!(+, y, z), 200)
    alloc_test(() -> MA.operate!(-, y, z), 200)
    alloc_test(() -> MA.operate_to!(x, +, y, z), 0)
    alloc_test(() -> MA.operate_to!(x, -, y, z), 0)
    alloc_test(() -> MA.operate_to!(x, +, y), 0)
    alloc_test(() -> MA.operate_to!(x, -, y), 0)
    return
end

end  # TestMatMul

TestMatMul.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

#!format:off
# TODO(odow): JuliaFormatter cannot format this file for some reason?

macro test_rewrite(expr)
    esc(quote
        @test MA.isequal_canonical(MA.@rewrite($expr), $expr)
    end)
end

function _add_test(x, y)
    @test_rewrite(x + y)
    @test_rewrite(-x + y)
    @test_rewrite(x - y)
    @test_rewrite(-x - y)
    if !(x isa UniformScaling)
        # Unary `+` not defined for `UniformScaling`.
        @test_rewrite(+x - y)
        @test_rewrite(+x + y)
    end
    @test_rewrite(2x + y)
    @test_rewrite(2x - y)
    @test_rewrite(x + 2y)
    @test_rewrite(x - 2y)
    @test_rewrite(x + y * 2)
    @test_rewrite(x - y * 2)
    @test_rewrite(x + 2y * 2)
    @test_rewrite(x - 2y * 2)
end
function add_test(x, y)
    _add_test(x, y)
    if x !== y
        _add_test(y, x)
    end
end

function unary_test(x)
    @test_rewrite 2x
    @test_rewrite x * 2
    @test_rewrite 2x * 2
    @test_rewrite +x
    @test_rewrite -x
end

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# `Base.evalpoly` MA operation implemented using Horner's scheme. For
# real-valued polynomials with real coefficients.

function promote_operation(
    ::typeof(Base.evalpoly),
    ::Type{F},
    ::Type{<:Union{Tuple,AbstractVector}},
) where {F<:Real}
    return F
end

function operate_to!(
    val::F,
    ::typeof(Base.evalpoly),
    x::F,
    coefs::Union{Tuple,AbstractVector},
) where {F<:Real}
    operate!(zero, val)

    # An empty collection of coefficients is interpreted as the zero polynomial.
    isempty(coefs) && return val

    operate!(+, val, last(coefs))

    for i in eachindex(coefs)[(end-1):-1:begin]
        operate!(Base.muladd, val, x, coefs[i])
    end

    return val
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestInterfaceSparseArrays

using Test

import LinearAlgebra
import MutableArithmetics as MA
import Random
import SparseArrays

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

function test_spmatmul()
    Random.seed!(1234)
    for m in [1, 2, 3, 5, 11]
        for n in [1, 2, 3, 5, 11]
            A = SparseArrays.sprand(Float64, m, n, 0.5)
            B = SparseArrays.sprand(Float64, n, m, 0.5)
            ret = SparseArrays.spzeros(Float64, m, m)
            MA.operate!(MA.add_mul, ret, A, B)
            @test ret ≈ A * B
            ret = SparseArrays.spzeros(Float64, m, m)
            MA.operate!(MA.add_mul, ret, A, A')
            @test ret ≈ A * A'
            ret = SparseArrays.spzeros(Float64, m, m)
            MA.operate!(MA.add_mul, ret, A, B, 2.0)
            @test ret ≈ A * B * 2.0
            ret = SparseArrays.spzeros(Float64, m, m)
            MA.operate!(MA.add_mul, ret, A, B, 2.0, 1.5)
            @test ret ≈ A * B * 2.0 * 1.5
        end
    end
    return
end

function test_spmatmul_prefer_sort()
    Random.seed!(1234)
    m = n = 100
    p = 0.01
    A = SparseArrays.sprand(Float64, m, n, p)
    B = SparseArrays.sprand(Float64, n, m, p)
    ret = SparseArrays.spzeros(Float64, m, m)
    MA.operate!(MA.add_mul, ret, A, B)
    @test ret ≈ A * B
    ret = SparseArrays.spzeros(Float64, m, m)
    MA.operate!(MA.add_mul, ret, A, B, 2.0)
    @test ret ≈ A * B * 2.0
    ret = SparseArrays.spzeros(Float64, m, m)
    MA.operate!(MA.add_mul, ret, A, B, 2.0, 1.5)
    @test ret ≈ A * B * 2.0 * 1.5
    return
end

function test_sparse_addmul_matmat()
    Random.seed!(1234)
    m = 10
    ret = SparseArrays.spzeros(Float64, m, m)
    A, B = rand(m, m), rand(m, m)
    MA.operate!(MA.add_mul, ret, A, B)
    @test ret ≈ A * B
    MA.operate!(MA.add_mul, ret, A, B)
    @test ret ≈ A * B + A * B
    return
end

function test_sparse_addmul_mat_adjspmat()
    Random.seed!(1234)
    m = 10
    ret = zeros(m, m)
    A = rand(m, m)
    B = SparseArrays.sprand(Float64, m, m, 0.5)'
    MA.operate!(MA.add_mul, ret, A, B)
    @test ret ≈ A * B
    MA.operate!(MA.add_mul, ret, A, B, 3.0)
    @test ret ≈ A * B + A * B * 3.0
    return
end

function test_spmatmul_adj()
    Random.seed!(1234)
    for m in [1, 2, 3, 5, 11]
        for f in (identity, LinearAlgebra.adjoint)
            for g in (identity, LinearAlgebra.adjoint)
                A = f(SparseArrays.sprand(Float64, m, m, 0.5))
                B = g(SparseArrays.sprand(Float64, m, m, 0.5))
                ret = SparseArrays.spzeros(Float64, m, m)
                MA.operate!(MA.add_mul, ret, A, B)
                @test ret ≈ A * B
                ret = SparseArrays.spzeros(Float64, m, m)
                MA.operate!(MA.add_mul, ret, A, A')
                @test ret ≈ A * A'
                ret = SparseArrays.spzeros(Float64, m, m)
                MA.operate!(MA.add_mul, ret, A, B, 2.0)
                @test ret ≈ A * B * 2.0
                ret = SparseArrays.spzeros(Float64, m, m)
                MA.operate!(MA.add_mul, ret, A, B, 2.0, 1.5)
                @test ret ≈ A * B * 2.0 * 1.5
            end
        end
    end
    return
end

function test_sparse_broadcast()
    Random.seed!(1234)
    x = [BigInt(1) for _ in 1:10]
    y = SparseArrays.sprand(Float64, 10, 0.5)
    @test MA.broadcast!!(+, x, y) ≈ x .+ y
    Random.seed!(1234)
    X = [BigInt(1) for _ in 1:10, _ in 1:10]
    Y = SparseArrays.sprand(Float64, 10, 10, 0.5)
    @test MA.broadcast!!(+, X, Y) ≈ X .+ Y
    return
end

function test_zero()
    v = SparseArrays.sparsevec([1, 2], [3.0, 4.0])
    MA.operate!(zero, v)
    @test isempty(SparseArrays.nonzeroinds(v))
    @test isempty(SparseArrays.nonzeros(v))
    A = SparseArrays.sprand(Float64, 2, 2, 0.5)
    MA.operate!(zero, A)
    @test iszero(SparseArrays.nnz(A))
    @test isempty(SparseArrays.nonzeros(A))
    return
end

end  # module

TestInterfaceSparseArrays.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestBroadcast

using Test

import MutableArithmetics as MA

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

function test_Int()
    a = [1, 2]
    b = 3
    c = [3, 4]
    @test MA.broadcast!!(+, a, b) == [4, 5]
    @test a == [4, 5]
    # Need to have immutable structs that contain references to be allocated on
    # the stack: https://github.com/JuliaLang/julia/pull/33886
    @test @allocated(MA.broadcast!!(+, a, b)) == 0
    @test @allocated(MA.broadcast!!(+, a, c)) == 0
    return
end

function test_BigInt()
    x = BigInt(1)
    y = BigInt(2)
    a = [x, y]
    b = 3
    c = [2x, 3y]
    @test MA.broadcast!!(+, a, b) == [4, 5]
    @test a == [4, 5]
    @test x == 4
    @test y == 5
    # FIXME This should not allocate but I couldn't figure out where these
    #       allocations come from.
    n = 6 * @allocated(BigInt(1))
    @test @allocated(MA.broadcast!!(+, a, b)) <= n
    @test @allocated(MA.broadcast!!(+, a, c)) == 0
    return
end

function test_broadcast_issue_158()
    x, y = BigInt[2 3], BigInt[2 3; 3 4]
    @test MA.@rewrite(x .+ y) == x .+ y
    @test MA.@rewrite(x .- y) == x .- y
    @test MA.@rewrite(y .+ x) == y .+ x
    @test MA.@rewrite(y .- x) == y .- x
    @test MA.@rewrite(y .* x) == y .* x
    @test MA.@rewrite(x .* y) == x .* y
    return
end

struct Struct221 <: AbstractArray{Int,1} end

struct BroadcastStyle221 <: Broadcast.BroadcastStyle end

Base.BroadcastStyle(::Type{Struct221}) = BroadcastStyle221()

function test_promote_broadcast_for_new_style()
    @test MA.promote_broadcast(MA.add_mul, Vector{Int}, Struct221) === Any
    return
end

function test_broadcast_length_1_dimensions()
    A = rand(2, 1, 3)
    B = rand(2, 3)
    @test MA.broadcast!!(MA.sub_mul, A, B) ≈ A .- B
    @test MA.broadcast!!(MA.sub_mul, B, A) ≈ B .- A
    return
end

end  # module

TestBroadcast.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

using LinearAlgebra, SparseArrays, Test
import MutableArithmetics as MA

@testset "Zero" begin
    z = MA.Zero()
    @test zero(MA.Zero) isa MA.Zero
    @test z + z isa MA.Zero
    @test z + 1 == 1
    @test 1 + z == 1
    @test z * z isa MA.Zero
    @test z * 1 isa MA.Zero
    @test 1 * z isa MA.Zero
    @test -z isa MA.Zero
    @test +z isa MA.Zero
    @test *(z) isa MA.Zero
    @test iszero(z)
    @test !isone(z)
end

# Test that the macro call `m` throws an error exception during pre-compilation
macro test_macro_throws(error, m)
    # See https://discourse.julialang.org/t/test-throws-with-macros-after-pr-23533/5878
    return quote
        @test_throws $(esc(error)) try
            @eval $m
        catch catched_error
            throw(catched_error.error)
        end
    end
end

function is_supported_test(T)
    @test MA.Test._is_supported(*, T, T)
    @test MA.Test._is_supported(+, T, T)
end

function error_test(x, y, z)
    err = ErrorException(
        "The curly syntax (sum{},prod{},norm2{}) is no longer supported. Expression: `sum{(i for i = 1:2)}`.",
    )
    @test_macro_throws err MA.@rewrite sum{i for i in 1:2}
    err = ErrorException("Unexpected comparison in expression `z >= y`.")
    @test_macro_throws err MA.@rewrite z >= y
    err = ErrorException("Unexpected comparison in expression `y <= z`.")
    @test_macro_throws err MA.@rewrite y <= z
    err = ErrorException("Unexpected comparison in expression `x <= y <= z`.")
    @test_macro_throws err MA.@rewrite x <= y <= z
end

using LinearAlgebra
using OffsetArrays

@testset "@rewrite with $T" for (T, supports_float) in [
    (Int, true),
    (Float64, true),
    (BigInt, true),
    (BigFloat, true),
    (Rational{Int}, true),
    (Rational{BigInt}, true),
    (DummyBigInt, false),
]
    @testset "is_supported_test" begin
        is_supported_test(T)
    end
    @testset "Error" begin
        error_test(T(1), T(2), T(3))
    end
    @testset "Scalar" begin
        MA.Test.scalar_test(T(2))
        MA.Test.scalar_test(T(3))
    end
    @testset "Quadratic" begin
        exclude = T == DummyBigInt ? ["quadratic_division"] : String[]
        MA.Test.quadratic_test(T(1), T(2), T(3), T(4), exclude = exclude)
    end
    @testset "Sparse" begin
        MA.Test.sparse_test(T(4), T(5), T[8 1 9; 4 3 1; 2 0 8])
    end
    exclude = if T == DummyBigInt
        ["broadcast_division", "matrix_vector_division"]
    elseif T <: Rational
        ["broadcast_division"]
    else
        String[]
    end
    @testset "Vector" begin
        MA.Test.array_test(T[-7, 1, 4], exclude = exclude)
        MA.Test.array_test(T[3, 2, 6], exclude = exclude)
    end
    @testset "Square Matrix" begin
        MA.Test.array_test(T[1 2; 2 4], exclude = exclude)
        MA.Test.array_test(T[2 4; -1 3], exclude = exclude)
        MA.Test.array_test(T[0 -4; 6 -5], exclude = exclude)
        MA.Test.array_test(T[5 1 9; -7 2 4; -2 -7 5], exclude = exclude)
    end
    @testset "Non-square matrix" begin
        MA.Test.array_test(T[5 1 9; -7 2 4], exclude = exclude)
    end
    @testset "Tensor" begin
        S = zeros(T, 2, 2, 2)
        S[1, :, :] = T[5 -8; 3 -7]
        S[2, :, :] = T[-2 8; 8 -1]
        MA.Test.array_test(S, exclude = exclude)
    end
    @testset "Non-array" begin
        x = T[2, 4, 3]
        MA.Test.non_array_test(x, OffsetArray(x, -length(x)))
    end
end

@testset "generator with not sum" begin
    @test MA.@rewrite(minimum(j^2 for j in 2:3)) == 4
    @test MA.@rewrite(maximum(j^2 for j in 2:3)) == 9
end

@testset "issue_76_trailing_dimensions" begin
    @testset "(4,) + (4,1)" begin
        X = [1, 2, 3, 4]
        Y = reshape([1, 2, 3, 4], (4, 1))
        @test MA.@rewrite(X + Y) == X + Y
        @test MA.@rewrite(Y + X) == Y + X
    end
    @testset "(4,) + (4,1,1)" begin
        X = [1, 2, 3, 4]
        Y = reshape([1, 2, 3, 4], (4, 1, 1))
        @test MA.@rewrite(X + Y) == X + Y
        @test MA.@rewrite(Y + X) == Y + X
    end
    @testset "(2,2) + (2,2,1)" begin
        X = [1 2; 3 4]
        Y = reshape([1, 2, 3, 4], (2, 2, 1))
        @test MA.@rewrite(X + Y) == X + Y
        @test MA.@rewrite(Y + X) == Y + X
    end
    @testset "(4,) - (4,1)" begin
        X = [1, 3, 5, 7]
        Y = reshape([1, 2, 3, 4], (4, 1))
        @test MA.@rewrite(X - Y) == X - Y
        @test MA.@rewrite(Y - X) == Y - X
    end
    @testset "(4,) - (4,1,1)" begin
        X = [1, 3, 5, 7]
        Y = reshape([1, 2, 3, 4], (4, 1, 1))
        @test MA.@rewrite(X - Y) == X - Y
        @test MA.@rewrite(Y - X) == Y - X
    end
    @testset "(2,2) - (2,2,1)" begin
        X = [1 3; 5 7]
        Y = reshape([1, 2, 3, 4], (2, 2, 1))
        @test MA.@rewrite(X - Y) == X - Y
        @test MA.@rewrite(Y - X) == Y - X
    end
end

struct _KwargRef{K,V}
    data::Dict{K,V}
end

Base.getindex(x::_KwargRef; i) = x.data[i]

@testset "test_rewrite_kw_in_ref" begin
    x = _KwargRef(Dict(i => i + 1 for i in 2:4))
    @test MA.@rewrite(sum(x[i = j] for j in 2:4)) == 12
end

@testset "dispatch_dot" begin
    # Symmetric
    x = DummyBigInt[1 2; 2 3]
    y = LinearAlgebra.Symmetric(x)
    @test MA.isequal_canonical(
        LinearAlgebra.dot(x, y),
        MA.operate(LinearAlgebra.dot, x, y),
    )
    a = @allocated LinearAlgebra.dot(x, y)
    b = @allocated MA.operate(LinearAlgebra.dot, x, y)
    @test a == b
    # Symmetric
    x = DummyBigInt[1 2; 2 3]
    y = LinearAlgebra.Hermitian(x)
    @test MA.isequal_canonical(
        LinearAlgebra.dot(x, y),
        MA.operate(LinearAlgebra.dot, x, y),
    )
    a = @allocated LinearAlgebra.dot(x, y)
    b = @allocated MA.operate(LinearAlgebra.dot, x, y)
    @test a == b
    # AbstractArray
    x = DummyBigInt[1 2; 2 3]
    y = x
    @test MA.isequal_canonical(
        LinearAlgebra.dot(x, y),
        MA.operate(LinearAlgebra.dot, x, y),
    )
    a = @allocated LinearAlgebra.dot(x, y)
    b = @allocated MA.operate(LinearAlgebra.dot, x, y)
    @test a == b
end

@testset "test_multiply_expr_MA_Zero" begin
    x = DummyBigInt(1)
    f = DummyBigInt(2)
    @test MA.@rewrite(
        f * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * f,
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        -f * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * -f,
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        (f + f) * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * (f + f),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        -[f] * sum(x for i in 1:0),
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.@rewrite(
        sum(x for i in 1:0) * -[f],
        move_factors_into_sums = false
    ) == MA.Zero()
    @test MA.isequal_canonical(
        MA.@rewrite(f + sum(x for i in 1:0), move_factors_into_sums = false),
        f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(sum(x for i in 1:0) + f, move_factors_into_sums = false),
        f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(-f + sum(x for i in 1:0), move_factors_into_sums = false),
        -f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(sum(x for i in 1:0) + -f, move_factors_into_sums = false),
        -f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(
            (f + f) + sum(x for i in 1:0),
            move_factors_into_sums = false
        ),
        f + f,
    )
    @test MA.isequal_canonical(
        MA.@rewrite(
            sum(x for i in 1:0) + (f + f),
            move_factors_into_sums = false
        ),
        f + f,
    )
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function int_add_test(::Type{T}) where {T}
    @testset "add_to! / add!" begin
        @test MA.mutability(T, +, T, T) isa MA.IsMutable

        t(n) = convert(T, n)
        a = t(5)
        b = t(28)
        c = t(41)
        expected = t(69)
        @test MA.isequal_canonical(MA.add_to!!(a, b, c), expected)
        @test MA.isequal_canonical(a, expected)
        @test MA.isequal_canonical(MA.add!!(b, c), expected)
        @test MA.isequal_canonical(b, expected)

        a = t(165)
        b = t(255)
        expected = t(420)
        @test MA.isequal_canonical(MA.add!!(a, b), expected)
        @test MA.isequal_canonical(a, expected)
    end
end
function int_sub_test(::Type{T}) where {T}
    @testset "sub_to! / sub!" begin
        @test MA.mutability(T, -, T, T) isa MA.IsMutable

        t(n) = convert(T, n)
        a = t(5)
        b = t(28)
        c = t(41)
        expected = t(-13)
        @test MA.isequal_canonical(MA.sub_to!!(a, b, c), expected)
        @test MA.isequal_canonical(a, expected)
        @test MA.isequal_canonical(MA.sub!!(b, c), expected)
        @test MA.isequal_canonical(b, expected)

        a = t(165)
        b = t(255)
        expected = t(-90)
        @test MA.isequal_canonical(MA.sub!!(a, b), expected)
        @test MA.isequal_canonical(a, expected)
    end
end
function int_mul_test(::Type{T}) where {T}
    @testset "mul_to! / mul!" begin
        @test MA.mutability(T, *, T, T) isa MA.IsMutable

        t(n) = convert(T, n)
        a = t(5)
        b = t(23)
        c = t(3)
        @test MA.isequal_canonical(MA.mul_to!!(a, b, c), t(69))
        @test MA.isequal_canonical(a, t(69))
        @test MA.isequal_canonical(MA.mul!!(b, c), t(69))
        @test MA.isequal_canonical(b, t(69))

        a = t(15)
        b = t(28)
        @test MA.isequal_canonical(MA.mul!!(a, b), t(420))
        @test MA.isequal_canonical(a, t(420))
    end
end
function int_add_mul_test(::Type{T}) where {T}
    @testset "add_mul_to! / add_mul! / add_mul_buf_to! / add_mul_buf!" begin
        @test MA.mutability(T, MA.add_mul, T, T) isa MA.IsMutable
        @test MA.mutability(T, MA.add_mul, T, T, T) isa MA.IsMutable
        @test MA.mutability(T, MA.add_mul, T, T, T, T) isa MA.IsMutable

        t(n) = convert(T, n)
        a = t(5)
        b = t(9)
        c = t(3)
        d = t(20)
        buf = MA.buffer_for(MA.add_mul, typeof(a), typeof(b), typeof(c))

        @test MA.isequal_canonical(MA.add_mul_to!!(a, b, c, d), t(69))
        @test MA.isequal_canonical(a, t(69))
        a = t(5)
        @test MA.isequal_canonical(MA.add_mul!!(b, c, d), t(69))
        @test MA.isequal_canonical(b, t(69))
        b = t(9)

        @test MA.isequal_canonical(MA.add_mul_buf_to!!(buf, a, b, c, d), t(69))
        @test MA.isequal_canonical(a, t(69))
        @test MA.isequal_canonical(MA.add_mul_buf!!(buf, b, c, d), t(69))
        @test MA.isequal_canonical(b, t(69))

        a = t(148)
        b = t(16)
        c = t(17)
        d = t(42)
        @test MA.isequal_canonical(MA.add_mul!!(a, b, c), t(420))
        @test MA.isequal_canonical(a, t(420))
        a = t(148)
        @test MA.isequal_canonical(MA.add_mul_buf_to!!(buf, d, a, b, c), t(420))
        @test MA.isequal_canonical(d, t(420))
        @test MA.isequal_canonical(MA.add_mul_buf!!(buf, a, b, c), t(420))
        @test MA.isequal_canonical(a, t(420))
    end
end
function int_sub_mul_test(::Type{T}) where {T}
    @testset "sub_mul_to! / sub_mul! / sub_mul_buf_to! / sub_mul_buf!" begin
        @test MA.mutability(T, MA.sub_mul, T, T) isa MA.IsMutable
        @test MA.mutability(T, MA.sub_mul, T, T, T) isa MA.IsMutable
        @test MA.mutability(T, MA.sub_mul, T, T, T, T) isa MA.IsMutable

        t(n) = convert(T, n)
        a = t(5)
        b = t(9)
        c = t(3)
        d = t(20)
        buf = t(24)

        expected = t(-51)
        @test MA.isequal_canonical(MA.sub_mul_to!!(a, b, c, d), expected)
        @test MA.isequal_canonical(a, expected)
        a = t(5)
        @test MA.isequal_canonical(MA.sub_mul!!(b, c, d), expected)
        @test MA.isequal_canonical(b, expected)
        b = t(9)

        @test MA.isequal_canonical(
            MA.sub_mul_buf_to!!(buf, a, b, c, d),
            expected,
        )
        @test MA.isequal_canonical(a, expected)
        @test MA.isequal_canonical(MA.sub_mul_buf!!(buf, b, c, d), expected)
        @test MA.isequal_canonical(b, expected)

        a = t(148)
        b = t(16)
        c = t(17)
        d = t(42)
        buf = t(56)
        expected = t(-124)
        @test MA.isequal_canonical(MA.sub_mul!!(a, b, c), expected)
        @test MA.isequal_canonical(a, expected)
        a = t(148)
        @test MA.isequal_canonical(
            MA.sub_mul_buf_to!!(buf, d, a, b, c),
            expected,
        )
        @test MA.isequal_canonical(d, expected)
        @test MA.isequal_canonical(MA.sub_mul_buf!!(buf, a, b, c), expected)
        @test MA.isequal_canonical(a, expected)
    end
end

function int_zero_test(::Type{T}) where {T}
    @testset "zero!" begin
        @test MA.mutability(T, zero, T) isa MA.IsMutable

        t(n) = convert(T, n)
        a = t(5)
        @test MA.isequal_canonical(MA.zero!!(a), t(0))
        @test MA.isequal_canonical(a, t(0))
        @test iszero(a)
    end
end

function int_one_test(::Type{T}) where {T}
    @testset "one!" begin
        @test MA.mutability(T, one, T) isa MA.IsMutable

        t(n) = convert(T, n)
        a = t(5)
        @test MA.isequal_canonical(MA.one!!(a), t(1))
        @test MA.isequal_canonical(a, t(1))
        @test isone(a)
    end
end

const int_tests = Dict(
    "int_add" => int_add_test,
    "int_mul" => int_mul_test,
    "int_add_mul" => int_add_mul_test,
    "int_zero" => int_zero_test,
    "int_one" => int_one_test,
)

@test_suite int

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# Example of mutable types that can implement this API: BigInt, Array, JuMP.AffExpr, MultivariatePolynomials.AbstractPolynomial
# `operate!(add_mul, ...)` is similar to `JuMP.add_to_expression(...)`
# `operate!!(add_mul, ...)` is similar to `JuMP.destructive_add(...)`
# `operate!!` is similar to `MOI.Utilities.operate!`

# `promote_operation_fallback` gives fallbacks for any type with no risk of
# ambiguity with specific methods defined for a given type, even if these are
# quite broad in the allowed operations.
function promote_operation_fallback(
    op::Function,
    x::Type{<:AbstractArray},
    y::Type{<:AbstractArray},
)
    # `zero` is not defined for `AbstractArray` so the fallback would fail with a cryptic MethodError.
    # We replace it by a more helpful error here.
    return error(
        "`promote_operation($op, $x, $y)` not implemented yet, please report " *
        "this.",
    )
end

_instantiate_zero(::Type{S}) where {S} = zero(S)
_instantiate_oneunit(::Type{S}) where {S} = oneunit(S)

# this is valid because Irrational numbers are defined in global scope as const
_instantiate(::Type{S}) where {S<:Irrational} = S()
_instantiate_zero(::Type{S}) where {S<:AbstractIrrational} = _instantiate(S)
_instantiate_oneunit(::Type{S}) where {S<:AbstractIrrational} = _instantiate(S)

# Julia v1.0.x has trouble with inference with the `Vararg` method, see
# https://travis-ci.org/jump-dev/JuMP.jl/jobs/617606373
function promote_operation_fallback(
    op::Union{typeof(/),typeof(div)},
    ::Type{S},
    ::Type{T},
) where {S,T}
    if isconcretetype(S) && isconcretetype(T)
        return typeof(op(_instantiate_zero(S), _instantiate_oneunit(T)))
    else
        return promote_type(S, T)
    end
end

function promote_operation_fallback(
    op::typeof(/),
    ::Type{S},
    ::Type{T},
) where {S<:Integer,T<:Integer}
    if isconcretetype(S) && isconcretetype(T)
        return typeof(op(_instantiate_zero(S), _instantiate_oneunit(T)))
    else
        return promote_type(float(S), float(T))
    end
end

function promote_operation_fallback(
    op::F,
    ::Type{S},
    ::Type{T},
) where {F<:Function,S,T}
    if isconcretetype(S) && isconcretetype(T)
        return typeof(op(_instantiate_zero(S), _instantiate_zero(T)))
    else
        return promote_type(S, T)
    end
end

function promote_operation_fallback(
    op::F,
    args::Vararg{Type,N},
) where {F<:Function,N}
    if all(isconcretetype, args)
        return typeof(op(_instantiate_zero.(args)...))
    else
        return promote_type(args...)
    end
end

promote_operation_fallback(::typeof(*), ::Type{T}) where {T} = T

function promote_operation_fallback(
    op::Union{typeof(*),typeof(+),typeof(gcd),typeof(lcm)},
    ::Type{S},
    ::Type{T},
    ::Type{U},
    args::Vararg{Type,N},
) where {S,T,U,N}
    return promote_operation(op, promote_operation(op, S, T), U, args...)
end

# `Vararg` gives extra allocations on Julia v1.3, see
# https://travis-ci.com/jump-dev/MutableArithmetics.jl/jobs/260666164#L215-L238
function promote_operation_fallback(
    op::AddSubMul,
    ::Type{T},
    ::Type{x},
    ::Type{y},
) where {T,x,y}
    new_op = add_sub_op(op)
    z = promote_operation(*, x, y)
    return promote_operation(new_op, T, z)
end

function promote_operation_fallback(
    op::AddSubMul,
    x::Type{<:AbstractArray},
    y::Type{<:AbstractArray},
)
    return promote_operation(add_sub_op(op), x, y)
end

function promote_operation_fallback(
    op::Union{AddSubMul,typeof(add_dot)},
    T::Type,
    args::Vararg{Type,N},
) where {N}
    return promote_operation(
        reduce_op(op),
        T,
        promote_operation(map_op(op), args...),
    )
end

function promote_operation(
    ::Union{typeof(real),typeof(imag)},
    ::Type{Complex{T}},
) where {T}
    return T
end

"""
    promote_operation(op::Function, ArgsTypes::Type...)

Returns the type returned to the call `operate(op, args...)` where the types of
the arguments `args` are `ArgsTypes`.
"""
function promote_operation(op::F, args::Vararg{Type,N}) where {F<:Function,N}
    return promote_operation_fallback(op, args...)
end

# Fix ambiguities identified by Aqua.jl
promote_operation(::typeof(-)) = Any
promote_operation(::typeof(+)) = Any
promote_operation(::typeof(*)) = Any

# Helpful error for common mistake
function promote_operation(
    op::Union{typeof(+),typeof(-),AddSubMul},
    A::Type{<:Array},
    α::Type{<:Number},
)
    return error(
        "Operation `$op` between `$A` and `$α` is not allowed. You should " *
        "use broadcast.",
    )
end
function promote_operation(
    op::Union{typeof(+),typeof(-),AddSubMul},
    α::Type{<:Number},
    A::Type{<:Array},
)
    return error(
        "Operation `$op` between `$α` and `$A` is not allowed. You should " *
        "use broadcast.",
    )
end

"""
    operate(op::Function, args...)

Return an object equal to the result of `op(args...)` that can be mutated
through the MultableArithmetics API without affecting the arguments.

By default:
* `operate(+, x)` and `operate(+, x)` redirect to `copy_if_mutable(x)` so a
  mutable type `T` can return the same instance from unary operators
  `+(x::T) = x` and `*(x::T) = x`.
* `operate(+, args...)` (resp. `operate(-, args...)` and `operate(*, args...)`)
  redirect to `+(args...)` (resp. `-(args...)` and `*(args...)`) if `length(args)`
  is at least 2 (or the operation is `-`).

Note that when `op` is a `Base` function whose implementation can be improved
for mutable arguments, `operate(op, args...)` may have an implementation in
this package relying on the MutableArithmetics API instead of redirecting to
`op(args...)`. This is the case for instance:

* for `Base.sum`,
* for `LinearAlgebra.dot` and
* for matrix-matrix product and matrix-vector product.

Therefore, for mutable arguments, there may be a performance advantage to call
`operate(op, args...)` instead of `op(args...)`.

## Example

If for a mutable type `T`, the following is defined:
```julia
function Base.:*(a::Bool, x::T)
    return a ? x : zero(T)
end
```
then `operate(*, a, x)` will return the instance `x` whose modification will
affect the argument of `operate`. Therefore, the following method need to
be implemented
```julia
function MA.operate(::typeof(*), a::Bool, x::T)
    return a ? MA.mutable_copy(x) : zero(T)
end
```
"""
function operate end

# /!\ We assume these three return an object that can be modified through the MA
#     API without altering `x` and `y`. If it is not the case, implement a
#     custom `operate` method.
operate(::typeof(-), x) = -x

# This is not efficient, as it may make unnecessary intermediate copies,
# but seems like the best way to write a generic implementation.
operate(::typeof(abs), x) = abs(copy_if_mutable(x))

function operate(
    op::Union{
        typeof(+),
        typeof(*),
        AddSubMul,
        typeof(add_dot),
        typeof(gcd),
        typeof(lcm),
    },
    x,
    y,
    args::Vararg{Any,N},
) where {N}
    return op(x, y, args...)
end

function operate(
    op::Union{typeof(-),typeof(/),typeof(div),typeof(evalpoly)},
    x,
    y,
)
    return op(x, y)
end

operate(::typeof(convert), ::Type{T}, x) where {T} = convert(T, x)

operate(::typeof(convert), ::Type{T}, x::T) where {T} = copy_if_mutable(x)

function operate(
    ::Union{typeof(copy),typeof(+),typeof(*),typeof(gcd),typeof(lcm)},
    x,
)
    return copy_if_mutable(x)
end

# We could only give `typeof(x)` to `zero` and `one` to be sure that modifying
# the returned object cannot alter `x` but for some objects, `one` and `zero`
# depends on some values of the fields (e.g. square matrices), elements of the
# cyclic group of order `n` (`n` is one of the field).
operate(::typeof(zero), x) = zero(x)

operate(::typeof(one), x) = one(x)

# Define Traits

"""
    abstract type MutableTrait end

Abstract type for [`IsMutable`](@ref) and [`IsNotMutable`](@ref) that are
returned by [`mutability`](@ref).
"""
abstract type MutableTrait end

"""
    struct IsMutable <: MutableTrait end

When this is returned by [`mutability`](@ref), it means that object of the given
type can always be mutated to equal the result of the operation.
"""
struct IsMutable <: MutableTrait end

"""
    struct IsNotMutable <: MutableTrait end

When this is returned by [`mutability`](@ref), it means that object of the given
type cannot be mutated to equal the result of the operation.
"""
struct IsNotMutable <: MutableTrait end

"""
    mutability(T::Type, ::typeof(op), args::Type...)::MutableTrait

Return either [`IsMutable`](@ref) to indicate an object of type `T` can be
modified to be equal to `op(args...)` or [`IsNotMutable`](@ref) otherwise.
"""
function mutability(T::Type, op, args::Vararg{Type,N}) where {N}
    if mutability(T) isa IsMutable && promote_operation(op, args...) == T
        return IsMutable()
    else
        return IsNotMutable()
    end
end

function mutability(x, op, args::Vararg{Any,N}) where {N}
    return mutability(typeof(x), op, typeof.(args)...)
end

# As a special case, we need to check that the shapes of matrix multiplication
# match in order for the array to be mutable.
function mutability(
    x::AbstractArray,
    op::typeof(*),
    args::Vararg{Any,N},
) where {N}
    is_mutable = mutability(typeof(x), op, typeof.(args)...) == IsMutable()
    if is_mutable && size(x) == _size_after_multiply(size.(args)...)
        return IsMutable()
    end
    return IsNotMutable()
end

function _size_after_multiply(x::NTuple{M,Int}, y::NTuple{N,Int}) where {N,M}
    if x[end] != y[1]
        return nothing
    end
    return (x[1:(end-1)]..., y[2:end]...)
end

_size_after_multiply(::Tuple{}, rhs::NTuple{M,Int}) where {M} = rhs
_size_after_multiply(lhs::NTuple{M,Int}, ::Tuple{}) where {M} = lhs
_size_after_multiply(::Tuple{}, ::Tuple{}) = ()
_size_after_multiply(::Nothing, ::Any) = nothing

function _size_after_multiply(x::NTuple{M,Int}, y::Vararg{Any,N}) where {N,M}
    head = _size_after_multiply(x, Base.first(y))
    return _size_after_multiply(head, Base.tail(y)...)
end

mutability(::Type) = IsNotMutable()

"""
    mutable_copy(x)

Return a copy of `x` that can be mutated with MultableArithmetics's API without
altering `x`.

## Examples

The copy of a JuMP affine expression does not copy the underlying model as it
cannot be modified though the MultableArithmetics's API, however, it calls
[`copy_if_mutable`](@ref) on the coefficients and on the constant as they could
be mutated.
"""
function mutable_copy end

mutable_copy(A::AbstractArray) = mutable_copy.(A)

copy_if_mutable_fallback(::IsNotMutable, x) = x

copy_if_mutable_fallback(::IsMutable, x) = mutable_copy(x)

"""
    copy_if_mutable(x)

Return a copy of `x` that can be mutated with MultableArithmetics's API without
altering `x`. If `mutability(x)` is `IsNotMutable` then `x` is returned as none of
`x` can be mutated. Otherwise, it redirects to [`mutable_copy`](@ref).
Mutable types should not implement a method for this function but should
implement a method for [`mutable_copy`](@ref) instead.
"""
copy_if_mutable(x) = copy_if_mutable_fallback(mutability(typeof(x)), x)

function operate_to_fallback!(::IsNotMutable, output, op::Function, args...)
    throw(
        ArgumentError(
            "Cannot call `operate_to!(::$(typeof(output)), $op, " *
            "::$(join(typeof.(args), ", ::")))` as objects of type " *
            "`$(typeof(output))` cannot be modifed to equal the result of " *
            "the operation. Use `operate_to!!` instead which returns the " *
            "value of the result (possibly modifying the first argument) to " *
            "write generic code that also works when the type cannot be " *
            "modified.",
        ),
    )
end

function operate_to_fallback!(::IsMutable, output, op::AddSubMul, x, y)
    return operate_to!(output, add_sub_op(op), x, y)
end

function operate_to_fallback!(::IsMutable, output, op::Function, args...)
    return error(
        "`operate_to!(::$(typeof(output)), $op, ::",
        join(typeof.(args), ", ::"),
        ")` is not implemented yet.",
    )
end

"""
    operate_to!(output, op::Function, args...)

Modify the value of `output` to be equal to the value of `op(args...)`. Can
only be called if `mutability(output, op, args...)` returns [`IsMutable`](@ref).

If `output === args[i]` for some `i`, this function may throw an error. Use
`operate!!` or `operate!` instead.

For example, in DynamicPolynomials, `operate_to!(p, +, p, q)` throws an error
because otherwise, the algorithm would fill `p` while iterating over the terms
of `p` and `q` hence it will never terminate. On the other hand
`operate!(+, p, q)` uses a different algorithm that efficiently inserts the
terms of `q` in the sorted list of terms of `p` with minimal displacement.
"""
function operate_to!(output, op::F, args::Vararg{Any,N}) where {F<:Function,N}
    return operate_to_fallback!(
        mutability(output, op, args...),
        output,
        op,
        args...,
    )
end

function operate_fallback!(::IsNotMutable, op::Function, args...)
    return throw(
        ArgumentError(
            "Cannot call `operate!($op, ::$(join(typeof.(args), ", ::")))` " *
            "as objects of type `$(typeof(args[1]))` cannot be modifed to " *
            "equal the result of the operation. Use `operate!!` instead " *
            "which returns the value of the result (possibly modifying the " *
            "first argument) to write generic code that also works when the " *
            "type cannot be modified.",
        ),
    )
end

function operate_fallback!(::IsMutable, op::AddSubMul, x, y)
    return operate!(add_sub_op(op), x, y)
end

function operate_fallback!(::IsMutable, op::Function, args...)
    return error(
        "`operate!($op, ::",
        join(typeof.(args), ", ::"),
        ")` is not implemented yet.",
    )
end

"""
    operate!(op::Function, args...)

Modify the value of `args[1]` to be equal to the value of `op(args...)`. Can
only be called if `mutability(args[1], op, args...)` returns
[`IsMutable`](@ref).
"""
function operate!(op::F, args::Vararg{Any,N}) where {F<:Function,N}
    return operate_fallback!(mutability(args[1], op, args...), op, args...)
end

buffer_for(::F, args::Vararg{Type,N}) where {F<:Function,N} = nothing

# Fix ambiguity identified by Aqua.jl
buffer_for(::AddSubMul) = nothing

function buffered_operate_to_fallback!(
    ::IsNotMutable,
    buffer,
    output,
    op::Function,
    args...,
)
    throw(
        ArgumentError(
            "Cannot call `buffered_operate_to!(::$(typeof(buffer)), " *
            "::$(typeof(output)), $op, ::$(join(typeof.(args), ", ::")))` " *
            "as objects of type `$(typeof(output))` cannot be modifed to " *
            "equal the result of the operation. Use `buffered_operate_to!!` " *
            "instead which returns the value of the result (possibly " *
            "modifying the first argument) to write generic code that also " *
            "works when the type cannot be modified.",
        ),
    )
end

function buffered_operate_to_fallback!(
    ::IsMutable,
    buffer,
    output,
    op::Function,
    args...,
)
    return error(
        "`buffered_operate_to!(::$(typeof(buffer)), ::$(typeof(output)), " *
        "$op, ::$(join(typeof.(args), ", ::")))` is not implemented.",
    )
end

function buffered_operate_to_fallback!(
    buffer,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate_to_fallback!(
        mutability(output, op, args...),
        buffer,
        output,
        op,
        args...,
    )
end

function buffered_operate_to_fallback!(
    ::Nothing,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate_to!(output, op, args...)
end

"""
    buffered_operate_to!(buffer, output, op::Function, args...)

Modify the value of `output` to be equal to the value of `op(args...)`,
possibly modifying `buffer`. Can only be called if
`mutability(output, op, args...)` returns [`IsMutable`](@ref).
"""
function buffered_operate_to!(
    buffer,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate_to_fallback!(buffer, output, op, args...)
end

function buffered_operate_fallback!(
    ::IsNotMutable,
    buffer,
    op::Function,
    args...,
)
    throw(
        ArgumentError(
            "Cannot call `buffered_operate!(::$(typeof(buffer)), $op, " *
            "::$(join(typeof.(args), ", ::")))` as objects of type " *
            "`$(typeof(args[1]))` cannot be modifed to equal the result of " *
            "the operation. Use `buffered_operate!!` instead which returns " *
            "the value of the result (possibly modifying the first argument) " *
            "to write generic code that also works when the type cannot be " *
            "modified.",
        ),
    )
end

function buffered_operate_fallback!(::IsMutable, buffer, op::Function, args...)
    return error(
        "`buffered_operate!(::$(typeof(buffer)), $op, ::",
        join(typeof.(args), ", ::"),
        ")` is not implemented.",
    )
end

function buffered_operate_fallback!(
    buffer,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate_fallback!(
        mutability(args[1], op, args...),
        buffer,
        op,
        args...,
    )
end

function buffered_operate_fallback!(
    ::Nothing,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate!(op, args...)
end

"""
    buffered_operate!(buffer, op::Function, args...)

Modify the value of `args[1]` to be equal to the value of `op(args...)`,
possibly modifying `buffer`. Can only be called if
`mutability(args[1], op, args...)` returns [`IsMutable`](@ref).
"""
function buffered_operate! end

function buffered_operate!(
    buffer,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate_fallback!(buffer, op, args...)
end

"""
    operate_to!(output, op::Function, args...)

Returns the value of `op(args...)`, possibly modifying `output`.
"""
function operate_to!!(output, op::F, args::Vararg{Any,N}) where {F<:Function,N}
    return operate_to_fallback!!(
        mutability(output, op, args...),
        output,
        op,
        args...,
    )
end

function operate_to_fallback!!(
    ::IsNotMutable,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate(op, args...)
end

function operate_to_fallback!!(
    ::IsMutable,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate_to!(output, op, args...)
end

"""
    operate!!(op::Function, args...)

Returns the value of `op(args...)`, possibly modifying `args[1]`.
"""
function operate!!(op::F, args::Vararg{Any,N}) where {F<:Function,N}
    return operate_fallback!!(mutability(args[1], op, args...), op, args...)
end

function operate_fallback!!(
    ::IsNotMutable,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate(op, args...)
end

function operate_fallback!!(
    ::IsMutable,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate!(op, args...)
end

"""
    buffered_operate_to!(buffer, output, op::Function, args...)

Returns the value of `op(args...)`, possibly modifying `buffer` and `output`.
"""
function buffered_operate_to!!(
    buffer,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate_to_fallback!!(
        mutability(output, op, args...),
        buffer,
        output,
        op,
        args...,
    )
end

function buffered_operate_to_fallback!!(
    ::IsNotMutable,
    buffer,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate(op, args...)
end

function buffered_operate_to_fallback!!(
    ::IsMutable,
    buffer,
    output,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate_to!(buffer, output, op, args...)
end

"""
    buffered_operate!!(buffer, op::Function, args...)

Returns the value of `op(args...)`, possibly modifying `buffer`.
"""
function buffered_operate!!(
    buffer,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate_fallback!!(
        mutability(args[1], op, args...),
        buffer,
        op,
        args...,
    )
end

function buffered_operate_fallback!!(
    ::IsNotMutable,
    buffer,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return operate(op, args...)
end

function buffered_operate_fallback!!(
    ::IsMutable,
    buffer,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return buffered_operate!(buffer, op, args...)
end

# For most types, `dot(b, c) = adjoint(b) * c`.
promote_operation_fallback(::typeof(adjoint), a::Type) = a

function promote_operation_fallback(
    ::typeof(LinearAlgebra.dot),
    ::Type{A},
    ::Type{B},
) where {A,B}
    return promote_operation(*, promote_operation(adjoint, A), B)
end

function promote_operation_fallback(
    ::typeof(LinearAlgebra.dot),
    ::Type{<:AbstractArray{A}},
    ::Type{<:AbstractArray{B}},
) where {A,B}
    C = promote_operation(*, A, B)
    return promote_operation(+, C, C)
end

function buffer_for(::typeof(add_dot), a::Type, b::Type, c::Type)
    return buffer_for(add_mul, a, promote_operation(adjoint, b), c)
end

function operate_to_fallback!(::IsMutable, output, ::typeof(add_dot), a, b, c)
    return operate_to!(output, add_mul, a, adjoint(b), c)
end

function operate_fallback!(::IsMutable, ::typeof(add_dot), a, b, c)
    return operate!(add_mul, a, adjoint(b), c)
end

function buffered_operate_to_fallback!(
    ::IsMutable,
    buffer,
    output,
    ::typeof(add_dot),
    a,
    b,
    c,
)
    return buffered_operate_to!(buffer, output, add_mul, a, adjoint(b), c)
end

function buffered_operate_fallback!(
    ::IsMutable,
    buffer,
    ::typeof(add_dot),
    a,
    b,
    c,
)
    return buffered_operate!(buffer, add_mul, a, adjoint(b), c)
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

using Test
import MutableArithmetics as MA
import LinearAlgebra

struct DummyMutable end

function MA.promote_operation(
    ::typeof(+),
    ::Type{DummyMutable},
    ::Type{DummyMutable},
)
    return DummyMutable
end
# Test that this does not triggers any ambiguity even if there is a fallback specific to `/`.
function MA.promote_operation(
    ::Union{typeof(-),typeof(/)},
    ::Type{DummyMutable},
    ::Type{DummyMutable},
)
    return DummyMutable
end
MA.mutability(::Type{DummyMutable}) = MA.IsMutable()

# Theodorus' constant √3 (deined in global scope due to const)
Base.@irrational theodorus 1.73205080756887729353 sqrt(big(3))
@testset "promote_operation" begin
    @test MA.promote_operation(/, Rational{Int}, Rational{Int}) == Rational{Int}
    @test MA.promote_operation(-, DummyMutable, DummyMutable) == DummyMutable
    @test MA.promote_operation(/, DummyMutable, DummyMutable) == DummyMutable
    @testset "Issue #164" begin
        iπ() = MA.promote_operation(+, Int, typeof(π))
        @test iπ() == Float64
        alloc_test(iπ, 0)
        ℯbf() = MA.promote_operation(+, typeof(ℯ), BigFloat)
        @test ℯbf() == BigFloat
        # TODO this allocates as it creates the `BigFloat`
        #alloc_test(ℯbf, 0)
        bγ() = MA.promote_operation(/, Bool, typeof(Base.MathConstants.γ))
        @test bγ() == Float64
        alloc_test(bγ, 0)
        φf32() = MA.promote_operation(*, typeof(Base.MathConstants.φ), Float32)
        @test φf32() == Float32
        alloc_test(φf32, 0)
        # test user-defined Irrational
        i_theodorus() = MA.promote_operation(+, Int, typeof(theodorus))
        @test i_theodorus() == Float64
        alloc_test(i_theodorus, 0)
        # test _instantiate(::Type{S}) where {S<:Irrational} return value
        @test MA._instantiate(typeof(π)) == π
        @test MA._instantiate(typeof(MathConstants.catalan)) ==
              MathConstants.catalan
        @test MA._instantiate(typeof(theodorus)) == theodorus
    end

    for op in [real, imag]
        @test MA.promote_operation(op, ComplexF64) == Float64
        @test MA.promote_operation(op, Complex{Real}) == Real
    end
end

@testset "Errors" begin
    err = ArgumentError(
        "Cannot call `operate_to!(::$Int, +, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `operate_to!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.operate_to!(0, +, 0, 0)
    err = ArgumentError(
        "Cannot call `operate!(+, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `operate!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.operate!(+, 0, 0)
    err = ArgumentError(
        "Cannot call `buffered_operate_to!(::$Int, ::$Int, +, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `buffered_operate_to!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.buffered_operate_to!(0, 0, +, 0, 0)
    err = ArgumentError(
        "Cannot call `buffered_operate!(::$Int, +, ::$Int, ::$Int)` as objects of type `$Int` cannot be modifed to equal the result of the operation. Use `buffered_operate!!` instead which returns the value of the result (possibly modifying the first argument) to write generic code that also works when the type cannot be modified.",
    )
    @test_throws err MA.buffered_operate!(0, +, 0, 0)
    x = DummyMutable()
    err = ErrorException(
        "`operate_to!(::DummyMutable, +, ::DummyMutable, ::DummyMutable)` is not implemented yet.",
    )
    @test_throws err MA.operate_to!(x, +, x, x)
    err = ErrorException(
        "`operate!(+, ::DummyMutable, ::DummyMutable)` is not implemented yet.",
    )
    @test_throws err MA.operate!(+, x, x)
    err = ErrorException(
        "`buffered_operate_to!(::DummyMutable, ::DummyMutable, +, ::DummyMutable, ::DummyMutable)` is not implemented.",
    )
    @test_throws err MA.buffered_operate_to!(x, x, +, x, x)
    err = ErrorException(
        "`buffered_operate!(::DummyMutable, +, ::DummyMutable, ::DummyMutable)` is not implemented.",
    )
    @test_throws err MA.buffered_operate!(x, +, x, x)
end

@testset "operate" begin
    @testset "$T" for T in (Int, BigInt, Rational{Int})
        x = T(7)
        @testset "1-ary $op" for op in [+, *, gcd, lcm, copy, abs]
            a = op(x)
            b = MA.operate(op, x)
            @test a == b
            if MA.mutability(T, op, T) == MA.IsMutable()
                @test a !== b
            end
        end
        ops = [+, *, MA.add_mul, MA.sub_mul, MA.add_dot, gcd, lcm]
        @testset "4-ary $op" for op in ops
            a = op(x, x, x, x)
            b = MA.operate(op, x, x, x, x)
            @test a == b
            if MA.mutability(T, op, T, T, T, T) == MA.IsMutable()
                @test a !== b
            end
        end
        @testset "2-ary $op" for op in [-, /, div]
            a = op(x, x)
            b = MA.operate(op, x, x)
            @test a == b
            if MA.mutability(T, op, T, T) == MA.IsMutable()
                @test a !== b
            end
        end
        @testset "dot" for U in (Int, BigInt, Rational{Int}, Rational{BigInt})
            y = U(5)
            a = LinearAlgebra.dot(x, y)
            b = MA.operate(LinearAlgebra.dot, [x], [y])
            @test a == b
            if MA.mutability(
                promote_type(T, U),
                LinearAlgebra.dot,
                Vector{T},
                Vector{U},
            ) == MA.IsMutable()
                @test a !== b
            end
        end
    end
end

@testset "add_mul for BitArray" begin
    x = BigInt[0, 0]
    MA.operate!!(MA.add_mul, x, big(2), trues(2))
    @test x == BigInt[2, 2]
    MA.operate!!(MA.add_mul, x, big(3), BitVector([true, false]))
    @test x == BigInt[5, 2]
    x = BigInt[0 0; 0 0]
    MA.operate!!(MA.add_mul, x, big(2), trues(2, 2))
    @test x == BigInt[2 2; 2 2]
    MA.operate!!(MA.add_mul, x, big(3), BitArray([true false; true true]))
    @test x == BigInt[5 2; 5 5]
end

@testset "similar_array_type" begin
    @test MA.similar_array_type(BitArray{2}, Int) == Array{Int,2}
    @test MA.similar_array_type(BitArray{2}, Bool) == BitArray{2}
end

@testset "similar_array_type_Diagonal" begin
    z = zeros(2, 2)
    y = MA.operate!!(MA.add_mul, z, big(1), LinearAlgebra.I(2))
    @test y == BigFloat[1 0; 0 1]
    y = MA.operate!!(MA.add_mul, z, 2.4, LinearAlgebra.I(2))
    @test y === z
    @test y == Float64[2.4 0; 0 2.4]
    z = zeros(2, 2)
    y = MA.operate!!(MA.add_mul, z, 2.4, LinearAlgebra.Diagonal(1:2))
    @test y == LinearAlgebra.Diagonal(2.4 * (1:2))
end

@testset "unary op(::$T)" for T in (
    Float64,
    BigFloat,
    Int,
    BigInt,
    Rational{Int},
    Rational{BigInt},
)
    @test MA.operate!!(+, T(7)) == 7
    @test MA.operate!!(*, T(7)) == 7
    @test MA.operate!!(-, T(7)) == -7

    @test MA.operate_to!!(T(6), +, T(7)) == 7
    @test MA.operate_to!!(T(6), *, T(7)) == 7
    @test MA.operate_to!!(T(6), -, T(7)) == -7

    @test MA.operate!!(abs, T(7)) == 7
    @test MA.operate!!(abs, T(-7)) == 7

    @test MA.operate_to!!(T(6), abs, T(7)) == 7
    @test MA.operate_to!!(T(6), abs, T(-7)) == 7
end

@testset "Error-free mutability (issue #240)" begin
    for op in (+, -, *, /, div)
        for T in
            (Float64, BigFloat, Int, BigInt, Rational{Int}, Rational{BigInt})
            @test_nowarn MA.mutability(T, op, T, T) # should run without error
        end
    end
end

@testset "issue_271_mutability" begin
    a = 1
    x = [1; 2;;]
    y = [1 2; 3 4]
    z = [1 2; 3 4; 5 6]
    @test MA.mutability(x, *, x, x') == MA.IsNotMutable()
    @test MA.mutability(x, *, x', x) == MA.IsNotMutable()
    @test MA.mutability(x, *, x, a, x') == MA.IsNotMutable()
    @test MA.mutability(x, *, x', a, x) == MA.IsNotMutable()
    @test MA.mutability(y, *, y, y) == MA.IsMutable()
    @test MA.mutability(y, *, y, y, y) == MA.IsMutable()
    @test MA.mutability(y, *, y, a, y') == MA.IsMutable()
    @test MA.mutability(y, *, y', a, y) == MA.IsMutable()
    @test MA.mutability(y, *, a, a, y) == MA.IsMutable()
    @test MA.mutability(y, *, y, z', z) == MA.IsMutable()
    @test MA.mutability(z, *, z, z) == MA.IsNotMutable()
    @test MA.mutability(z, *, z, z, y) == MA.IsNotMutable()
end

@testset "issue_316_SubArray" begin
    y = reshape([1.0], 1, 1, 1)
    Y = view(y, :, :, 1)
    ret = reshape([1.0], 1, 1)
    ret = MA.operate!!(MA.add_mul, ret, 2.0, Y)
    @test ret == reshape([3.0], 1, 1)
    @test y == reshape([1.0], 1, 1, 1)
end

@testset "issue_318_neutral_element" begin
    a = rand(3)
    A = [rand(2, 2) for _ in 1:3]
    @test_throws DimensionMismatch MA.operate(LinearAlgebra.dot, a, A)
    y = a' * A
    @test isapprox(MA.fused_map_reduce(MA.add_mul, a', A), y)
    z = MA.operate(LinearAlgebra.dot, Int[], Int[])
    @test iszero(z) && z isa Int
    z = MA.operate(LinearAlgebra.dot, BigInt[], Int[])
    @test iszero(z) && z isa BigInt
    z = MA.operate(LinearAlgebra.dot, Int[], Float64[])
    @test iszero(z) && z isa Float64
    z = MA.operate(LinearAlgebra.dot, Matrix{Int}[], Matrix{Float64}[])
    @test iszero(z) && z isa Float64
    @test MA.fused_map_reduce(MA.add_mul, Matrix{Int}[], Float64[]) isa MA.Zero
    @test MA.fused_map_reduce(MA.add_mul, Float64[], Matrix{Int}[]) isa MA.Zero
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# This file contains methods to implement the MutableArithmetics API for
# Base.Rational{T}.

# `Rational` is a `struct`, not a `mutable struct`, so if `T` is not
# mutable, we cannot mutate the rational.
mutability(::Type{Rational{T}}) where {T} = mutability(T)

mutable_copy(x::Rational) = Rational(mutable_copy(x.num), mutable_copy(x.den))

# copy

promote_operation(::typeof(copy), ::Type{Q}) where {Q<:Rational} = Q

function operate_to!(out::Q, ::typeof(copy), in::Q) where {Q<:Rational}
    operate_to!(out.num, copy, in.num)
    operate_to!(out.den, copy, in.den)
    return out
end

operate!(::typeof(copy), x::Rational) = x

# zero

promote_operation(::typeof(zero), ::Type{Rational{T}}) where {T} = Rational{T}

function operate!(::typeof(zero), x::Rational)
    operate!(zero, x.num)
    operate!(one, x.den)
    return x
end

# one

promote_operation(::typeof(one), ::Type{Rational{T}}) where {T} = Rational{T}

function operate!(::typeof(one), x::Rational)
    operate!(one, x.num)
    operate!(one, x.den)
    return x
end

function _buffered_divgcd(buffer, x, x_output, y, y_output)
    operate_to!(buffer, gcd, x, y)
    operate_to!(x_output, div, x, buffer)
    operate_to!(y_output, div, y, buffer)
    return
end

function _buffered_divgcd(buffer, x, y)
    operate_to!(buffer, gcd, x, y)
    if !isone(buffer)
        operate!(div, x, buffer)
        operate!(div, y, buffer)
    end
    return
end

_buffered_simplify(buffer, x::Rational) = _buffered_divgcd(buffer, x.num, x.den)

# + and -

function promote_operation(
    ::Union{typeof(+),typeof(-)},
    ::Type{Rational{S}},
    ::Type{Rational{T}},
) where {S,T}
    return Rational{promote_sum_mul(S, T)}
end

function buffer_for(
    ::Union{typeof(+),typeof(-)},
    ::Type{Rational{S}},
    ::Type{Rational{T}},
) where {S,T}
    U = promote_operation(gcd, S, T)
    return zero(U), zero(U), zero(U)
end

function buffered_operate_to!(
    buffer::Tuple,
    output::Rational,
    op::Union{typeof(-),typeof(+)},
    x::Rational,
    y::Rational,
)
    _buffered_divgcd(buffer[1], x.den, buffer[2], y.den, buffer[3])
    # TODO: Use `checked_mul` and `checked_sub` like in Base
    operate_to!(output.num, *, x.num, buffer[3])
    buffered_operate!(
        buffer[2],
        add_sub_mul_op(op),
        output.num,
        y.num,
        buffer[2],
    )
    operate_to!(output.den, *, x.den, buffer[3])
    _buffered_simplify(buffer[1], output)
    return output
end

function operate_to!(
    output::Rational,
    op::Union{typeof(+),typeof(-)},
    x::Rational,
    y::Rational,
)
    return buffered_operate_to!(
        buffer_for(op, typeof(x), typeof(y)),
        output,
        op,
        x,
        y,
    )
end

function operate_to!(output::Rational, ::typeof(+), x::Rational, y::Rational)
    xd, yd = Base.divgcd(promote(x.den, y.den)...)
    # TODO: Use `checked_mul` and `checked_add` like in Base
    operate_to!(output.num, *, x.num, yd)
    operate!(add_mul, output.num, y.num, xd)
    operate_to!(output.den, *, x.den, yd)
    # Reuse `xd` as it is a local copy created by this method
    _buffered_simplify(xd, output)
    return output
end

function operate_to!(out::Q, ::typeof(+), x::Q) where {Q<:Rational}
    return operate_to!(out, copy, x)
end

operate!(::typeof(+), x::Rational) = x

function operate_to!(out::Q, ::typeof(-), x::Q) where {Q<:Rational}
    operate_to!(out.num, -, x.num)
    operate_to!(out.den, copy, x.den)
    return out
end

function operate!(::typeof(-), x::Rational)
    operate!(-, x.num)
    return x
end

# abs

promote_operation(::typeof(abs), ::Type{Q}) where {Q<:Rational} = Q

function operate!(::typeof(abs), x::Rational)
    operate!(abs, x.num)
    return x
end

function operate_to!(o::Q, ::typeof(abs), x::Q) where {Q<:Rational}
    operate_to!(o.num, abs, x.num)
    operate_to!(o.den, copy, x.den)
    return o
end

# *

function promote_operation(
    ::typeof(*),
    ::Type{Rational{S}},
    ::Type{Rational{T}},
) where {S,T}
    return Rational{promote_operation(*, S, T)}
end

function buffer_for(
    ::typeof(*),
    ::Type{Rational{S}},
    ::Type{Rational{T}},
) where {S,T}
    U = promote_operation(gcd, S, T)
    return zero(Rational{U}), zero(Rational{U}), zero(U)
end

function buffered_operate_to!(
    buffer::Tuple,
    output::Rational,
    ::typeof(*),
    x::Rational,
    y::Rational,
)
    # Cannot use `output.num` and `output.den` as buffer as `output` might be an alias for `x`
    _buffered_divgcd(buffer[3], x.num, buffer[1].num, y.den, buffer[2].den)
    _buffered_divgcd(buffer[3], x.den, buffer[1].den, y.num, buffer[2].num)
    operate_to!(output.num, *, buffer[1].num, buffer[2].num)
    operate_to!(output.den, *, buffer[1].den, buffer[2].den)
    return output
end

function operate_to!(output::Rational, ::typeof(*), x::Rational, y::Rational)
    return buffered_operate_to!(
        buffer_for(*, typeof(x), typeof(y)),
        output,
        *,
        x,
        y,
    )
end

function operate_to!(out::Q, ::typeof(*), x::Q) where {Q<:Rational}
    return operate_to!(out, copy, x)
end

operate!(::typeof(*), x::Rational) = x

# gcd

function promote_operation(
    ::Union{typeof(gcd),typeof(lcm)},
    ::Type{Rational{S}},
    ::Type{Rational{T}},
) where {S,T}
    return Rational{promote_operation(gcd, S, T)}
end

function operate_to!(output::Rational, ::typeof(gcd), a::Rational, b::Rational)
    operate_to!(output.num, gcd, a.num, b.num)
    operate_to!(output.den, lcm, a.den, b.den)
    return output
end

function operate_to!(output::Rational, ::typeof(lcm), a::Rational, b::Rational)
    operate_to!(output.num, lcm, a.num, b.num)
    operate_to!(output.den, gcd, a.den, b.den)
    return output
end

function operate_to!(
    output::Rational,
    op::Union{typeof(+),typeof(-),typeof(*)},
    a::Rational,
    b::Rational,
    c::Vararg{Rational,N},
) where {N}
    operate_to!(output, op, a, b)
    return operate!(op, output, c...)
end

function operate!(op::Function, x::Rational, args::Vararg{Any,N}) where {N}
    return operate_to!(x, op, x, args...)
end

# add_mul and sub_mul

# Buffer to hold the product
function buffer_for(op::AddSubMul, args::Vararg{Type{<:Rational},N}) where {N}
    U = promote_operation(*, args...)
    return buffer_for(*, Base.tail(args)...),
    zero(U),
    buffer_for(add_sub_op(op), args[1], U)
end

function operate_to!(
    output::Rational,
    op::AddSubMul,
    x::Rational,
    y::Rational,
    z::Rational,
    args::Vararg{Rational,N},
) where {N}
    buffer = buffer_for(op, typeof(x), typeof(y), typeof(z), typeof.(args)...)
    return buffered_operate_to!(buffer, output, op, x, y, z, args...)
end

function buffered_operate_to!(
    buffer::Tuple,
    output::Rational,
    op::AddSubMul,
    a::Rational,
    x::Rational,
    y::Rational,
    args::Vararg{Rational,N},
) where {N}
    buffered_operate_to!(buffer[1], buffer[2], *, x, y, args...)
    return buffered_operate_to!(buffer[3], output, add_sub_op(op), a, buffer[2])
end

function buffered_operate!(
    buffer,
    op::AddSubMul,
    x::Rational,
    args::Vararg{Any,N},
) where {N}
    return buffered_operate_to!(buffer, x, op, x, args...)
end

function operate_to!(
    output::Rational,
    op::Union{typeof(+),typeof(-),typeof(*)},
    args::Vararg{Scaling,N},
) where {N}
    return operate_to!(output, op, _scaling_to.(typeof(output), args)...)
end

function operate_to!(
    output::Rational,
    op::AddSubMul,
    x::Scaling,
    y::Scaling,
    z::Scaling,
    args::Vararg{Scaling,N},
) where {N}
    return operate_to!(
        output,
        op,
        _scaling_to(typeof(output), x),
        _scaling_to(typeof(output), y),
        _scaling_to(typeof(output), z),
        _scaling_to.(typeof(output), args)...,
    )
end

# Called for instance if `args` is `(v', v)` for a vector `v`.
function operate_to!(
    output::Rational,
    op::AddSubMul,
    x,
    y,
    z,
    args::Vararg{Any,N},
) where {N}
    return operate_to!(output, add_sub_op(op), x, *(y, z, args...))
end

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

abstract type OpSignature end
struct RegularSignature <: OpSignature end
struct ToSignature <: OpSignature end

function signature_type_of(
    ::Union{typeof(MA.operate),typeof(MA.operate!),typeof(MA.operate!!)},
)
    return RegularSignature()
end

function signature_type_of(
    ::Union{typeof(MA.operate_to!),typeof(MA.operate_to!!)},
)
    return ToSignature()
end

function op_may_modify_first_argument(op::Function)
    return (op != MA.operate) & (signature_type_of(op) == RegularSignature())
end

function op_is_allowed_for_arithmetic(
    ::typeof(evalpoly),
    ::Union{typeof(MA.operate!),typeof(MA.operate_to!)},
    ::Type{F},
) where {F<:Any}
    return MA.mutability(F) == MA.IsMutable()
end

function op_is_allowed_for_arithmetic(
    ::typeof(evalpoly),
    ::Union{typeof(MA.operate),typeof(MA.operate!!),typeof(MA.operate_to!!)},
    ::Type{F},
) where {F<:Any}
    return true
end

function allowed_allocated_byte_count(
    ::typeof(evalpoly),
    ::Union{typeof(MA.operate),typeof(MA.operate!),typeof(MA.operate!!)},
    ::Type{F},
) where {F<:Any}
    return @allocated zero(F)
end

function allowed_allocated_byte_count(
    ::typeof(evalpoly),
    ::Union{typeof(MA.operate_to!),typeof(MA.operate_to!!)},
    ::Type{F},
) where {F<:Any}
    return @allocated nothing
end

const evalpoly_supported_arithmetics =
    (BigFloat, Rational{Int}, Float64, Float32, Int)

const evalpoly_operations =
    (MA.operate, MA.operate!, MA.operate_to!, MA.operate!!, MA.operate_to!!)

@testset "evalpoly with $op and $F" for F in evalpoly_supported_arithmetics,
    op in evalpoly_operations

    op_is_allowed_for_arithmetic(evalpoly, op, F) || continue

    sig = signature_type_of(op)

    if MA.mutability(F) == MA.IsMutable()
        @testset "empty coefficients $collection_type" for collection_type in
                                                           ("vector", "tuple")
            out = one(F)
            x = one(F)
            backup = MA.copy_if_mutable(x)
            coefs = F[]
            if collection_type == "tuple"
                coefs = ()
            end

            # Check that the result value is OK
            if sig == RegularSignature()
                @test iszero(@inferred op(evalpoly, x, coefs))
            elseif sig == ToSignature()
                @test iszero(@inferred op(out, evalpoly, x, coefs))
            else
                error("unexpected")
            end

            # Check that the arguments are unmodified
            op_may_modify_first_argument(op) || @test backup == x
        end
    end

    @testset "exact values: $degree, $x_int" for degree in 0:4, x_int in -5:5
        coefs_int = rand(-6:6, degree + 1)

        coefs = map(F, coefs_int)
        x = F(x_int)

        reference = evalpoly(x, coefs)

        @test reference == evalpoly(x_int, coefs_int)

        @testset "collection type $collection_type" for collection_type in
                                                        ("vector", "tuple")
            out = zero(F)
            if collection_type == "vector"
                coefs_arg = coefs
            else
                coefs_arg = (coefs...,)
            end
            if sig == RegularSignature()
                out = @inferred op(evalpoly, x, coefs_arg)
            elseif sig == ToSignature()
                out = @inferred op(out, evalpoly, x, coefs_arg)
            else
                error("unexpected")
            end

            # Check that the result value is OK
            @test reference == out

            # Check that the arguments are unmodified
            if op_may_modify_first_argument(op)
                x = F(x_int)
            else
                @test x == F(x_int)
            end
            @test coefs == map(F, coefs_int)
        end
    end

    @testset "allocation" begin
        byte_cnt = allowed_allocated_byte_count(evalpoly, op, F)
        coefs_tuple = map(F, (0, 1, 0, 1, 1))
        @testset "collection type $collection_type" for collection_type in
                                                        ("vector", "tuple")
            if collection_type == "vector"
                coefs = collect(coefs_tuple)
            else
                coefs = coefs_tuple
            end
            local tested_fun
            if sig == RegularSignature()
                tested_fun = let x = one(F), coefs = coefs
                    () -> op(evalpoly, x, coefs)
                end
            elseif sig == ToSignature()
                tested_fun = let o = one(F), x = one(F), coefs = coefs
                    () -> op(o, evalpoly, x, coefs)
                end
            else
                error("unexpected")
            end
            alloc_test(tested_fun, byte_cnt)
        end
    end
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module Test

import MutableArithmetics as MA

using LinearAlgebra, SparseArrays, Test

include("config.jl")

include("int.jl")
include("generic.jl")
include("scalar.jl")
include("quadratic.jl")
include("array.jl")
include("sparse.jl")

end # module

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

import LinearAlgebra
import MutableArithmetics as MA

struct DummyMutable end

function MA.promote_operation(
    ::typeof(+),
    ::Type{DummyMutable},
    ::Type{DummyMutable},
)
    return DummyMutable
end

# Test that this does not triggers any ambiguity even if there is a fallback specific to `/`.
function MA.promote_operation(
    ::Union{typeof(-),typeof(/)},
    ::Type{DummyMutable},
    ::Type{DummyMutable},
)
    return DummyMutable
end

MA.mutability(::Type{DummyMutable}) = MA.IsMutable()

# It does not support operation with floats on purpose to test that
# MutableArithmetics does not convert to float when it shouldn't.
struct DummyBigInt <: MA.AbstractMutable
    data::BigInt
end

DummyBigInt(J::LinearAlgebra.UniformScaling) = DummyBigInt(J.λ)

# Broadcast
Base.broadcastable(x::DummyBigInt) = Ref(x)

# The version with `DummyBigInt` without `Type` is needed in LinearAlgebra for
# Julia v1.6+.
Base.ndims(::Union{Type{DummyBigInt},DummyBigInt}) = 0

function Base.promote_rule(
    ::Type{DummyBigInt},
    ::Type{<:Union{Integer,LinearAlgebra.UniformScaling{<:Integer}}},
)
    return DummyBigInt
end

# `copy` on BigInt returns the same instance anyway
Base.copy(x::DummyBigInt) = x

MA.mutable_copy(x::DummyBigInt) = DummyBigInt(MA.mutable_copy(x.data))

LinearAlgebra.symmetric_type(::Type{DummyBigInt}) = DummyBigInt

LinearAlgebra.symmetric(x::DummyBigInt, ::Symbol) = x

LinearAlgebra.issymmetric(::DummyBigInt) = true

LinearAlgebra.hermitian_type(::Type{DummyBigInt}) = DummyBigInt

LinearAlgebra.hermitian(x::DummyBigInt, ::Symbol) = x

LinearAlgebra.dot(x::DummyBigInt, y::DummyBigInt) = x * y

function LinearAlgebra.dot(
    x::DummyBigInt,
    y::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
)
    return x * y
end

function LinearAlgebra.dot(
    x::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
    y::DummyBigInt,
)
    return x * y
end

LinearAlgebra.transpose(x::DummyBigInt) = x

LinearAlgebra.adjoint(x::DummyBigInt) = x

MA.mutability(::Type{DummyBigInt}) = MA.IsMutable()

MA.promote_operation(::typeof(zero), ::Type{DummyBigInt}) = DummyBigInt

MA.promote_operation(::typeof(one), ::Type{DummyBigInt}) = DummyBigInt

function MA.promote_operation(
    ::typeof(+),
    ::Type{DummyBigInt},
    ::Type{DummyBigInt},
)
    return DummyBigInt
end

_data(x) = x

_data(x::DummyBigInt) = x.data

MA.scaling(x::DummyBigInt) = x

function MA.operate_to!(
    x::DummyBigInt,
    op::Function,
    args::Union{MA.Scaling,DummyBigInt}...,
)
    return DummyBigInt(MA.operate_to!(x.data, op, _data.(args)...))
end

function MA.buffer_for(
    ::MA.AddSubMul,
    args::Vararg{Type{DummyBigInt},N},
) where {N}
    return DummyBigInt(BigInt())
end

_undummy(x) = x

_undummy(x::DummyBigInt) = x.data

function MA.buffered_operate_to!(
    buffer::DummyBigInt,
    output::DummyBigInt,
    op::Function,
    args::Vararg{Union{MA.Scaling,DummyBigInt},N},
) where {N}
    MA.buffered_operate_to!(
        buffer.data,
        output.data,
        output,
        op,
        _undummy.(args)...,
    )
    return output
end

function MA.buffered_operate!(
    buffer::DummyBigInt,
    op::Function,
    args::Vararg{Union{MA.Scaling,DummyBigInt},N},
) where {N}
    MA.buffered_operate!(buffer.data, op, _undummy.(args)...)
    return args[1]
end

# Called for instance if `args` is `(v', v)` for a vector `v`.
function MA.operate_to!(
    output::DummyBigInt,
    op::MA.AddSubMul,
    x::Union{MA.Scaling,DummyBigInt},
    y::Union{MA.Scaling,DummyBigInt},
    z::Union{MA.Scaling,DummyBigInt},
    args::Union{MA.Scaling,DummyBigInt}...,
)
    return MA.operate_to!(output, MA.add_sub_op(op), x, *(y, z, args...))
end

function MA.operate_to!(output::DummyBigInt, op::MA.AddSubMul, x, y, z, args...)
    return MA.operate_to!(output, MA.add_sub_op(op), x, *(y, z, args...))
end

function MA.operate!(
    op::Function,
    x::DummyBigInt,
    args::Vararg{Any,N},
) where {N}
    return MA.operate_to!(x, op, x, args...)
end

function MA.operate!(op::Union{typeof(zero),typeof(one)}, x::DummyBigInt)
    return DummyBigInt(MA.operate!(op, x.data))
end

function MA.promote_operation(
    ::typeof(*),
    ::Type{DummyBigInt},
    ::Type{DummyBigInt},
)
    return DummyBigInt
end

Base.convert(::Type{DummyBigInt}, x::Int) = DummyBigInt(x)

MA.isequal_canonical(x::DummyBigInt, y::DummyBigInt) = x.data == y.data

Base.iszero(x::DummyBigInt) = iszero(x.data)

Base.isone(x::DummyBigInt) = isone(x.data)

# We don't define == to tests that implementation of MA can pass the tests
# without defining ==.
#
# This is the case for MOI functions for instance.
#
# For the same reason, we only define `zero` and `one` for `Type{DummyBigInt}`,
# not for `DummyBigInt`.

Base.zero(::Type{DummyBigInt}) = DummyBigInt(zero(BigInt))

Base.one(::Type{DummyBigInt}) = DummyBigInt(one(BigInt))

Base.:+(x::DummyBigInt) = DummyBigInt(+x.data)

Base.:+(x::DummyBigInt, y::DummyBigInt) = DummyBigInt(x.data + y.data)

function Base.:+(
    x::DummyBigInt,
    y::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
)
    return DummyBigInt(x.data + y)
end

function Base.:+(
    x::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
    y::DummyBigInt,
)
    return DummyBigInt(x + y.data)
end

Base.:-(x::DummyBigInt) = DummyBigInt(-x.data)

Base.:-(x::DummyBigInt, y::DummyBigInt) = DummyBigInt(x.data - y.data)

function Base.:-(
    x::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
    y::DummyBigInt,
)
    return DummyBigInt(x - y.data)
end

function Base.:-(
    x::DummyBigInt,
    y::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
)
    return DummyBigInt(x.data - y)
end

Base.:*(x::DummyBigInt) = x

Base.:*(x::DummyBigInt, y::DummyBigInt) = DummyBigInt(x.data * y.data)

function Base.:*(
    x::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
    y::DummyBigInt,
)
    return DummyBigInt(x * y.data)
end

function Base.:*(
    x::DummyBigInt,
    y::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
)
    return DummyBigInt(x.data * y)
end

function Base.:^(
    x::DummyBigInt,
    y::Union{Integer,LinearAlgebra.UniformScaling{<:Integer}},
)
    return DummyBigInt(x.data^y)
end

Base.:*(x::Complex, y::DummyBigInt) = x * y.data

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# This file provides a mutable broadcast interface for types that support
# mutation.

function _broadcasted_type(
    ::Broadcast.DefaultArrayStyle{N},
    ::Base.HasShape{N},
    ::Type{Eltype},
) where {N,Eltype}
    return Array{Eltype,N}
end

function _broadcasted_type(
    ::Broadcast.DefaultArrayStyle{N},
    ::Base.HasShape{N},
    ::Type{Bool},
) where {N}
    return BitArray{N}
end

"""
This method is a generic fallback for array types that are not
`DefaultArrayStyle`. Because we can't tell the container from a generic
broadcast style, we fallback to `Any`, which is always a valid super type (just
not a helpful one).

In MutableArithmetics, `_broadcasted_type` appears only in `promote_broadcast`,
which itself appears only in `broadcast_mutability`, and so types hitting this
method will fallback to the `IsNotMutable()` branch, which is the expected
outcome.
"""
_broadcasted_type(::Broadcast.BroadcastStyle, ::Base.HasShape, ::Type) = Any

# Same as `Base.Broadcast._combine_styles` but with types as argument.
_combine_styles() = Broadcast.DefaultArrayStyle{0}()

_combine_styles(c::Type) = Broadcast.result_style(Broadcast.BroadcastStyle(c))

function _combine_styles(c1::Type, c2::Type)
    return Broadcast.result_style(_combine_styles(c1), _combine_styles(c2))
end

@inline function _combine_styles(
    c1::Type,
    c2::Type,
    cs::Vararg{Type,N},
) where {N}
    return Broadcast.result_style(
        _combine_styles(c1),
        _combine_styles(c2, cs...),
    )
end

_combine_shapes(s) = s

function _combine_2_shapes(::Base.HasShape{N}, ::Base.HasShape{M}) where {N,M}
    return Base.HasShape{max(N, M)}()
end

function _combine_shapes(s1, s2, args::Vararg{Any,N}) where {N}
    return _combine_shapes(_combine_2_shapes(s1, s2), args...)
end

_shape(T) = Base.HasShape{ndims(T)}()

function _combine_sizes(args::Vararg{Any,N}) where {N}
    return _combine_shapes(_shape.(args)...)
end

function promote_broadcast(op::F, args::Vararg{Any,N}) where {F<:Function,N}
    # TODO: we could use `promote_operation` instead as `combine_eltypes` uses
    # `return_type` hence it may return a non-concrete type and we do not handle
    # that case.
    T = Base.Broadcast.combine_eltypes(op, args)
    return _broadcasted_type(
        _combine_styles(args...),
        _combine_sizes(args...),
        T,
    )
end

"""
    broadcast_mutability(T::Type, ::typeof(op), args::Type...)::MutableTrait

Return `IsMutable` to indicate an object of type `T` can be modified to be
equal to `broadcast(op, args...)`.
"""
function broadcast_mutability(T::Type, op, args::Vararg{Type,N}) where {N}
    if mutability(T) isa IsMutable && promote_broadcast(op, args...) == T
        return IsMutable()
    else
        return IsNotMutable()
    end
end

function broadcast_mutability(x, op, args::Vararg{Any,N}) where {N}
    return broadcast_mutability(typeof(x), op, typeof.(args)...)
end

# Some AbstractArray, like JuMP.Containers.SparseAxisArray, do not support
# Base.size. In such cases, we default to returning `false`, since we cannot
# safely decide whether a broadcast can be stored in `x` unless we know the
# sizes of the two entries.
function _try_size(x::AbstractArray)
    try
        return size(x)
    catch
        return missing
    end
end
_try_size(x::Array) = size(x)

_checked_size(x_size::Any, y::AbstractArray) = x_size == _try_size(y)
_checked_size(::Any, ::Any) = true
_checked_size(::Any, ::Tuple{}) = true
function _checked_size(x_size::Any, y::Tuple)
    return _checked_size(x_size, y[1]) && _checked_size(x_size, Base.tail(y))
end
_checked_size(::Missing, ::Tuple) = false
_checked_size(::Missing, ::Tuple{}) = false

# This method is a slightly tricky one:
#
# If the elements in the broadcast are different sized arrays, weird things can
# happen during broadcasting since we'll either need to return a different size
# to `x`, or multiple copies of an argument will be used for different parts of
# `x`. To simplify, let's just return `IsNotMutable` if the sizes are different,
# which will be slower but correct.
function broadcast_mutability(
    x::AbstractArray,
    op,
    args::Vararg{Any,N},
) where {N}
    if !_checked_size(_try_size(x), args)::Bool
        return IsNotMutable()
    end
    return broadcast_mutability(typeof(x), op, typeof.(args)...)
end

broadcast_mutability(::Type) = IsNotMutable()

"""
    broadcast!(op::Function, args...)

Modify the value of `args[1]` to be equal to the value of
`broadcast(op, args...)`.

This method can only be called if `mutability(args[1], op, args...)` returns
[`IsMutable`](@ref).
"""
function broadcast! end

function mutable_broadcasted(broadcasted::Broadcast.Broadcasted{S}) where {S}
    function f(args::Vararg{Any,N}) where {N}
        return operate!!(broadcasted.f, args...)
    end
    return Broadcast.Broadcasted{S}(f, broadcasted.args, broadcasted.axes)
end

# If A is `Symmetric`, we cannot do a normal broadcast because we might modify
# the same entry twice. See https://github.com/jump-dev/JuMP.jl/issues/2102
function broadcast!(
    op::F,
    A::Union{Array,SparseArrays.AbstractSparseArray},
    args::Vararg{Any,N},
) where {F<:Function,N}
    bc = Broadcast.broadcasted(op, A, args...)
    instantiated = Broadcast.instantiate(bc)
    return copyto!(A, mutable_broadcasted(instantiated))
end

_any_uniform_scaling() = false

function _any_uniform_scaling(
    ::LinearAlgebra.UniformScaling,
    args::Vararg{Any,N},
) where {N}
    return true
end

function _any_uniform_scaling(::Any, args::Vararg{Any,N}) where {N}
    return _any_uniform_scaling(args...)
end

"""
    broadcast!!(op::Function, args...)

Returns the value of `broadcast(op, args...)`, possibly modifying `args[1]`.
"""
function broadcast!!(op::F, args::Vararg{Any,N}) where {F<:Function,N}
    # `any(x -> x isa LinearAlgebra.UniformScaling, args)` produces
    # `(1 allocation: 32 bytes)` on Julia v1.6.1 so we use
    # `_any_uniform_scaling` instead.
    if _any_uniform_scaling(args...)
        return _broadcast_with_uniform_scaling!(op, args...)
    else
        return broadcast_fallback!(
            broadcast_mutability(args[1], op, args...),
            op,
            args...,
        )
    end
end

function _broadcast_with_uniform_scaling!(
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return op(args...)
end

function broadcast_fallback!(
    ::IsNotMutable,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return broadcast(op, args...)
end

function broadcast_fallback!(
    ::IsMutable,
    op::F,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return broadcast!(op, args...)
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestInt

using Test
import MutableArithmetics as MA

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

function test_promote_operation()
    @test MA.promote_operation(MA.zero, Int) == Int
    @test MA.promote_operation(MA.one, Int) == Int
    @test MA.promote_operation(+, Int, Int) == Int
    @test MA.promote_operation(+, Int, Int, Int) == Int
    @test MA.promote_operation(-, Int, Int) == Int
    @test MA.promote_operation(*, Int, Int) == Int
    @test MA.promote_operation(*, Int, Int, Int) == Int
    @test MA.promote_operation(gcd, Int, Int) == Int
    @test MA.promote_operation(gcd, Int, Int, Int) == Int
    @test MA.promote_operation(MA.add_mul, Int, Int, Int) == Int
    for op in [+, -, MA.add_mul, MA.sub_mul]
        err = ErrorException(
            "Operation `$op` between `$(Vector{Int})` and `$Int` is not allowed. You should use broadcast.",
        )
        @test_throws err MA.promote_operation(op, Vector{Int}, Int)
        err = ErrorException(
            "Operation `$op` between `$Int` and `$(Vector{Int})` is not allowed. You should use broadcast.",
        )
        @test_throws err MA.promote_operation(op, Int, Vector{Int})
    end
    for op in [+, -, *, /, div]
        @test MA.promote_operation(op, Int, Number) == Number
        @test MA.promote_operation(op, Number, Int) == Number
    end
    @test MA.promote_operation(/, Int, Integer) == Float64
    @test MA.promote_operation(/, Integer, Integer) == Float64
    @test MA.promote_operation(/, Integer, Int) == Float64
    @test MA.promote_operation(gcd, Int, Integer) == Integer
    @test MA.promote_operation(gcd, Integer, Integer) == Integer
    @test MA.promote_operation(gcd, Integer, Int) == Integer
    @test MA.promote_operation(&, Integer, Integer, Integer) == Integer
    @test MA.promote_operation(&, Integer, Integer, Int) == Integer
    return
end

function test_add_to!!_add!!()
    @test MA.mutability(Int, MA.add_to!!, Int, Int) isa MA.IsNotMutable
    @test MA.mutability(Int, MA.add!!, Int) isa MA.IsNotMutable
    a = 5
    b = 28
    c = 41
    @test MA.add_to!!(a, b, c) == 69
    @test MA.add!!(b, c) == 69
    a = 165
    b = 255
    @test MA.add!!(a, b) == 420
    return
end

function test_mul_to!!_mul!!()
    @test MA.mutability(Int, MA.mul_to!!, Int, Int) isa MA.IsNotMutable
    @test MA.mutability(Int, MA.mul!!, Int) isa MA.IsNotMutable
    a = 5
    b = 23
    c = 3
    @test MA.mul_to!!(a, b, c) == 69
    @test MA.mul!!(b, c) == 69
    a = 15
    b = 28
    @test MA.mul!!(a, b) == 420
    return
end

function test_add_mul_to!!_add_mul!!_add_mul_buf_to!!_add_mul_buf!!()
    @test MA.mutability(Int, MA.add_mul_to!!, Int, Int, Int) isa MA.IsNotMutable
    @test MA.mutability(Int, MA.add_mul!!, Int, Int) isa MA.IsNotMutable
    @test MA.mutability(Int, MA.add_mul_buf_to!!, Int, Int, Int, Int) isa
          MA.IsNotMutable
    @test MA.mutability(Int, MA.add_mul_buf!!, Int, Int, Int) isa
          MA.IsNotMutable
    a = 5
    b = 9
    c = 3
    d = 20
    buf = 24
    @test MA.add_mul_to!!(a, b, c, d) == 69
    @test MA.add_mul!!(b, c, d) == 69
    @test MA.add_mul_buf_to!!(buf, a, b, c, d) == 69
    @test MA.add_mul_buf!!(buf, b, c, d) == 69
    a = 148
    b = 16
    c = 17
    @test MA.add_mul!!(a, b, c) == 420
    a = 148
    b = 16
    c = 17
    buf = 56
    @test MA.add_mul_buf!!(buf, a, b, c) == 420
    a = 148
    b = 16
    c = 17
    d = 42
    buf = 56
    @test MA.add_mul_buf_to!!(buf, d, a, b, c) == 420
    return
end

function test_zero!!()
    @test MA.mutability(Int, MA.zero!!) isa MA.IsNotMutable
    a = 5
    @test MA.zero!!(a) == 0
    return
end

function test_one!!()
    @test MA.mutability(Int, MA.one!!) isa MA.IsNotMutable
    a = 5
    @test MA.one!!(a) == 1
    return
end

function test_Zero_Int()
    @test MA.Zero() / 1 == MA.Zero()
    @test_throws DivideError MA.Zero() / 0
    return
end

function test_Division()
    @test 1 / 2 == MA.operate!!(/, 1, 2)
    return
end

end  # module

TestInt.runtests()

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

macro test_suite(setname, subsets = false)
    testname = Symbol(string(setname) * "_test")
    testdict = Symbol(string(testname) * "s")
    if subsets
        runtest = :(f(args...; exclude = exclude))
    else
        runtest = :(f(args...))
    end
    return esc(
        :(function $testname(args...; exclude::Vector{String} = String[])
            for (name, f) in $testdict
                if name in exclude
                    continue
                end
                @testset "$name" begin
                    $runtest
                end
            end
        end),
    )
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

"""
    @rewrite(expr, move_factors_into_sums = true)

Return the value of `expr`, exploiting the mutability of the temporary
expressions created for the computation of the result.

If you have an `Expr` as input, use [`rewrite_and_return`](@ref) instead.

See [`rewrite`](@ref) for an explanation of the keyword argument.

!!! info
    Passing `move_factors_into_sums` after a `;` is not supported. Use a `,`
    instead.
"""
macro rewrite(args...)
    @assert 1 <= length(args) <= 2
    if length(args) == 1
        return rewrite_and_return(args[1]; move_factors_into_sums = true)
    end
    @assert Meta.isexpr(args[2], :(=), 2) &&
            args[2].args[1] == :move_factors_into_sums
    return rewrite_and_return(args[1]; move_factors_into_sums = args[2].args[2])
end

struct Zero end

# This method is called in various `promote_operation_fallback` methods if one
# of the arguments is `::Zero`.
Base.zero(::Type{Zero}) = Zero()

## We need to copy `x` as it will be used as might be given by the user and be
## given as first argument of `operate!!`.
#Base.:(+)(zero::Zero, x) = copy_if_mutable(x)
## `add_mul(zero, ...)` redirects to `muladd(..., zero)` which calls `... + zero`.
#Base.:(+)(x, zero::Zero) = copy_if_mutable(x)
function operate(::typeof(add_mul), ::Zero, args::Vararg{Any,N}) where {N}
    return operate(*, args...)
end

function operate(::typeof(sub_mul), ::Zero, x)
    # `operate(*, x)` would redirect to `copy_if_mutable(x)` which would be a
    # useless copy.
    return operate(-, x)
end

function operate(::typeof(sub_mul), ::Zero, x, y, args::Vararg{Any,N}) where {N}
    return operate(-, operate(*, x, y, args...))
end

broadcast!!(::Union{typeof(add_mul),typeof(+)}, ::Zero, x) = copy_if_mutable(x)

broadcast!!(::typeof(add_mul), ::Zero, x, y) = x * y

# Needed in `@rewrite(1 .+ sum(1 for i in 1:0) * 1^2)`
# These methods are narrowed to `Number` and `AbstractArray` to avoid invalidating
# the very broad `+(x, y)`, `*(x, y)` fallbacks in Base, which causes thousands of
# method invalidations across the ecosystem. Downstream packages that define custom
# types participating in MutableArithmetics rewrites should define their own
# `+(::MyType, ::Zero)` etc. methods.
Base.:*(z::Zero, ::Number) = z
Base.:*(::Number, z::Zero) = z
Base.:*(z::Zero, ::AbstractArray) = z
Base.:*(::AbstractArray, z::Zero) = z
Base.:*(z::Zero, ::Zero) = z
Base.:+(::Zero, x::Number) = x
Base.:+(x::Number, ::Zero) = x
Base.:+(::Zero, x::AbstractArray) = x
Base.:+(x::AbstractArray, ::Zero) = x
Base.:+(z::Zero, ::Zero) = z
Base.:-(::Zero, x::Number) = -x
Base.:-(x::Number, ::Zero) = x
Base.:-(::Zero, x::AbstractArray) = -x
Base.:-(x::AbstractArray, ::Zero) = x
Base.:-(z::Zero, ::Zero) = z
Base.:-(z::Zero) = z
Base.:+(z::Zero) = z
Base.:*(z::Zero) = z

function Base.:/(z::Zero, x::Number)
    if iszero(x)
        throw(DivideError())
    end
    return z
end

Base.iszero(::Zero) = true
Base.isone(::Zero) = false

# These methods are used to provide an efficient implementation for the common
# case like `x^2 * sum(f for i in 1:0)`, which lowers to
# `_MA.operate!!(*, x^2, _MA.Zero())`. We don't need the method with reversed
# arguments because MA.Zero is not mutable, and MA never queries the mutablility
# of arguments if the first is not mutable.
promote_operation(::typeof(*), ::Type{<:Any}, ::Type{Zero}) = Zero

function promote_operation(
    ::typeof(*),
    ::Type{<:AbstractArray{T}},
    ::Type{Zero},
) where {T}
    return Zero
end

# Needed by `@rewrite(BigInt(1) .+ sum(1 for i in 1:0) * 1^2)`
# since we don't require mutable type to support Zero in
# `mutable_operate!`.
_any_zero() = false
_any_zero(::Any, args::Vararg{Any,N}) where {N} = _any_zero(args...)
_any_zero(::Zero, ::Vararg{Any,N}) where {N} = true

function operate!!(
    op::Union{typeof(add_mul),typeof(sub_mul)},
    x,
    args::Vararg{Any,N},
) where {N}
    if _any_zero(args...)
        return x
    else
        return operate_fallback!!(mutability(x, op, x, args...), op, x, args...)
    end
end

# Needed for `@rewrite(BigInt(1) .+ sum(1 for i in 1:0) * 1^2)`
Base.broadcastable(z::Zero) = Ref(z)
Base.ndims(::Type{Zero}) = 0
Base.length(::Zero) = 1
Base.iterate(z::Zero) = (z, nothing)
Base.iterate(::Zero, ::Nothing) = nothing

# See `JuMP._try_parse_idx_set`
function _try_parse_idx_set(arg::Expr)
    # [i=1] and x[i=1] parse as Expr(:vect, Expr(:(=), :i, 1)) and
    # Expr(:ref, :x, Expr(:kw, :i, 1)) respectively.
    if arg.head === :kw || arg.head === :(=)
        @assert length(arg.args) == 2
        return true, arg.args[1], arg.args[2]
    elseif isexpr(arg, :call) && arg.args[1] === :in
        # FIXME It seems not to be called anymore on Julia v1.0 as `i in idx`
        #       is parsed as `i = idx`.
        return true, arg.args[2], arg.args[3]
    else
        # FIXME When is this called ?
        return false, nothing, nothing
    end
end

function _parse_idx_set(arg::Expr)
    parse_done, idxvar, idxset = _try_parse_idx_set(arg)
    if !parse_done
        error("Invalid syntax: $arg")
    end
    return idxvar, idxset
end

"""
    rewrite_generator(expr::Expr, inner::Function)

Rewrites the generator statements `expr` and returns a properly nested for loop
with nested filters as specified.

# Examples

```jldoctest
julia> using MutableArithmetics

julia> MutableArithmetics.rewrite_generator(:(i for i in 1:2 if isodd(i)), i -> :(\$i + 1))
:(for \$(Expr(:escape, :(i = 1:2)))
      if \$(Expr(:escape, :(isodd(i))))
          i + 1
      end
  end)
```
"""
function rewrite_generator(ex, inner)
    # `i + j for i in 1:2 for j in 1:2` is a `flatten` expression
    if isexpr(ex, :flatten)
        return rewrite_generator(ex.args[1], inner)
    elseif !isexpr(ex, :generator)
        return inner(ex)
    end
    # `i + j for i in 1:2, j in 1:2` is a `generator` expression
    function itrsets(sets)
        if isa(sets, Expr)
            return sets
        elseif length(sets) == 1
            return sets[1]
        else
            return Expr(:block, sets...)
        end
    end

    idxvars = []
    if isexpr(ex.args[2], :filter) # if condition
        loop = Expr(
            :for,
            esc(itrsets(ex.args[2].args[2:end])),
            Expr(
                :if,
                esc(ex.args[2].args[1]),
                rewrite_generator(ex.args[1], inner),
            ),
        )
        for idxset in ex.args[2].args[2:end]
            idxvar, s = _parse_idx_set(idxset)
            push!(idxvars, idxvar)
        end
    else
        loop = Expr(
            :for,
            esc(itrsets(ex.args[2:end])),
            rewrite_generator(ex.args[1], inner),
        )
        for idxset in ex.args[2:end]
            idxvar, s = _parse_idx_set(idxset)
            push!(idxvars, idxvar)
        end
    end
    return loop
end

# See `JuMP._is_sum`
_is_sum(s::Symbol) = (s == :sum) || (s == :∑) || (s == :Σ)

function _parse_generator(
    vectorized::Bool,
    minus::Bool,
    inner_factor::Expr,
    current_sum::Union{Nothing,Symbol},
    left_factors,
    right_factors,
    new_var = gensym(),
)
    @assert isexpr(inner_factor, :call)
    @assert length(inner_factor.args) > 1
    @assert isexpr(inner_factor.args[2], :generator) ||
            isexpr(inner_factor.args[2], :flatten)
    header = inner_factor.args[1]
    if !_is_sum(header)
        error("Expected `sum` outside generator expression; got `$header`.")
    end
    return _parse_generator_sum(
        vectorized,
        minus,
        inner_factor.args[2],
        current_sum,
        left_factors,
        right_factors,
        new_var,
    )
end

function _parse_generator_sum(
    vectorized::Bool,
    minus::Bool,
    inner_factor::Expr,
    current_sum::Union{Nothing,Symbol},
    left_factors,
    right_factors,
    new_var,
)
    # We used to preallocate the expression at the lowest level of the loop.
    # When rewriting this some benchmarks revealed that it actually doesn't
    # seem to help anymore, so might as well keep the code simple.
    return _start_summing(
        current_sum,
        current_sum -> begin
            code = rewrite_generator(
                inner_factor,
                t -> _rewrite(
                    vectorized,
                    minus,
                    t,
                    current_sum,
                    left_factors,
                    right_factors,
                    current_sum,
                )[2],
            )
            return Expr(:block, code, :($new_var = $current_sum))
        end,
    )
end

_is_complex_expr(ex) = isa(ex, Expr) && !isexpr(ex, :ref)

function _is_decomposable_with_factors(ex)
    # `.+` and `.-` do not support being decomposed if `left_factors` or
    # `right_factors` are not empty. Otherwise, for instance
    # `I * (x .+ 1)` would be rewritten into `(I * x) .+ (I * 1)` which is
    # incorrect.
    return _is_complex_expr(ex) &&
           (isempty(ex.args) || (ex.args[1] != :.+ && ex.args[1] != :.-))
end

"""
    rewrite(
        expr;
        move_factors_into_sums::Bool = true,
        return_is_mutable::Bool = false,
    ) -> Tuple{Symbol,Expr[,Bool]}

Rewrites the expression `expr` to use mutable arithmetics.

Returns `(variable, code)` comprised of a `gensym`'d variable equivalent to
`expr` and the code necessary to create the variable.

## `move_factors_into_sums`

If `move_factors_into_sums = true`, some terms are rewritten based on the
assumption that summations produce a linear function.

For example, if `move_factors_into_sums = true`, then
`y * sum(x[i] for i in 1:2)` is rewritten to:
```julia
variable = MA.Zero()
for i in 1:2
    variable = MA.operate!!(MA.add_mul, result, y, x[i])
end
```

If `move_factors_into_sums = false`, it is rewritten to:
```julia
term = MA.Zero()
for i in 1:2
    term = MA.operate!!(MA.add_mul, term, x[i])
end
variable = MA.operate!!(*, y, term)
```

The latter can produce an additional allocation if there is an efficient
fallback for `add_mul` and not for `*(y, term)`.

## `return_is_mutable`

If `return_is_mutable = true`, this function returns three arguments. The third
is a `Bool` indicating if the returned expression can be safely mutated without
changing the user's original expression.

`return_is_mutable` cannot be `true` if `move_factors_into_sums = true`.
"""
function rewrite(x; return_is_mutable::Bool = false, kwargs...)
    variable = gensym()
    if return_is_mutable
        code, is_mutable = rewrite_and_return(x; return_is_mutable, kwargs...)
        return variable, :($variable = $code), is_mutable
    end
    code = rewrite_and_return(x; kwargs...)
    return variable, :($variable = $code)
end

"""
    rewrite_and_return(
        expr;
        move_factors_into_sums::Bool = true,
        return_is_mutable::Bool = false,
    ) -> Expr

Rewrite the expression `expr` using mutable arithmetics and return an expression
in which the last statement is equivalent to `expr`.

See [`rewrite`](@ref) for an explanation of the keyword arguments.
"""
function rewrite_and_return(
    expr;
    move_factors_into_sums::Bool = true,
    return_is_mutable::Bool = false,
)
    if move_factors_into_sums
        @assert !return_is_mutable
        root, stack = _rewrite(false, false, expr, nothing, [], [])
        return quote
            let
                $stack
                $root
            end
        end
    end
    stack = quote end
    root, is_mutable = _rewrite_generic(stack, expr)
    code = quote
        let
            $stack
            $root
        end
    end
    if return_is_mutable
        return code, is_mutable
    end
    return code
end

function _is_comparison(ex::Expr)
    if isexpr(ex, :comparison)
        # Range comparison `_ <= _ <= _`.
        return true
    elseif isexpr(ex, :call)
        # Binary comparison `_ <= _`.
        if ex.args[1] in (:<=, :≤, :>=, :≥, :(==))
            return true
        else
            return false
        end
    end
    return false
end

function _rewrite_sum(
    vectorized::Bool,
    minus::Bool,
    terms,
    current_sum::Union{Nothing,Symbol},
    left_factors::Vector,
    right_factors::Vector,
    output::Symbol,
    block = Expr(:block),
)
    var = current_sum
    for term in terms[1:(end-1)]
        var, code =
            _rewrite(vectorized, minus, term, var, left_factors, right_factors)
        push!(block.args, code)
    end
    new_output, code = _rewrite(
        vectorized,
        minus,
        terms[end],
        var,
        left_factors,
        right_factors,
        output,
    )
    @assert new_output == output
    push!(block.args, code)
    return output, block
end

function _start_summing(::Nothing, first_term::Function)
    variable = gensym()
    return Expr(:block, Expr(:(=), variable, Zero()), first_term(variable))
end

function _start_summing(current_sum::Symbol, first_term::Function)
    return first_term(current_sum)
end

function _write_add_mul(
    vectorized,
    minus,
    current_sum,
    left_factors,
    inner_factors,
    right_factors,
    new_var::Symbol,
)
    return _start_summing(
        current_sum,
        current_sum -> begin
            call_expr = Expr(
                :call,
                vectorized ? broadcast!! : operate!!,
                minus ? sub_mul : add_mul,
                current_sum,
                left_factors...,
                inner_factors...,
                reverse(right_factors)...,
            )
            return :($new_var = $call_expr)
        end,
    )
end

"""
    _rewrite(
        vectorized::Bool,
        minus::Bool,
        inner_factor,
        current_sum::Union{Symbol, Nothing},
        left_factors::Vector,
        right_factors::Vector,
        new_var::Symbol = gensym(),
    )

Return `new_var, code` such that `code` is equivalent to
```julia
new_var = prod(left_factors) * inner_factor * prod(reverse(right_factors))
```

If `current_sum` is `nothing`, and is
```julia
new_var = current_sum op prod(left_factors) * inner_factor * prod(reverse(right_factors))
```
otherwise where `op` is `+` if `!vectorized & !minus`, `.+` if
`vectorized & !minus`, `-` if `!vectorized & minus` and `.-` if
`vectorized & minus`.
"""
function _rewrite(
    vectorized::Bool,
    minus::Bool,
    inner_factor,
    current_sum::Union{Symbol,Nothing},
    left_factors::Vector,
    right_factors::Vector,
    new_var::Symbol = gensym(),
)
    if isexpr(inner_factor, :call)
        if (
            inner_factor.args[1] == :+ ||
            inner_factor.args[1] == :- ||
            (
                current_sum === nothing &&
                isempty(left_factors) &&
                isempty(right_factors) &&
                (inner_factor.args[1] == :.+ || inner_factor.args[1] == :.-)
            )
        )
            # There are three cases here:
            #   1. scalar addition      : +(args...)
            #   2. scalar subtraction   : -(args...)
            #   3. broadcast addition or subtraction.
            # For case (3), we need to verify that current_sum, left_factors,
            # and right_factors are empty, otherwise we are unsure that the
            # elements in the containers have been copied, e.g., in
            # `I + (x .+ 1)`, the offdiagonal entries of `I + x` are the same as
            # `x` so we cannot do `broadcast!!(add_mul, I + x, 1)`.
            code = Expr(:block)
            if length(inner_factor.args) == 2
                # Unary addition or subtraction.
                next_sum = current_sum
                start = 2
            else
                next_sum, new_code = _rewrite(
                    vectorized,
                    minus,
                    inner_factor.args[2],
                    current_sum,
                    left_factors,
                    right_factors,
                )
                push!(code.args, new_code)
                start = 3
            end
            if inner_factor.args[1] == :- || inner_factor.args[1] == :.-
                minus = !minus
            end
            vectorized = (
                vectorized ||
                inner_factor.args[1] == :.+ ||
                inner_factor.args[1] == :.-
            )
            return _rewrite_sum(
                vectorized,
                minus,
                inner_factor.args[start:end],
                next_sum,
                left_factors,
                right_factors,
                new_var,
                code,
            )
        elseif inner_factor.args[1] == :* && !vectorized
            # A multiplication expression *(args...). We need `!vectorized`
            # otherwise `x .+ A * b` would be rewritten
            # `broadcast!!(add_mul, x, A, b)`.
            # We might need to recurse on multiple arguments, e.g., (x+y)*(x+y).
            # As a special case, only recurse on one argument and don't create
            # temporary objects
            if (
                isone(mapreduce(_is_complex_expr, +, inner_factor.args)) &&
                isone(
                    mapreduce(
                        _is_decomposable_with_factors,
                        +,
                        inner_factor.args,
                    ),
                )
            )
                # `findfirst` return the index in `2:...` so we need to add `1`.
                which_idx =
                    1 + findfirst(2:length(inner_factor.args)) do i
                        return _is_decomposable_with_factors(
                            inner_factor.args[i],
                        )
                    end
                return _rewrite(
                    vectorized,
                    minus,
                    inner_factor.args[which_idx],
                    current_sum,
                    vcat(
                        left_factors,
                        [esc(inner_factor.args[i]) for i in 2:(which_idx-1)],
                    ),
                    vcat(
                        right_factors,
                        [
                            esc(inner_factor.args[i]) for
                            i in length(inner_factor.args):-1:(which_idx+1)
                        ],
                    ),
                    new_var,
                )
            else
                code = Expr(:block)
                for i in 2:length(inner_factor.args)
                    arg = inner_factor.args[i]
                    if _is_complex_expr(arg)  # `arg` needs rewriting.
                        new_arg, new_arg_code = rewrite(arg)
                        push!(code.args, new_arg_code)
                        inner_factor.args[i] = new_arg
                    else
                        inner_factor.args[i] = esc(arg)
                    end
                end
                push!(
                    code.args,
                    _write_add_mul(
                        vectorized,
                        minus,
                        current_sum,
                        left_factors,
                        inner_factor.args[2:end],
                        right_factors,
                        new_var,
                    ),
                )
                return new_var, code
            end
        elseif (
            inner_factor.args[1] == :^ &&
            _is_complex_expr(inner_factor.args[2]) &&
            !vectorized
        )
            # An expression like `base ^ exponent`, where the `base` is a
            # non-trivial expression that also needs to be re-written. We need
            # `!vectorized` otherwise `A .+ (A + A)^2` would be rewritten as
            # `broadcast!!(add_mul, x, AA, AA)` where `AA` is `A + A`.
            MulType = :($promote_operation(
                *,
                typeof($(inner_factor.args[2])),
                typeof($(inner_factor.args[2])),
            ))
            if inner_factor.args[3] == 0
                # If the exponent is 0, rewrite
                #    new_var = base^0
                # as
                #    new_var = 1
                return _rewrite(
                    vectorized,
                    minus,
                    :(one($MulType)),
                    current_sum,
                    left_factors,
                    right_factors,
                    new_var,
                )
            elseif inner_factor.args[3] == 1
                # If the exponent is 1, rewrite
                #    new_var = base^1
                # as
                #    new_var = base
                return _rewrite(
                    vectorized,
                    minus,
                    :(convert($MulType, $(inner_factor.args[2]))),
                    current_sum,
                    left_factors,
                    right_factors,
                    new_var,
                )
            elseif inner_factor.args[3] == 2
                # If the exponent is 2, rewrite
                #    new_var = base^2
                # as
                #    new_base = base_rewrite
                #    new_var = base_rewrite * base_rewrite
                new_var_, parsed = rewrite(inner_factor.args[2])
                square_expr = _write_add_mul(
                    vectorized,
                    minus,
                    current_sum,
                    left_factors,
                    (new_var_, new_var_),
                    right_factors,
                    new_var,
                )
                return new_var, Expr(:block, parsed, square_expr)
            else
                # In the general case, rewrite
                #    new_var = base^exponent
                # as
                #    new_base = base_rewrite
                #    new_var = base_rewrite^(exponent)
                new_base, base_rewrite = rewrite(inner_factor.args[2])
                new_expr = _write_add_mul(
                    vectorized,
                    minus,
                    current_sum,
                    left_factors,
                    (Expr(:call, :^, new_base, esc(inner_factor.args[3])),),
                    right_factors,
                    new_var,
                )
                return new_var, Expr(:block, base_rewrite, new_expr)
            end
        elseif inner_factor.args[1] == :/ && !vectorized
            # Rewrite
            #   new_var = numerator / denominator
            # as
            #   new_var = numerator * (1 / denominator)
            @assert length(inner_factor.args) == 3
            return _rewrite(
                vectorized,
                minus,
                inner_factor.args[2],
                current_sum,
                left_factors,
                vcat(esc(:(1 / $(inner_factor.args[3]))), right_factors),
                new_var,
            )
        elseif (
            length(inner_factor.args) >= 2 &&
            (
                isexpr(inner_factor.args[2], :generator) ||
                isexpr(inner_factor.args[2], :flatten)
            ) &&
            _is_sum(inner_factor.args[1])
        )
            # A generator statement.
            code = _parse_generator(
                vectorized,
                minus,
                inner_factor,
                current_sum,
                left_factors,
                right_factors,
                new_var,
            )
            return new_var, code
        end
    end
    if isexpr(inner_factor, :curly)
        error(
            "The curly syntax (sum{},prod{},norm2{}) is no longer supported. " *
            "Expression: `$inner_factor`.",
        )
    elseif isa(inner_factor, Expr) && _is_comparison(inner_factor)
        error("Unexpected comparison in expression `$inner_factor`.")
    end
    # None of the special cases were hit! This probably means we are vectorized.
    code = _write_add_mul(
        vectorized,
        minus,
        current_sum,
        left_factors,
        (esc(inner_factor),),
        right_factors,
        new_var,
    )
    return new_var, code
end

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestEvalPoly

using Test

import MutableArithmetics as MA

function runtests()
    is_test(name::Symbol) = startswith("$name", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

_is_op_to(::Any) = false

_is_op_to(::Union{typeof(MA.operate_to!),typeof(MA.operate_to!!)}) = true

function _should_test(
    ::Union{typeof(MA.operate!),typeof(MA.operate_to!)},
    ::Type{F},
) where {F}
    return MA.mutability(F) == MA.IsMutable()
end

_should_test(op, ::Type{F}) where {F} = true

function test_evalpoly()
    for F in (BigFloat, Rational{Int}, Float64, Float32, Int)
        for op in (
            MA.operate,
            MA.operate!,
            MA.operate_to!,
            MA.operate!!,
            MA.operate_to!!,
        )
            if _should_test(op, F)
                _test_evalpoly(op, F, "vector")
                _test_evalpoly(op, F, "tuple")
            end
        end
    end
    return
end

function _test_evalpoly(op, ::Type{F}, collection_type) where {F}
    if MA.mutability(F) == MA.IsMutable()
        out = one(F)
        x = one(F)
        backup = MA.copy_if_mutable(x)
        coefs = collection_type == "tuple" ? () : F[]
        if _is_op_to(op)
            @test iszero(@inferred op(out, evalpoly, x, coefs))
        else
            @test iszero(@inferred op(evalpoly, x, coefs))
        end
        if op == MA.operate || _is_op_to(op)
            @test backup == x
        end
    end
    for degree in 0:4, x_int in -5:5
        coefs_int = rand(-6:6, degree + 1)
        coefs = map(F, coefs_int)
        x = F(x_int)
        backup = MA.copy_if_mutable(x)
        reference = evalpoly(x, coefs)
        @test reference == evalpoly(x_int, coefs_int)
        out = zero(F)
        coefs_arg = collection_type == "vector" ? coefs : (coefs...,)
        if _is_op_to(op)
            @test reference == @inferred op(out, evalpoly, x, coefs_arg)
        else
            @test reference == @inferred op(evalpoly, x, coefs_arg)
        end
        if op == MA.operate || _is_op_to(op)
            @test x == backup
        end
        @test coefs == map(F, coefs_int)
    end
    byte_cnt = _is_op_to(op) ? 0 : @allocated(zero(F))
    coefs = if collection_type == "vector"
        F[0, 1, 0, 1, 1]
    else
        F.((0, 1, 0, 1, 1))
    end
    let o = one(F), x = one(F), coefs = coefs
        if _is_op_to(op)
            @test @allocated(op(o, evalpoly, x, coefs)) <= byte_cnt
        else
            @test @allocated(op(evalpoly, x, coefs)) <= byte_cnt
        end
    end
    return
end

end  # TestEvalPoly

TestEvalPoly.runtests()

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function neg_abs_test(f::F, x::BigFloat) where {F<:Function}
    backup = MA.copy_if_mutable(x)
    output = MA.operate!(f, x)
    @test f(backup) == output == x
    return
end

@testset "$input" for input in map(
    BigFloat,
    (-1.3, -1.0, -0.7, -0.0, 0.0, 0.3, 1.0, 1.7),
)
    @testset "-" begin
        neg_abs_test(-, input)
    end

    @testset "Base.abs" begin
        neg_abs_test(Base.abs, input)
    end
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function _mat_mat_test(A, B)
    @test _matrix_equal(copy(transpose(A)) * B, A' * B)
    @test _matrix_equal(A * copy(transpose(B)), A * B')
    @test _matrix_equal(copy(transpose(B)) * A, B' * A)
    @test _matrix_equal(B * copy(transpose(A)), B * A')
end

function sparse_linear_test(X11, X23, Xd)
    X = sparse([1, 2], [1, 3], [X11, X23], 3, 3)

    #@test MA.isequal_canonical([X11 0. 0.; 0. 0. X23; 0. 0. 0.], @inferred MA._densify_with_jump_eltype(X))

    Y = sparse([1, 2], [1, 3], [2X11, 4X23], 3, 3)
    Yd = [
        2X11 0 0
        0 0 4X23
        0 0 0
    ]

    function _test_broadcast(A, B)
        @test_rewrite(A .+ B)
        @test_rewrite(B .+ A)
        @test_rewrite(A .- B)
        @test_rewrite(B .- A)
    end

    _test_broadcast(Xd, X)
    _test_broadcast(Xd, Y)
    _test_broadcast(Yd, X)
    _test_broadcast(Yd, Y)
    _test_broadcast(X, Y)

    add_test(Xd, Yd)
    add_test(Xd, Y)
    add_test(Xd, Xd)

    v = [4, 5, 6]
    @test MA.isequal_canonical(X * v, [4X11, 6X23, 0])
    @test MA.isequal_canonical((v' * X)', [4X11, 0, 5X23])
    @test MA.isequal_canonical(
        transpose(copy(transpose(v)) * X),
        [4X11, 0, 5X23],
    )
    @test MA.isequal_canonical(X' * v, [4X11, 0, 5X23])
    @test MA.isequal_canonical(copy(transpose(X)) * v, [4X11, 0, 5X23])

    A = [
        2 1 0
        1 2 1
        0 1 2
    ]

    add_test(X, A)
    _mat_mat_test(X, A)
    add_test(Y, A)
    _mat_mat_test(Y, A)

    @test _matrix_equal(
        X * A,
        [
            2X11 X11 0
            0 X23 2X23
            0 0 0
        ],
    )
    @test _matrix_equal(
        A * X,
        [
            2X11 0 X23
            X11 0 2X23
            0 0 X23
        ],
    )
    @test _matrix_equal(
        A * X',
        [
            2X11 0 0
            X11 X23 0
            0 2X23 0
        ],
    )
    @test _matrix_equal(
        X' * A,
        [
            2X11 X11 0
            0 0 0
            X23 2X23 X23
        ],
    )
    @test _matrix_equal(
        A' * X,
        [
            2X11 0 X23
            X11 0 2X23
            0 0 X23
        ],
    )

    B = sparse(A)
    @test _matrix_equal(X * A, X * B)
    @test _matrix_equal(A * X, B * X)
    @test _matrix_equal(A * X', B * X')
    @test _matrix_equal(A' * X, B' * X)
end

function sparse_quadratic_test(X11, X23, Xd)
    Y = sparse([1, 2], [1, 3], [2X11, 4X23], 3, 3) # for testing GenericAffExpr
    Yd = [
        2X11 0 0
        0 0 4X23
        0 0 0
    ]

    Z = sparse([1, 2], [1, 3], [X11^2, 2X23^2], 3, 3)
    Zd = [
        X11^2 0 0
        0 0 2X23^2
        0 0 0
    ]

    _mat_mat_test(Xd, Yd)
    _mat_mat_test(Xd, Y)
    _mat_mat_test(Xd, Xd)

    add_test(Yd, Zd)
    add_test(Zd, Xd)

    A = [
        2 1 0
        1 2 1
        0 1 2
    ]

    add_test(Z, A)
    return _mat_mat_test(Z, A)
end

const sparse_tests = Dict(
    "sparse_linear" => sparse_linear_test,
    "sparse_quadratic" => sparse_quadratic_test,
)

@test_suite sparse

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

_check_same_length(::Any) = nothing

function _check_same_length(a, b, c::Vararg{Any,N}) where {N}
    if length(a) != length(b)
        throw(
            DimensionMismatch(
                "one array has length $(length(a)) which does not match the " *
                "length of the next one, $(length(b)).",
            ),
        )
    end
    return _check_same_length(b, c...)
end

reduce_op(op::AddSubMul) = add_sub_op(op)

reduce_op(::typeof(add_dot)) = +

neutral_element(::typeof(+), ::Type{T}) where {T} = zero(T)
neutral_element(::typeof(+), ::Type{T}) where {T<:AbstractArray} = Zero()

map_op(::AddSubMul) = *

map_op(::typeof(add_dot)) = LinearAlgebra.dot

function promote_map_reduce(op::Function, args::Vararg{Any,N}) where {N}
    return promote_operation(
        op,
        promote_operation(map_op(op), args...),
        args...,
    )
end

_concrete_eltype(x) = isempty(x) ? eltype(x) : typeof(first(x))

function fused_map_reduce(op::F, args::Vararg{Any,N}) where {F<:Function,N}
    _check_same_length(args...)
    T = promote_map_reduce(op, _concrete_eltype.(args)...)
    accumulator = neutral_element(reduce_op(op), T)
    buffer = buffer_for(op, T, eltype.(args)...)
    for I in zip(eachindex.(args)...)
        accumulator =
            buffered_operate!!(buffer, op, accumulator, getindex.(args, I)...)
    end
    return accumulator
end

function operate(
    ::typeof(sum),
    a::AbstractArray;
    init = zero(promote_operation(+, eltype(a), eltype(a))),
)
    return mapreduce(identity, add!!, a; init)
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# We need these two methods because we're changing how * is re-written.
operate!(::typeof(*), x::AbstractArray{T}, y::T) where {T} = (x .*= y)
operate!(::typeof(*), x::AbstractArray, y) = (x .= operate(*, x, y))

"""
    _rewrite_generic(stack::Expr, expr::T)::Tuple{Any,Bool}

This method is the heart of the rewrite logic. It converts `expr` into a mutable
equivalent, places any intermediate calculations onto `stack`, and returns a
tuple containing the return value---which is either `expr` or a `gensym`ed
variable equivalent to `expr`---and a boolean flag that indicates whether the
return value can be mutated by future callers.
"""
function _rewrite_generic end

"""
    _rewrite_generic(::Expr, x)

A generic fallback. Given a type `x` we return it without mutation. In addition,
this type should not be mutated by future callers.
"""
_rewrite_generic(::Expr, x) = esc(x), false

"""
    _rewrite_generic(::Expr, x::Number)

If `x` is a `Number` at macro expansion time, it _must_ be a constant literal.
We return `x` without mutation, but we return `true` because other callers may
mutate the value without fear. Put aother way, they don't need to wrap the value
in `copy_if_mutable(x)` before using it as the first argument to `operate!!`.

This most commonly happens in situations like `x^2`.
"""
_rewrite_generic(::Expr, x::Number) = x, true

function _is_generic_generator_call(expr)
    if Meta.isexpr(expr, :call, 2)
        return _is_generator_or_flatten(expr.args[2])
    end
    return Meta.isexpr(expr, :call, 3) &&
           Meta.isexpr(expr.args[2], :parameters) &&
           _is_generator_or_flatten(expr.args[3])
end

function _is_generator_or_flatten(expr)
    return Meta.isexpr(expr, :generator) || Meta.isexpr(expr, :flatten)
end

function _is_kwarg(expr, kwarg::Symbol)
    return Meta.isexpr(expr, :kw) && expr.args[1] == kwarg
end

function _rewrite_elseif!(if_expr, expr::Any)
    if expr isa Expr && Meta.isexpr(expr, :elseif)
        new_ifelse_expr = Expr(:elseif, esc(expr.args[1]))
        push!(if_expr.args, new_ifelse_expr)
        @assert 2 <= length(expr.args) <= 3
        return mapreduce(&, 2:length(expr.args)) do i
            return _rewrite_elseif!(new_ifelse_expr, expr.args[i])
        end
    end
    stack = quote end
    root, is_mutable = _rewrite_generic(stack, expr)
    push!(stack.args, root)
    push!(if_expr.args, stack)
    return is_mutable
end

_rewrite_generic(stack::Expr, expr::LineNumberNode) = expr, false

"""
    _rewrite_generic(stack::Expr, expr::Expr)

This method is the heart of the rewrite logic. It converts `expr` into a mutable
equivalent.
"""
function _rewrite_generic(stack::Expr, expr::Expr)
    if Meta.isexpr(expr, :block)
        new_stack = quote end
        for arg in expr.args
            root, _ = _rewrite_generic(new_stack, arg)
            push!(new_stack.args, root)
        end
        root = gensym()
        push!(stack.args, :($root = $new_stack))
        return root, false
    elseif Meta.isexpr(expr, :if)
        # `if` blocks are special, because we can't lift the computation inside
        # them into the stack; the values might be defined only if the branch is
        # true.
        if_expr = Expr(:if, esc(expr.args[1]))
        @assert 2 <= length(expr.args) <= 3
        is_mutable = mapreduce(&, 2:length(expr.args)) do i
            return _rewrite_elseif!(if_expr, expr.args[i])
        end
        root = gensym()
        push!(stack.args, :($root = $if_expr))
        return root, is_mutable
    elseif !Meta.isexpr(expr, :call)
        # In situations like `x[i]`, we do not attempt to rewrite. Return `expr`
        # and don't let future callers mutate.
        return esc(expr), false
    elseif Meta.isexpr(expr, :call, 1)
        # A zero-argument function
        return esc(expr), false
    elseif Meta.isexpr(expr.args[2], :(...))
        # If the first argument is a splat.
        return esc(expr), false
    elseif _is_generic_generator_call(expr)
        if !(expr.args[1] in (:sum, :Σ, :∑))
            # We don't know what this is. Return the expression and don't let
            # future callers mutate.
            return esc(expr), false
        end
        # This is a generator expression like `sum(i for i in args)`. Generators
        # come in two forms: `sum(i for i=I, j=J)` or `sum(i for i=I for j=J)`.
        # The latter is a `:flatten` expression and needs additional handling,
        # but we delay this complexity for _rewrite_generic_generator.
        if Meta.isexpr(expr.args[2], :parameters)
            # The summation has keyword arguments. We can deal with `init`, but
            # not any of the others.
            p = expr.args[2]
            is_init = length(p.args) == 1 && _is_kwarg(p.args[1], :init)
            if is_init && _is_generator_or_flatten(expr.args[3])
                # sum(iter ; init) form!
                # We rewrite only if `iter` is an Expr; if it's just a Symbol,
                # we don't enter this branch.
                root = gensym()
                init, _ = _rewrite_generic(stack, p.args[1].args[2])
                push!(stack.args, :($root = $init))
                return _rewrite_generic_generator(stack, :+, expr.args[3], root)
            end
            # We don't know how to deal with this
            return esc(expr), false
        else
            # Summations use :+ as the reduction operator.
            init_expr = expr.args[2].args[end]
            if Meta.isexpr(init_expr, :(=)) && init_expr.args[1] == :init
                # sum(iter, init) form!
                root = gensym()
                init, _ = _rewrite_generic(stack, init_expr.args[2])
                push!(stack.args, :($root = $init))
                new_expr = copy(expr.args[2])
                pop!(new_expr.args)
                return _rewrite_generic_generator(stack, :+, new_expr, root)
            elseif Meta.isexpr(expr.args[2], :flatten)
                # sum(iter for iter, init) form!
                first_generator = expr.args[2].args[1].args[1]
                init_expr = first_generator.args[end]
                if Meta.isexpr(init_expr, :(=)) && init_expr.args[1] == :init
                    root = gensym()
                    init, _ = _rewrite_generic(stack, init_expr.args[2])
                    push!(stack.args, :($root = $init))
                    new_expr = copy(expr.args[2])
                    pop!(new_expr.args[1].args[1].args)
                    return _rewrite_generic_generator(stack, :+, new_expr, root)
                end
            end
            return _rewrite_generic_generator(stack, :+, expr.args[2])
        end
    end
    # At this point, we have an expression like `op(args...)`. We can either
    # choose to convert the operation to it's mutable equivalent, or return the
    # non-mutating operation.
    if expr.args[1] == :+
        # +(args...) => add_mul(add_mul(arg1, arg2), arg3)
        @assert length(expr.args) > 1
        if length(expr.args) == 2  # +(arg)
            return _rewrite_generic(stack, expr.args[2])
        elseif length(expr.args) == 3 && _is_call(expr.args[3], :*)
            # +(x, *(y...)) => add_mul(x, y...)
            x, is_mutable = _rewrite_generic(stack, expr.args[2])
            rhs = if is_mutable
                Expr(:call, operate!!, add_mul, x)
            else
                Expr(:call, operate, add_mul, x)
            end
            for i in 2:length(expr.args[3].args)
                yi, _ = _rewrite_generic(stack, expr.args[3].args[i])
                push!(rhs.args, yi)
            end
            root = gensym()
            push!(stack.args, :($root = $rhs))
            return root, true
        end
        return _rewrite_generic_to_nested_op(stack, expr, add_mul)
    elseif expr.args[1] == :-
        # -(args...) => sub_mul(sub_mul(arg1, arg2), arg3)
        @assert length(expr.args) > 1
        if length(expr.args) == 2  # -(arg)
            value, is_mutable = _rewrite_generic(stack, expr.args[2])
            root = gensym()
            rhs = if is_mutable
                Expr(:call, operate!!, *, value, -1)
            else
                Expr(:call, operate, *, -1, value)
            end
            push!(stack.args, :($root = $rhs))
            return root, true
        end
        return _rewrite_generic_to_nested_op(stack, expr, sub_mul)
    elseif expr.args[1] == :*
        # *(args...) => *(*(arg1, arg2), arg3)
        @assert length(expr.args) > 2
        arg1, is_mutable = _rewrite_generic(stack, expr.args[2])
        arg2, _ = _rewrite_generic(stack, expr.args[3])
        rhs = if is_mutable
            Expr(:call, operate!!, *, arg1, arg2)
        else
            Expr(:call, operate, *, arg1, arg2)
        end
        root = gensym()
        push!(stack.args, :($root = $rhs))
        for i in 4:length(expr.args)
            arg, _ = _rewrite_generic(stack, expr.args[i])
            # It is always safe to modify `root` here
            rhs = Expr(:call, operate!!, *, root, arg)
            root = gensym()
            push!(stack.args, :($root = $rhs))
        end
        return root, is_mutable
    elseif expr.args[1] == :.+
        # .+(args...) => add_mul.(add_mul.(arg1, arg2), arg3)
        @assert length(expr.args) > 1
        if length(expr.args) == 2  # +(arg)
            return _rewrite_generic(stack, expr.args[2])
        end
        return _rewrite_generic_to_nested_op(
            stack,
            expr,
            add_mul;
            broadcast = true,
        )
    elseif expr.args[1] == :.-
        # .-(args...) => sub_mul.(sub_mul.(arg1, arg2), arg3)
        @assert length(expr.args) > 1
        if length(expr.args) == 2  # .-(arg)
            return _rewrite_generic(stack, Expr(:call, :.*, -1, expr.args[2]))
        end
        return _rewrite_generic_to_nested_op(
            stack,
            expr,
            sub_mul;
            broadcast = true,
        )
    else
        # Use the non-mutating call.
        result = Expr(:call, esc(expr.args[1]))
        for i in 2:length(expr.args)
            arg, _ = _rewrite_generic(stack, expr.args[i])
            push!(result.args, arg)
        end
        root = gensym()
        push!(stack.args, Expr(:(=), root, result))
        # This value isn't safe to mutate, because it might be a reference to
        # another object.
        return root, false
    end
end

function _rewrite_generic_to_nested_op(stack, expr, op; broadcast::Bool = false)
    root, is_mutable = _rewrite_generic(stack, expr.args[2])
    if !is_mutable
        # The first argument isn't mutable, so we need to make a copy.
        arg = Expr(:call, copy_if_mutable, root)
        root = gensym()
        push!(stack.args, Expr(:(=), root, arg))
    end
    for i in 3:length(expr.args)
        arg, _ = _rewrite_generic(stack, expr.args[i])
        rhs = if broadcast
            Expr(:call, broadcast!!, op, root, arg)
        else
            Expr(:call, operate!!, op, root, arg)
        end
        root = gensym()
        push!(stack.args, Expr(:(=), root, rhs))
    end
    return root, true
end

_is_call(expr, op) = Meta.isexpr(expr, :call) && expr.args[1] == op
_is_call(expr, op, n) = Meta.isexpr(expr, :call, 1 + n) && expr.args[1] == op

"""
    _rewrite_generic_generator(stack::Expr, op::Symbol, expr::Expr)

Special handling for generator expressions.

`op` is `:+` and `expr` is a `:generator` or `:flatten` expression.
"""
function _rewrite_generic_generator(
    stack::Expr,
    op::Symbol,
    expr::Expr,
    root = nothing,
)
    @assert op == :+
    is_flatten = Meta.isexpr(expr, :flatten)
    if is_flatten
        expr = expr.args[1]
    end
    # The value we're going to mutate. Start it off at `Zero`.
    if root === nothing
        root = gensym()
        push!(stack.args, Expr(:(=), root, Zero()))
    end
    # We need a new stack to go inside our for-loops since we want to
    # recursively rewrite the inner part as well.
    new_stack = quote end
    if _is_call(expr.args[1], op)
        # Optimization time! Instead of operate!!(op, root, op(args...)),
        # rewrite as operate!!(op, root, arg) for arg in args
        for arg in expr.args[1].args[2:end]
            value, _ = _rewrite_generic(new_stack, arg)
            rhs = Expr(:call, operate!!, add_mul, root, value)
            push!(new_stack.args, :($root = $rhs))
        end
    elseif op == :+ && _is_call(expr.args[1], :*)
        # Optimization time! Instead of operate!!(+, root, *(args...)), rewrite
        # this as operate!!(add_mul, root, args...)
        rhs = Expr(:call, operate!!, add_mul, root)
        for arg in expr.args[1].args[2:end]
            value, _ = _rewrite_generic(new_stack, arg)
            push!(rhs.args, value)
        end
        push!(new_stack.args, :($root = $rhs))
    elseif op == :+ && _is_call(expr.args[1], :-, 1)
        # Optimization time! Instead of operate!!(+, root, -(arg)), rewrite this
        # as operate!!(sub_mul, root, arg)
        value, _ = _rewrite_generic(new_stack, expr.args[1].args[2])
        rhs = Expr(:call, operate!!, sub_mul, root, value)
        push!(new_stack.args, :($root = $rhs))
    elseif is_flatten
        # The first argument is itself a generator
        _rewrite_generic_generator(new_stack, op, expr.args[1], root)
    else
        # expr.args[1] is the inner part of the loop. Rewrite it. We don't care
        # if it is mutable because we need a new value every iteration.
        inner, _ = _rewrite_generic(new_stack, expr.args[1])
        # Now build up the summation or product part of the inner loop. It's
        # always safe to mutate because we're going to start with `root=Zero()`.
        rhs = Expr(:call, operate!!, add_mul, root, inner)
        push!(new_stack.args, :($root = $rhs))
    end
    # This is a little complicated: walk back out of the generator statements
    # wrapping each level in a for loop and the over-writing the `new_stack`
    # variable.
    #
    # !!! warning
    #     The Julia syntax sum(i for i in 1:2, j in 1:i) is incorrect, but we
    #     handle it anyway! Because the user will write dependencies from left
    #     to right, we need to wrap from right to left.
    for i in length(expr.args):-1:2
        new_stack = _iterable_condition(new_stack, expr.args[i])
    end
    # Finally, push our new_stack onto the old `stack`...
    push!(stack.args, new_stack)
    # and return the `root`. We can mutate this in future because it started off
    # as `Zero`.
    return root, true
end

function _iterable_condition(new_stack, expr)
    if !Meta.isexpr(expr, :filter)
        return Expr(:for, esc(expr), new_stack)
    end
    body = quote
        if $(esc(expr.args[1]))
            $new_stack
        end
    end
    # A filter might be over multiple index sets
    for i in length(expr.args):-1:2
        body = Expr(:for, esc(expr.args[i]), body)
    end
    return body
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# This file contains methods to implement the MutableArithmetics API for
# Base.BigFloat.

mutability(::Type{BigFloat}) = IsMutable()

# These methods are copied from `deepcopy_internal` in `base/mpfr.jl`. We don't
# use `mutable_copy(x) = deepcopy(x)` because this creates an empty `IdDict()`
# which costs some extra allocations. We don't need the IdDict case because we
# never call `mutable_copy` recursively.
@static if VERSION >= v"1.12.0-DEV.1343"
    mutable_copy(x::BigFloat) = Base.MPFR._BigFloat(copy(getfield(x, :d)))
else
    function mutable_copy(x::BigFloat)
        d = x._d
        GC.@preserve d begin
            d′ = unsafe_string(pointer(d), sizeof(d))
            return Base.MPFR._BigFloat(x.prec, x.sign, x.exp, d′)
        end
    end
end

const _MPFRRoundingMode = Base.MPFR.MPFRRoundingMode

# copy

promote_operation(::typeof(copy), ::Type{BigFloat}) = BigFloat

function operate_to!(out::BigFloat, ::typeof(copy), in::BigFloat)
    ccall(
        (:mpfr_set, :libmpfr),
        Int32,
        (Ref{BigFloat}, Ref{BigFloat}, _MPFRRoundingMode),
        out,
        in,
        Base.MPFR.ROUNDING_MODE[],
    )
    return out
end

operate!(::typeof(copy), x::BigFloat) = x

# zero

promote_operation(::typeof(zero), ::Type{BigFloat}) = BigFloat

function _set_si!(x::BigFloat, value)
    ccall(
        (:mpfr_set_si, :libmpfr),
        Int32,
        (Ref{BigFloat}, Clong, _MPFRRoundingMode),
        x,
        value,
        Base.MPFR.ROUNDING_MODE[],
    )
    return x
end
operate!(::typeof(zero), x::BigFloat) = _set_si!(x, 0)

# one

promote_operation(::typeof(one), ::Type{BigFloat}) = BigFloat

operate!(::typeof(one), x::BigFloat) = _set_si!(x, 1)

# +

function promote_operation(::typeof(+), ::Type{BigFloat}, ::Type{BigFloat})
    return BigFloat
end

function operate_to!(output::BigFloat, ::typeof(+), a::BigFloat, b::BigFloat)
    ccall(
        (:mpfr_add, :libmpfr),
        Int32,
        (Ref{BigFloat}, Ref{BigFloat}, Ref{BigFloat}, _MPFRRoundingMode),
        output,
        a,
        b,
        Base.MPFR.ROUNDING_MODE[],
    )
    return output
end

operate_to!(out::BigFloat, ::typeof(+), a::BigFloat) = operate_to!(out, copy, a)

operate!(::typeof(+), a::BigFloat) = a

# -

promote_operation(::typeof(-), ::Vararg{Type{BigFloat},N}) where {N} = BigFloat

function operate_to!(output::BigFloat, ::typeof(-), a::BigFloat, b::BigFloat)
    ccall(
        (:mpfr_sub, :libmpfr),
        Int32,
        (Ref{BigFloat}, Ref{BigFloat}, Ref{BigFloat}, _MPFRRoundingMode),
        output,
        a,
        b,
        Base.MPFR.ROUNDING_MODE[],
    )
    return output
end

function operate!(::typeof(-), x::BigFloat)
    x.sign = -x.sign
    return x
end

function operate_to!(o::BigFloat, ::typeof(-), x::BigFloat)
    operate_to!(o, copy, x)
    return operate!(-, o)
end

# Base.abs

function operate!(::typeof(Base.abs), x::BigFloat)
    x.sign = abs(x.sign)
    return x
end

function operate_to!(o::BigFloat, ::typeof(abs), x::BigFloat)
    operate_to!(o, copy, x)
    return operate!(abs, o)
end

# *

promote_operation(::typeof(*), ::Type{BigFloat}, ::Type{BigFloat}) = BigFloat

function operate_to!(output::BigFloat, ::typeof(*), a::BigFloat, b::BigFloat)
    ccall(
        (:mpfr_mul, :libmpfr),
        Int32,
        (Ref{BigFloat}, Ref{BigFloat}, Ref{BigFloat}, _MPFRRoundingMode),
        output,
        a,
        b,
        Base.MPFR.ROUNDING_MODE[],
    )
    return output
end

operate_to!(out::BigFloat, ::typeof(*), a::BigFloat) = operate_to!(out, copy, a)

operate!(::typeof(*), a::BigFloat) = a

# Base.fma

function promote_operation(
    ::typeof(Base.fma),
    ::Type{F},
    ::Type{F},
    ::Type{F},
) where {F<:BigFloat}
    return F
end

function operate_to!(
    output::F,
    ::typeof(Base.fma),
    x::F,
    y::F,
    z::F,
) where {F<:BigFloat}
    ccall(
        (:mpfr_fma, :libmpfr),
        Int32,
        (Ref{F}, Ref{F}, Ref{F}, Ref{F}, _MPFRRoundingMode),
        output,
        x,
        y,
        z,
        Base.MPFR.ROUNDING_MODE[],
    )
    return output
end

function operate!(::typeof(Base.fma), x::F, y::F, z::F) where {F<:BigFloat}
    return operate_to!(x, Base.fma, x, y, z)
end

# Base.muladd

function promote_operation(
    ::typeof(Base.muladd),
    ::Type{F},
    ::Type{F},
    ::Type{F},
) where {F<:BigFloat}
    return F
end

function operate_to!(
    output::F,
    ::typeof(Base.muladd),
    x::F,
    y::F,
    z::F,
) where {F<:BigFloat}
    return operate_to!(output, Base.fma, x, y, z)
end

function operate!(::typeof(Base.muladd), x::F, y::F, z::F) where {F<:BigFloat}
    return operate!(Base.fma, x, y, z)
end

function operate_to!(
    output::BigFloat,
    op::Union{typeof(+),typeof(-),typeof(*)},
    a::BigFloat,
    b::BigFloat,
    c::Vararg{BigFloat,N},
) where {N}
    operate_to!(output, op, a, b)
    return operate!(op, output, c...)
end

function operate!(op::Function, x::BigFloat, args::Vararg{Any,N}) where {N}
    return operate_to!(x, op, x, args...)
end

# add_mul and sub_mul

# Buffer to hold the product
buffer_for(::AddSubMul, args::Vararg{Type{BigFloat},N}) where {N} = BigFloat()

function operate_to!(
    output::BigFloat,
    op::AddSubMul,
    x::BigFloat,
    y::BigFloat,
    z::BigFloat,
    args::Vararg{BigFloat,N},
) where {N}
    return buffered_operate_to!(BigFloat(), output, op, x, y, z, args...)
end

function buffered_operate_to!(
    buffer::BigFloat,
    output::BigFloat,
    op::AddSubMul,
    a::BigFloat,
    x::BigFloat,
    y::BigFloat,
    args::Vararg{BigFloat,N},
) where {N}
    operate_to!(buffer, *, x, y, args...)
    return operate_to!(output, add_sub_op(op), a, buffer)
end

function buffered_operate!(
    buffer::BigFloat,
    op::AddSubMul,
    x::BigFloat,
    args::Vararg{Any,N},
) where {N}
    return buffered_operate_to!(buffer, x, op, x, args...)
end

_scaling_to_bigfloat(x) = _scaling_to(BigFloat, x)

function operate_to!(
    output::BigFloat,
    op::Union{typeof(+),typeof(-),typeof(*)},
    args::Vararg{Scaling,N},
) where {N}
    return operate_to!(output, op, _scaling_to_bigfloat.(args)...)
end

function operate_to!(
    output::BigFloat,
    op::AddSubMul,
    x::Scaling,
    y::Scaling,
    z::Scaling,
    args::Vararg{Scaling,N},
) where {N}
    return operate_to!(
        output,
        op,
        _scaling_to_bigfloat(x),
        _scaling_to_bigfloat(y),
        _scaling_to_bigfloat(z),
        _scaling_to_bigfloat.(args)...,
    )
end

# Called for instance if `args` is `(v', v)` for a vector `v`.
function operate_to!(
    output::BigFloat,
    op::AddSubMul,
    x,
    y,
    z,
    args::Vararg{Any,N},
) where {N}
    return operate_to!(output, add_sub_op(op), x, *(y, z, args...))
end

struct DotBuffer{F<:Real}
    c::F
    t::F
    input::F
    tmp::F

    DotBuffer{F}() where {F<:Real} = new{F}(zero(F), zero(F), zero(F), zero(F))
end

function buffer_for(
    ::typeof(LinearAlgebra.dot),
    ::Type{V},
    ::Type{V},
) where {V<:AbstractVector{BigFloat}}
    return DotBuffer{BigFloat}()
end

# Dot product using Kahan-Babuška-Neumaier compensated summation.
#
# Currently restricted to BigFloat, but easily extendable to other
# similar types, if any such types appear in the ecosystem.
#
# Neumaier's 1974 paper is in German and not currently available from
# Google Scholar, but a scanned version is here:
# https://www.mat.univie.ac.at/~neum/scan/01.pdf
#
# Neumaier 1974:
#   * Rundungsfehleranalyse einiger Verfahren zur Summation endlicher
#     Summen
#   * English name: Rounding Error Analysis of Some Methods for Summing
#     Finite Sums
#   * DOI: https://doi.org/10.1002%2Fzamm.19740540106
#
# The paper has the pseudocode on page two of the PDF, in section 2,
# subsection "IV. Verbessertes Kahan-Babuška-Verfahren".
#
# Wikipedia page and section:
# https://en.wikipedia.org/w/index.php?title=Kahan_summation_algorithm&oldid=1114844162#Further_enhancements
#
# TODO: further improvement: Ogita, Rump and Oishi have a compensated
#       algorithm specifically tailored for dot product, so it would
#       be better to use that (I found out only after writing the code
#       here)
#
# Pseudocode as in Neumaier's 1974 paper:
#
#   s_0 := 0
#
#   # A running compensation for lost low-order bits.
#   w_0 := 0
#
#   for m ∈ 1:n
#     s_m := a_m + s_(m-1)
#
#     if abs(a_m) ≤ abs(s_(m-1))
#       w_m := w_(m-1) + (a_m + (s_(m-1) - s_m))
#     else
#       w_m := w_(m-1) + (s_(m-1) + (a_m - s_m))
#     end
#   end
#
#   # The result, with the correction only applied once in the very
#   # end.
#   s := s_n + w_n
#
# Pseudocode as in the Wikipedia page on Kahan summation (equivalent to
# Neumaier, but closer to the implementation):
#
#   function KahanBabushkaNeumaierSum(input)
#       sum = 0.0
#       # A running compensation for lost low-order bits.
#       c = 0.0
#       for i ∈ eachindex(input)
#           t = sum + input[i]
#           if abs(input[i]) ≤ abs(sum)
#               tmp = (sum - t) + input[i]
#           else
#               tmp = (input[i] - t) + sum
#           end
#           c += tmp
#           sum = t
#       end
#       # The result, with the correction only applied once in the very end.
#       sum + c
#   end

# Returns abs(x) <= abs(y) without allocating.
function _abs_lte_abs(x::BigFloat, y::BigFloat)
    x_is_neg, y_is_neg = signbit(x), signbit(y)
    if x_is_neg != y_is_neg
        operate!(-, x)
    end
    ret = y_is_neg ? y <= x : x <= y
    if x_is_neg != y_is_neg
        operate!(-, x)
    end
    return ret
end

function buffered_operate_to!(
    buf::DotBuffer{BigFloat},
    sum::BigFloat,
    ::typeof(LinearAlgebra.dot),
    x::AbstractVector{BigFloat},
    y::AbstractVector{BigFloat},
)                                                   # See pseudocode description
    operate!(zero, sum)                             # sum = 0
    operate!(zero, buf.c)                           # c = 0
    for (xi, yi) in zip(x, y)                       # for i in eachindex(input)
        operate_to!(buf.input, copy, xi)            # input = x[i]
        operate!(*, buf.input, yi)                  # input = x[i] * y[i]
        operate_to!(buf.t, +, sum, buf.input)       # t = sum + input
        if _abs_lte_abs(buf.input, sum)             # if |input| < |sum|
            operate_to!(buf.tmp, copy, sum)         # tmp = sum
            operate!(-, buf.tmp, buf.t)             # tmp = sum - t
            operate!(+, buf.tmp, buf.input)         # tmp = (sum - t) + input
        else
            operate_to!(buf.tmp, copy, buf.input)   # tmp = input
            operate!(-, buf.tmp, buf.t)             # tmp = input - t
            operate!(+, buf.tmp, sum)               # tmp = (input - t) + sum
        end
        operate!(+, buf.c, buf.tmp)                 # c += tmp
        operate_to!(sum, copy, buf.t)               # sum = t
    end
    operate!(+, sum, buf.c)                         # sum += c
    return sum
end

# Base.evalpoly

function operate!(
    op::typeof(Base.evalpoly),
    out::F,
    coefs::Union{Tuple,AbstractVector},
) where {F<:BigFloat}
    return operate_to!(out, op, mutable_copy(out), coefs)
end

function operate(
    op::typeof(Base.evalpoly),
    x::F,
    coefs::Union{Tuple,AbstractVector},
) where {F<:BigFloat}
    return operate_to!(zero(x), op, x, coefs)
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

# TODO: this file contains a large number of method specializations to intercept
# "externally owned" method calls by dispatching on type parameters (rather than
# outermost wrapper type). This is generally bad practice, but refactoring this
# code to use a different mechanism would be a lot of work. In the future, this
# interception code would be more easily/robustly replaced by using a tool like
# https://github.com/jrevels/Cassette.jl.

abstract type AbstractMutable end

# Zero arithmetic methods for AbstractMutable types.
# The main Zero arithmetic is defined in rewrite.jl with Number/AbstractArray;
# these methods extend it to AbstractMutable.
Base.:*(z::Zero, ::AbstractMutable) = z
Base.:*(::AbstractMutable, z::Zero) = z
Base.:+(::Zero, x::AbstractMutable) = copy_if_mutable(x)
Base.:+(x::AbstractMutable, ::Zero) = copy_if_mutable(x)
Base.:-(::Zero, x::AbstractMutable) = operate(-, x)
Base.:-(x::AbstractMutable, ::Zero) = copy_if_mutable(x)

function Base.:/(z::Zero, x::AbstractMutable)
    if iszero(x)
        throw(DivideError())
    end
    return z
end

function Base.sum(
    a::AbstractArray{T};
    dims = :,
    init = zero(promote_operation(+, T, T)),
) where {T<:AbstractMutable}
    if dims !== Colon()
        # We cannot use `mapreduce` with `add!!` instead of `Base.add_mul` like
        # `operate(sum, ...)` because the same instance given at `init` is used
        # at several places.
        return mapreduce(identity, Base.add_sum, a; dims, init)
    end
    return operate(sum, a; init)
end

# When doing `x'y` where the elements of `x` and/or `y` are arrays, redirecting
# to `dot(x, y)` is not equivalent to `x'y` as it will call dot recursively on
# the elements of `x` and `y`. See
# https://github.com/JuliaLang/julia/issues/35174
# For this reason, a `_dot_nonrecursive` function was added that does not
# recursively call `dot`:
# https://github.com/JuliaLang/julia/commit/eae3216416453b53631afa6c803591cf2c5ae5b3
#
# However, it does not exploit mutability and returns
# `zero(eltype(lhs)) * zero(eltype(rhs))` in case the arrays are empty which
# creates type instability for some types for which this type is not invariant
# under addition.

# TODO: LinearAlgebra should have a documented function so that we don't have to
# overload an internal function
function LinearAlgebra._dot_nonrecursive(
    lhs::AbstractArray{<:AbstractMutable},
    rhs::AbstractArray,
)
    return fused_map_reduce(add_mul, lhs, rhs)
end
function LinearAlgebra._dot_nonrecursive(
    lhs::AbstractArray,
    rhs::AbstractArray{<:AbstractMutable},
)
    return fused_map_reduce(add_mul, lhs, rhs)
end
function LinearAlgebra._dot_nonrecursive(
    lhs::AbstractArray{<:AbstractMutable},
    rhs::AbstractArray{<:AbstractMutable},
)
    return fused_map_reduce(add_mul, lhs, rhs)
end

for A in (LinearAlgebra.Symmetric, LinearAlgebra.Hermitian, AbstractArray)
    B = A{<:AbstractMutable}
    @eval begin
        LinearAlgebra.dot(x::$A, y::$B) = operate(LinearAlgebra.dot, x, y)
        LinearAlgebra.dot(x::$B, y::$A) = operate(LinearAlgebra.dot, x, y)
        LinearAlgebra.dot(x::$B, y::$B) = operate(LinearAlgebra.dot, x, y)
    end
end

# Special-case because the the base version wants to do
# fill!(::Array{AbstractVariableRef}, zero(GenericAffExpr{Float64,eltype(x)}))
_one_indexed(A) = all(x -> isa(x, Base.OneTo), axes(A))

function LinearAlgebra.diagm_container(
    size,
    kv::Pair{<:Integer,<:AbstractVector{<:AbstractMutable}}...,
)
    T = promote_type(map(x -> promote_type(eltype(x.second)), kv)...)
    U = promote_type(T, promote_operation(zero, T))
    return zeros(U, LinearAlgebra.diagm_size(size, kv...)...)
end

function LinearAlgebra.diagm(x::AbstractVector{<:AbstractMutable})
    # `LinearAlgebra.diagm` doesn't work for non-one-indexed arrays in general.
    @assert _one_indexed(x)
    ZeroType = promote_operation(zero, eltype(x))
    return LinearAlgebra.diagm(0 => copyto!(similar(x, ZeroType), x))
end

################################################################################
# Interception of Base's matrix/vector arithmetic machinery
#
# Redirect calls with `eltype(ret) <: AbstractMutable` to `_mul!` to replace it
# with an implementation more efficient than `generic_matmatmul!` and
# `generic_matvecmul!` since it takes into account the mutability of the
# arithmetic. We need `args...` because SparseArrays` also gives `α` and `β`
# arguments.

function _mul!(output, A, B, α, β)
    # See SparseArrays/src/linalg.jl
    if !isone(β)
        if iszero(β)
            operate!(zero, output)
        else
            rmul!(output, scaling(β))
        end
    end
    return operate!(add_mul, output, A, B, scaling(α))
end

function _mul!(output, A, B, α)
    operate!(zero, output)
    return operate!(add_mul, output, A, B, scaling(α))
end

# LinearAlgebra uses `Base.promote_op(LinearAlgebra.matprod, ...)` to try to
# infere the return type. If the operation is not supported, it returns
# `Union{}`.
function _mul!(output::AbstractArray{Union{}}, A, B)
    # Normally, if the product is not supported, this should redirect to
    # `MA.promote_operation(*, ...)` which redirects to
    # `zero(...) * zero(...)` which should throw an appropriate error.
    # For example, in JuMP, it would say that you cannot multiply quadratic
    # expressions with an affine expression for instance.
    ProdType = promote_array_mul(typeof(A), typeof(B))
    # If we arrived here, it means that we have found a type for `output`, even
    # if LinearAlgebra couldn't. This is most probably a but so let's provide
    # extensive information to help debugging.
    return error(
        "Cannot multiply a `$(typeof(A))` with a `$(typeof(B))` because the " *
        "sum of the product of a `$(eltype(A))` and a `$(eltype(B))` could " *
        "not be inferred so a `$(typeof(output))` allocated to store the " *
        "output of the multiplication instead of a `$ProdType`.",
    )
end

_mul!(output, A, B) = operate_to!(output, *, A, B)

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::AbstractVecOrMat,
    B::AbstractVecOrMat,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractVector{<:AbstractMutable},
    A::AbstractVecOrMat,
    B::AbstractVector,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractVector{<:AbstractMutable},
    A::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    B::AbstractVector,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractVector{<:AbstractMutable},
    A::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    B::AbstractVector,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractVector{<:AbstractMutable},
    A::LinearAlgebra.AbstractTriangular,
    B::AbstractVector,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    B::AbstractMatrix,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    B::AbstractMatrix,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.AbstractTriangular,
    B::AbstractMatrix,
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::AbstractMatrix,
    B::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::AbstractMatrix,
    B::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    B::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    B::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
)
    return _mul!(ret, A, B)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::AbstractVecOrMat,
    B::AbstractVecOrMat,
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractVector{<:AbstractMutable},
    A::AbstractVecOrMat,
    B::AbstractVector,
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractVector{<:AbstractMutable},
    A::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    B::AbstractVector,
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractVector{<:AbstractMutable},
    A::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    B::AbstractVector,
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    B::AbstractMatrix,
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    B::AbstractMatrix,
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::AbstractMatrix,
    B::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::AbstractMatrix,
    B::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    B::LinearAlgebra.Adjoint{<:Any,<:AbstractVecOrMat},
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

function LinearAlgebra.mul!(
    ret::AbstractMatrix{<:AbstractMutable},
    A::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    B::LinearAlgebra.Transpose{<:Any,<:AbstractVecOrMat},
    α::Number,
    β::Number,
)
    return _mul!(ret, A, B, α, β)
end

# SparseArrays promotes the element types of `A` and `B` to the same type which,
# always produce quadratic expressions for JuMP even if only one of them was
# affine and the other one constant. Moreover, it does not always go through
# `LinearAlgebra.mul!` which prevents us from using mutability of the
# arithmetic. For this reason we intercept the calls and redirect them to `mul`.

const _LinearAlgebraWrappers = (
    LinearAlgebra.Adjoint,
    LinearAlgebra.Transpose,
    # TODO(odow): we could expand these overloads to other LinearAlgebra types.
    # LinearAlgebra.Symmetric,
    # LinearAlgebra.Hermitian,
    # LinearAlgebra.Diagonal,
    # LinearAlgebra.LowerTriangular,
    # LinearAlgebra.UpperTriangular,
    # LinearAlgebra.UnitLowerTriangular,
    # LinearAlgebra.UnitUpperTriangular,
)

const _MatrixLike = vcat(
    Any[T -> LA{<:T,<:_SparseMat} for LA in _LinearAlgebraWrappers],
    Any[T->_SparseMat{<:T}, T->StridedMatrix{<:T}],
)

for f_A in _MatrixLike, f_B in vcat(_MatrixLike, T -> StridedVector{<:T})
    A, mut_A = f_A(Any), f_A(AbstractMutable)
    B, mut_B = f_B(Any), f_B(AbstractMutable)
    if A <: StridedMatrix && B <: StridedMatrix
        continue
    end
    @eval begin
        Base.:*(a::$(mut_A), b::$(B)) = mul(a, b)
        Base.:*(a::$(A), b::$(mut_B)) = mul(a, b)
        Base.:*(a::$(mut_A), b::$(mut_B)) = mul(a, b)
    end
end

_mat_mat_scalar(A, B, γ) = operate!!(*, operate(*, A, B), γ)

function LinearAlgebra.mat_mat_scalar(
    A::LinearAlgebra.StridedMaybeAdjOrTransMat{<:AbstractMutable},
    B::LinearAlgebra.StridedMaybeAdjOrTransMat,
    γ,
)
    return _mat_mat_scalar(A, B, γ)
end

function LinearAlgebra.mat_mat_scalar(
    A::LinearAlgebra.StridedMaybeAdjOrTransMat,
    B::LinearAlgebra.StridedMaybeAdjOrTransMat{<:AbstractMutable},
    γ,
)
    return _mat_mat_scalar(A, B, γ)
end

function LinearAlgebra.mat_mat_scalar(
    A::LinearAlgebra.StridedMaybeAdjOrTransMat{<:AbstractMutable},
    B::LinearAlgebra.StridedMaybeAdjOrTransMat{<:AbstractMutable},
    γ,
)
    return _mat_mat_scalar(A, B, γ)
end

# Base doesn't define efficient fallbacks for sparse array arithmetic involving
# non-`<:Number` scalar elements, so we define some of these for
# `<:AbstractMutable` scalar elements here.

for (S, T) in [
    (LinearAlgebra.UniformScaling, AbstractMutable),
    (Number, AbstractMutable),
    (AbstractMutable, Any),
]
    @eval begin
        function Base.:*(A::$S, B::_SparseMat{<:$T})
            return _SparseMat(
                B.m,
                B.n,
                copy(B.colptr),
                copy(SparseArrays.rowvals(B)),
                A .* SparseArrays.nonzeros(B),
            )
        end
        function Base.:*(B::_SparseMat{<:$T}, A::$S)
            return _SparseMat(
                B.m,
                B.n,
                copy(B.colptr),
                copy(SparseArrays.rowvals(B)),
                SparseArrays.nonzeros(B) .* A,
            )
        end
    end
end

function Base.:/(
    A::_SparseMat{<:AbstractMutable},
    B::LinearAlgebra.UniformScaling,
)
    return _SparseMat(
        A.m,
        A.n,
        copy(A.colptr),
        copy(SparseArrays.rowvals(A)),
        SparseArrays.nonzeros(A) ./ B,
    )
end

function Base.:/(A::_SparseMat{<:AbstractMutable}, B::Number)
    return _SparseMat(
        A.m,
        A.n,
        copy(A.colptr),
        copy(SparseArrays.rowvals(A)),
        SparseArrays.nonzeros(A) ./ B,
    )
end

# Base assumes that the element type is unaffected by `-`
function Base.:-(A::_SparseMat{<:AbstractMutable})
    return _SparseMat(
        A.m,
        A.n,
        copy(A.colptr),
        copy(SparseArrays.rowvals(A)),
        -SparseArrays.nonzeros(A),
    )
end

# Matrix(::SparseMatrixCSC) assumes that `zero` does not affect the element
# type of `S`.
function Base.Matrix(S::_SparseMat{T}) where {T<:AbstractMutable}
    U = promote_operation(+, promote_operation(zero, T), T)
    A = Matrix{U}(undef, size(S)...)
    operate!(zero, A)
    return operate!(+, A, S)
end

# +(::SparseMatrixCSC) is not defined for generic types in Base.
Base.:+(A::AbstractArray{<:AbstractMutable}) = A

# `Base.*(::AbstractArray, α)` is only defined if `α isa Number`
# Currently, mutable types are scalar elements (e.g. JuMP expression,
# MOI functions or polynomials) so broadcasting is the right dispatch.
# If this causes issues in the future, e.g., because a user define a non-scalar
# subtype of `AbstractMutable`, we might want to check that
# `ndims` is zero and error otherwise.

Base.:*(α::AbstractMutable, A::AbstractArray) = α .* A

Base.:*(A::AbstractArray, α::AbstractMutable) = A .* α

function operate_to!(
    output::AbstractArray,
    ::typeof(*),
    v::AbstractArray,
    α::Union{Number,AbstractMutable},
)
    return Base.broadcast!(*, output, v, α)
end

function operate_to!(
    output::AbstractArray,
    ::typeof(*),
    α::Union{Number,AbstractMutable},
    v::AbstractArray,
)
    return Base.broadcast!(*, output, α, v)
end

# Needed for Julia v1.0, otherwise, `broadcast(*, α, A)` gives a `Array` and
# not a `Symmetric`.

function _mult_triangle(
    ::Type{T},
    x,
    A::T,
) where {T<:Union{LinearAlgebra.Symmetric,LinearAlgebra.Hermitian}}
    c = LinearAlgebra.sym_uplo(A.uplo)
    B = if c == :U
        parent(x * LinearAlgebra.UpperTriangular(parent(A)))
    else
        parent(x * LinearAlgebra.LowerTriangular(parent(A)))
    end
    # Intermediate conversion to `Matrix` is needed to work around
    # https://github.com/JuliaLang/julia/issues/52895
    return T(Matrix(T(B, c)), c)
end

function Base.:*(α::Number, A::LinearAlgebra.Symmetric{<:AbstractMutable})
    return _mult_triangle(LinearAlgebra.Symmetric, α, A)
end

Base.:*(A::LinearAlgebra.Symmetric{<:AbstractMutable}, α::Number) = α * A

function Base.:*(
    α::AbstractMutable,
    A::LinearAlgebra.Symmetric{<:AbstractMutable},
)
    return _mult_triangle(LinearAlgebra.Symmetric, α, A)
end

function Base.:*(
    A::LinearAlgebra.Symmetric{<:AbstractMutable},
    α::AbstractMutable,
)
    return α * A
end

function Base.:*(α::AbstractMutable, A::LinearAlgebra.Symmetric)
    return _mult_triangle(LinearAlgebra.Symmetric, α, A)
end

Base.:*(A::LinearAlgebra.Symmetric, α::AbstractMutable) = α * A

function Base.:*(α::Real, A::LinearAlgebra.Hermitian{<:AbstractMutable})
    return _mult_triangle(LinearAlgebra.Hermitian, α, A)
end

function Base.:*(A::LinearAlgebra.Hermitian{<:AbstractMutable}, α::Real)
    return α * A
end

# These three have specific methods that just redirect to `Matrix{T}` which
# does not work, e.g. if `zero(T)` has a different type than `T`.

function Base.Matrix(x::LinearAlgebra.Tridiagonal{T}) where {T<:AbstractMutable}
    return Matrix{promote_type(promote_operation(zero, T), T)}(x)
end

function Base.Matrix(
    x::LinearAlgebra.UpperTriangular{T},
) where {T<:AbstractMutable}
    return Matrix{promote_type(promote_operation(zero, T), T)}(x)
end

function Base.Matrix(
    x::LinearAlgebra.LowerTriangular{T},
) where {T<:AbstractMutable}
    return Matrix{promote_type(promote_operation(zero, T), T)}(x)
end

# Needed for Julia v1.1 only. If `parent(A)` is for instance `Diagonal`, the
# `eltype` of `B` might be different form the `eltype` of `A`.
function Base.Matrix(A::LinearAlgebra.Symmetric{<:AbstractMutable})
    B = LinearAlgebra.copytri!(convert(Matrix, copy(A.data)), A.uplo)
    for i in axes(A, 1)
        # `B[i, i]` is used instead of `A[i, i]` on Julia v1.1 hence the need
        # to overwrite it for `AbstractMutable`.
        B[i, i] = LinearAlgebra.symmetric(
            A[i, i],
            LinearAlgebra.sym_uplo(A.uplo),
        )::LinearAlgebra.symmetric_type(eltype(A.data))
    end
    return B
end

function Base.Matrix(A::LinearAlgebra.Hermitian{<:AbstractMutable})
    B = LinearAlgebra.copytri!(convert(Matrix, copy(A.data)), A.uplo, true)
    for i in axes(A, 1)
        # `B[i, i]` is used instead of `A[i, i]` on Julia v1.1 hence the need
        # to overwrite it for `AbstractMutable`.
        B[i, i] = LinearAlgebra.hermitian(
            A[i, i],
            LinearAlgebra.sym_uplo(A.uplo),
        )::LinearAlgebra.hermitian_type(eltype(A.data))
    end
    return B
end

# Called in `getindex` of `LinearAlgebra.LowerTriangular` and
# `LinearAlgebra.UpperTriangular` as the elements may be `Array` for which
# `zero` is only defined for instances but not for the type. For
# `AbstractMutable` we assume that `zero` for the instance is the same than for
# the type by default.
Base.zero(x::AbstractMutable) = zero(typeof(x))

# `AbstractMutable` objects are more likely to implement `iszero` than `==`
# with `Int`.
LinearAlgebra.iszerodefined(::Type{<:AbstractMutable}) = true

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

module TestHygiene

module M

using Test

# Import it as a different name so that we test whether MutableArithmetics is
# needed in the current scope.
import MutableArithmetics as NewSymbolMA

@test !@isdefined(MA)

@test !@isdefined(MutableArithmetics)

macro _rewrite(expr)
    variable, code = NewSymbolMA.rewrite(expr)
    return quote
        $code
        $variable
    end
end

# Don't include this in `@test` to make sure it is in global scope
x = NewSymbolMA.@rewrite sum(i for i in 1:10)
@test x == 55
x = @_rewrite sum(i for i in 1:10)
@test x == 55

x = NewSymbolMA.@rewrite sum(i for i in 1:10 if isodd(i))
@test x == 25
x = @_rewrite sum(i for i in 1:10 if isodd(i))
@test x == 25

x = NewSymbolMA.@rewrite sum(i * j for i in 1:4 for j in 1:4 if i == j)
@test x == 30
x = @_rewrite sum(i * j for i in 1:4 for j in 1:4 if i == j)
@test x == 30

x = big(1)
y = NewSymbolMA.@rewrite(x + (x + 1)^1)
@test y == 3

end  # M

# Test the scoping outside the module. See also the note in runtests.jl.

using Test

@testset "test_scoping" begin
    @test M.@_rewrite(1 + (1 + 1)^1) == 3
end

end  # TestHygiene

function sum(x)
    acc = zero(eltype(x))
    for el in x
        acc = add!!(acc, el)
    end
    return acc
end
add!!(a, b) = a + b # default fallback
add!!(a::BigInt, b::BigInt) = Base.GMP.MPZ.add!(a, b)
function add!!(s::Sum, t::Term)
    push!(s.terms, t)
    return s
end

# Copyright (c) 2019 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

function allocation_test(
    op,
    T,
    short,
    short_to,
    n;
    a = T(2),
    b = T(3),
    c = T(4),
)
    @test MA.promote_operation(op, T, T) == T
    alloc_test(() -> MA.promote_operation(op, T, T), 0)
    if op != div && op != -
        @test MA.promote_operation(op, T, T, T) == T
        alloc_test(() -> MA.promote_operation(op, T, T, T), 0)
    end
    g = op(a, b)
    @test c === short_to(c, a, b)
    @test g == c
    A = MA.copy_if_mutable(a)
    @test A === short(A, b)
    @test g == A
    alloc_test_le(() -> short(A, b), n)
    alloc_test_le(() -> short_to(c, a, b), n)
    @test g == MA.buffered_operate!(nothing, op, MA.copy_if_mutable(a), b)
    @test g == MA.buffered_operate_to!(nothing, c, op, a, b)
    buffer = MA.buffer_for(op, typeof(a), typeof(b))
    @test g == MA.buffered_operate_to!(buffer, c, op, a, b)
    alloc_test(() -> MA.buffered_operate_to!(buffer, c, op, a, b), 0)
    return
end

function add_sub_mul_test(op, T; a = T(2), b = T(3), c = T(4))
    g = op(a, b, c)
    @test g == MA.buffered_operate!(nothing, op, MA.copy_if_mutable(a), b, c)
    buffer = MA.buffer_for(op, typeof(a), typeof(b), typeof(c))
    return alloc_test(() -> MA.buffered_operate!(buffer, op, a, b, c), 0)
end
@testset "$T" for T in [BigInt, BigFloat, Rational{BigInt}]
    MA.Test.int_test(T)
    @testset "Allocation" begin
        MAX_ALLOC = T <: Rational ? 280 : 0
        allocation_test(+, T, MA.add!!, MA.add_to!!, MAX_ALLOC)
        allocation_test(-, T, MA.sub!!, MA.sub_to!!, MAX_ALLOC)
        allocation_test(*, T, MA.mul!!, MA.mul_to!!, MAX_ALLOC)
        add_sub_mul_test(MA.add_mul, T)
        add_sub_mul_test(MA.sub_mul, T)
        if T <: Rational # https://github.com/jump-dev/MutableArithmetics.jl/issues/167
            allocation_test(
                +,
                T,
                MA.add!!,
                MA.add_to!!,
                MAX_ALLOC,
                a = T(1 // 2),
                b = T(3 // 2),
                c = T(5 // 2),
            )
            allocation_test(
                -,
                T,
                MA.sub!!,
                MA.sub_to!!,
                MAX_ALLOC,
                a = T(1 // 2),
                b = T(3 // 2),
                c = T(5 // 2),
            )
        end
        # Requires https://github.com/JuliaLang/julia/commit/3f92832df042198b2daefc1f7ca609db38cb8173
        # for `gcd` to be defined on `Rational`.
        if T == BigInt
            allocation_test(div, T, MA.div!!, MA.div_to!!, 0)
        end
        if T == BigInt || T == Rational{BigInt}
            allocation_test(gcd, T, MA.gcd!!, MA.gcd_to!!, 0)
            allocation_test(lcm, T, MA.lcm!!, MA.lcm_to!!, 0)
        end
    end
end

# Copyright (c) 2023 MutableArithmetics.jl contributors
#
# This Source Code Form is subject to the terms of the Mozilla Public License,
# v.2.0. If a copy of the MPL was not distributed with this file, You can obtain
# one at http://mozilla.org/MPL/2.0/.

@testset "copy: $T" for T in (
    Float64,
    BigFloat,
    Int,
    BigInt,
    Rational{Int},
    Rational{BigInt},
)
    @test MA.operate!!(copy, T(2)) == 2
    @test MA.operate_to!!(T(3), copy, T(2)) == 2
    if MA.mutability(T, copy, T) == MA.IsMutable()
        @testset "mutable" begin
            @testset "correctness" begin
                x = T(2)
                y = T(3)
                @test MA.operate!(copy, x) === x == 2
                @test MA.operate_to!(y, copy, x) === y == 2
            end
            @testset "alloc" begin
                f = let x = T(2)
                    () -> MA.operate!(copy, x)
                end
                g = let x = T(2), y = T(3)
                    () -> MA.operate_to!(y, copy, x)
                end
                alloc_test(f, 0)
                alloc_test(g, 0)
            end
        end
    end
end
